// @generated by Peggy 4.0.3.
//
// https://peggyjs.org/

"use strict";


function peg$subclass(child, parent) {
  function C() { this.constructor = child; }
  C.prototype = parent.prototype;
  child.prototype = new C();
}

function peg$SyntaxError(message, expected, found, location) {
  var self = Error.call(this, message);
  // istanbul ignore next Check is a necessary evil to support older environments
  if (Object.setPrototypeOf) {
    Object.setPrototypeOf(self, peg$SyntaxError.prototype);
  }
  self.expected = expected;
  self.found = found;
  self.location = location;
  self.name = "SyntaxError";
  return self;
}

peg$subclass(peg$SyntaxError, Error);

function peg$padEnd(str, targetLength, padString) {
  padString = padString || " ";
  if (str.length > targetLength) { return str; }
  targetLength -= str.length;
  padString += padString.repeat(targetLength);
  return str + padString.slice(0, targetLength);
}

peg$SyntaxError.prototype.format = function(sources) {
  var str = "Error: " + this.message;
  if (this.location) {
    var src = null;
    var k;
    for (k = 0; k < sources.length; k++) {
      if (sources[k].source === this.location.source) {
        src = sources[k].text.split(/\r\n|\n|\r/g);
        break;
      }
    }
    var s = this.location.start;
    var offset_s = (this.location.source && (typeof this.location.source.offset === "function"))
      ? this.location.source.offset(s)
      : s;
    var loc = this.location.source + ":" + offset_s.line + ":" + offset_s.column;
    if (src) {
      var e = this.location.end;
      var filler = peg$padEnd("", offset_s.line.toString().length, ' ');
      var line = src[s.line - 1];
      var last = s.line === e.line ? e.column : line.length + 1;
      var hatLen = (last - s.column) || 1;
      str += "\n --> " + loc + "\n"
          + filler + " |\n"
          + offset_s.line + " | " + line + "\n"
          + filler + " | " + peg$padEnd("", s.column - 1, ' ')
          + peg$padEnd("", hatLen, "^");
    } else {
      str += "\n at " + loc;
    }
  }
  return str;
};

peg$SyntaxError.buildMessage = function(expected, found) {
  var DESCRIBE_EXPECTATION_FNS = {
    literal: function(expectation) {
      return "\"" + literalEscape(expectation.text) + "\"";
    },

    class: function(expectation) {
      var escapedParts = expectation.parts.map(function(part) {
        return Array.isArray(part)
          ? classEscape(part[0]) + "-" + classEscape(part[1])
          : classEscape(part);
      });

      return "[" + (expectation.inverted ? "^" : "") + escapedParts.join("") + "]";
    },

    any: function() {
      return "any character";
    },

    end: function() {
      return "end of input";
    },

    other: function(expectation) {
      return expectation.description;
    }
  };

  function hex(ch) {
    return ch.charCodeAt(0).toString(16).toUpperCase();
  }

  function literalEscape(s) {
    return s
      .replace(/\\/g, "\\\\")
      .replace(/"/g,  "\\\"")
      .replace(/\0/g, "\\0")
      .replace(/\t/g, "\\t")
      .replace(/\n/g, "\\n")
      .replace(/\r/g, "\\r")
      .replace(/[\x00-\x0F]/g,          function(ch) { return "\\x0" + hex(ch); })
      .replace(/[\x10-\x1F\x7F-\x9F]/g, function(ch) { return "\\x"  + hex(ch); });
  }

  function classEscape(s) {
    return s
      .replace(/\\/g, "\\\\")
      .replace(/\]/g, "\\]")
      .replace(/\^/g, "\\^")
      .replace(/-/g,  "\\-")
      .replace(/\0/g, "\\0")
      .replace(/\t/g, "\\t")
      .replace(/\n/g, "\\n")
      .replace(/\r/g, "\\r")
      .replace(/[\x00-\x0F]/g,          function(ch) { return "\\x0" + hex(ch); })
      .replace(/[\x10-\x1F\x7F-\x9F]/g, function(ch) { return "\\x"  + hex(ch); });
  }

  function describeExpectation(expectation) {
    return DESCRIBE_EXPECTATION_FNS[expectation.type](expectation);
  }

  function describeExpected(expected) {
    var descriptions = expected.map(describeExpectation);
    var i, j;

    descriptions.sort();

    if (descriptions.length > 0) {
      for (i = 1, j = 1; i < descriptions.length; i++) {
        if (descriptions[i - 1] !== descriptions[i]) {
          descriptions[j] = descriptions[i];
          j++;
        }
      }
      descriptions.length = j;
    }

    switch (descriptions.length) {
      case 1:
        return descriptions[0];

      case 2:
        return descriptions[0] + " or " + descriptions[1];

      default:
        return descriptions.slice(0, -1).join(", ")
          + ", or "
          + descriptions[descriptions.length - 1];
    }
  }

  function describeFound(found) {
    return found ? "\"" + literalEscape(found) + "\"" : "end of input";
  }

  return "Expected " + describeExpected(expected) + " but " + describeFound(found) + " found.";
};

function peg$parse(input, options) {
  options = options !== undefined ? options : {};

  var peg$FAILED = {};
  var peg$source = options.grammarSource;

  var peg$startRuleFunctions = { start: peg$parsestart };
  var peg$startRuleFunction = peg$parsestart;

  var peg$c0 = "column_value";
  var peg$c1 = "opaque_format_spec";
  var peg$c2 = "sha2_512";
  var peg$c3 = "v1";
  var peg$c4 = "(";
  var peg$c5 = ")";
  var peg$c6 = "byte";
  var peg$c7 = "char";
  var peg$c8 = "nchar";
  var peg$c9 = "nvarchar2";
  var peg$c10 = "varchar2";
  var peg$c11 = "binary_float";
  var peg$c12 = "binary_double";
  var peg$c13 = "float";
  var peg$c14 = "number";
  var peg$c15 = ",";
  var peg$c16 = "long raw";
  var peg$c17 = "long";
  var peg$c18 = "raw";
  var peg$c19 = "blob";
  var peg$c20 = "clob";
  var peg$c21 = "nclob";
  var peg$c22 = "bfile";
  var peg$c23 = "rowid";
  var peg$c24 = "urowid";
  var peg$c25 = "date";
  var peg$c26 = "timestamp";
  var peg$c27 = "with";
  var peg$c28 = "local";
  var peg$c29 = "time";
  var peg$c30 = "zone";
  var peg$c31 = "interval";
  var peg$c32 = "year";
  var peg$c33 = "to";
  var peg$c34 = "month";
  var peg$c35 = "day";
  var peg$c36 = "second";
  var peg$c37 = "sdo_geometry";
  var peg$c38 = "sdo_topo_geometry";
  var peg$c39 = "SDO_GeoRaster";
  var peg$c40 = "xmltype";
  var peg$c41 = "uritype";
  var peg$c42 = "sys.anydataset";
  var peg$c43 = "sys.anydata";
  var peg$c44 = "sys.anytype";
  var peg$c45 = "=";
  var peg$c46 = ".";
  var peg$c47 = ";";
  var peg$c48 = "'";
  var peg$c49 = ":";
  var peg$c50 = "create";
  var peg$c51 = "table";
  var peg$c52 = "global";
  var peg$c53 = "private";
  var peg$c54 = "temporary";
  var peg$c55 = "shared";
  var peg$c56 = "duplicated";
  var peg$c57 = "immutable";
  var peg$c58 = "blockchain";
  var peg$c59 = "sharing";
  var peg$c60 = "metadata";
  var peg$c61 = "data";
  var peg$c62 = "extended";
  var peg$c63 = "none";
  var peg$c64 = "memoptimize";
  var peg$c65 = "for";
  var peg$c66 = "read";
  var peg$c67 = "write";
  var peg$c68 = "parent";
  var peg$c69 = "no";
  var peg$c70 = "on";
  var peg$c71 = "not";
  var peg$c72 = "into";
  var peg$c73 = "drop";
  var peg$c74 = "delete";
  var peg$c75 = "until";
  var peg$c76 = "days";
  var peg$c77 = "idle";
  var peg$c78 = "locked";
  var peg$c79 = "after";
  var peg$c80 = "insert";
  var peg$c81 = "hashing";
  var peg$c82 = "using";
  var peg$c83 = "version";
  var peg$c84 = "default";
  var peg$c85 = "collation";
  var peg$c86 = "collate";
  var peg$c87 = "commit";
  var peg$c88 = "preserve";
  var peg$c89 = "definition";
  var peg$c90 = "rows";
  var peg$c91 = "sort";
  var peg$c92 = "visible";
  var peg$c93 = "invisible";
  var peg$c94 = "null";
  var peg$c95 = "generated";
  var peg$c96 = "always";
  var peg$c97 = "by";
  var peg$c98 = "as";
  var peg$c99 = "is";
  var peg$c100 = "of";
  var peg$c101 = "identity";
  var peg$c102 = "start";
  var peg$c103 = "salt";
  var peg$c104 = "limit";
  var peg$c105 = "value";
  var peg$c106 = "increment";
  var peg$c107 = "maxvalue";
  var peg$c108 = "nomaxvalue";
  var peg$c109 = "minvalue";
  var peg$c110 = "nominvalue";
  var peg$c111 = "cycle";
  var peg$c112 = "nocycle";
  var peg$c113 = "cache";
  var peg$c114 = "nocache";
  var peg$c115 = "order";
  var peg$c116 = "noorder";
  var peg$c117 = "encrypt";
  var peg$c118 = "identified";
  var peg$c119 = "constraint";
  var peg$c120 = "unique";
  var peg$c121 = "primary";
  var peg$c122 = "key";
  var peg$c123 = "check";
  var peg$c124 = "references";
  var peg$c125 = "cascade";
  var peg$c126 = "set";
  var peg$c127 = "ref";
  var peg$c128 = "rely";
  var peg$c129 = "norely";
  var peg$c130 = "deferrable";
  var peg$c131 = "deferred";
  var peg$c132 = "initially";
  var peg$c133 = "immediate";
  var peg$c134 = "enable";
  var peg$c135 = "disable";
  var peg$c136 = "validate";
  var peg$c137 = "novalidate";
  var peg$c138 = "exceptions";
  var peg$c139 = "scope";
  var peg$c140 = "foreign";
  var peg$c141 = "segment";
  var peg$c142 = "creation";
  var peg$c143 = "tablespace";
  var peg$c144 = "logging";
  var peg$c145 = "nologging";
  var peg$c146 = "filesystem_like_logging";
  var peg$c147 = "pctfree";
  var peg$c148 = "pctused";
  var peg$c149 = "initrans";
  var peg$c150 = "storage";
  var peg$c151 = "initial";
  var peg$c152 = "next";
  var peg$c153 = "minextents";
  var peg$c154 = "maxextents";
  var peg$c155 = "unlimited";
  var peg$c156 = "maxsize";
  var peg$c157 = "keep";
  var peg$c158 = "recycle";
  var peg$c159 = "optimal";
  var peg$c160 = "pctincrease";
  var peg$c161 = "freelists";
  var peg$c162 = "freelist";
  var peg$c163 = "groups";
  var peg$c164 = "buffer_pool";
  var peg$c165 = "flash_cache";
  var peg$c166 = "cell_flash_cache";
  var peg$c167 = "compress";
  var peg$c168 = "row";
  var peg$c169 = "store";
  var peg$c170 = "basic";
  var peg$c171 = "advanced";
  var peg$c172 = "column";
  var peg$c173 = "query";
  var peg$c174 = "archive";
  var peg$c175 = "low";
  var peg$c176 = "high";
  var peg$c177 = "row level locking";
  var peg$c178 = "nocompress";
  var peg$c179 = "level";
  var peg$c180 = "locking";
  var peg$c181 = "inmemory";
  var peg$c182 = "memcompress";
  var peg$c183 = "dml";
  var peg$c184 = "capacity";
  var peg$c185 = "auto";
  var peg$c186 = "priority";
  var peg$c187 = "medium";
  var peg$c188 = "critical";
  var peg$c189 = "distribute";
  var peg$c190 = "range";
  var peg$c191 = "partition";
  var peg$c192 = "subpartition";
  var peg$c193 = "service";
  var peg$c194 = "all";
  var peg$c195 = "duplicate";
  var peg$c196 = "spatial";
  var peg$c197 = "ilm";
  var peg$c198 = "add";
  var peg$c199 = "policy";
  var peg$c200 = "disable_all";
  var peg$c201 = "delete_all";
  var peg$c202 = "enable_all";
  var peg$c203 = "group";
  var peg$c204 = "access";
  var peg$c205 = "modification";
  var peg$c206 = "months";
  var peg$c207 = "years";
  var peg$c208 = "tier";
  var peg$c209 = "only";
  var peg$c210 = "modify";
  var peg$c211 = "cluster";
  var peg$c212 = "index";
  var peg$c213 = "external";
  var peg$c214 = "reject";
  var peg$c215 = "attributes";
  var peg$c216 = "type";
  var peg$c217 = "directory";
  var peg$c218 = "location";
  var peg$c219 = "heap";
  var peg$c220 = "parameters";
  var peg$c221 = "organization";
  var peg$c222 = "mapping";
  var peg$c223 = "nomapping";
  var peg$c224 = "pctthreshold";
  var peg$c225 = "including";
  var peg$c226 = "overflow";
  var peg$c227 = "period";
  var peg$c228 = "supplemental";
  var peg$c229 = "log";
  var peg$c230 = "columns";
  var peg$c231 = "substitutable";
  var peg$c232 = "element";
  var peg$c233 = "levels";
  var peg$c234 = "at";
  var peg$c235 = "nested";
  var peg$c236 = "return";
  var peg$c237 = "locator";
  var peg$c238 = "retention";
  var peg$c239 = "chunk";
  var peg$c240 = "pctversion";
  var peg$c241 = "freepools";
  var peg$c242 = "varray";
  var peg$c243 = "securefile";
  var peg$c244 = "basicfile";
  var peg$c245 = "lob";
  var peg$c246 = "in";
  var peg$c247 = "decrypt";
  var peg$c248 = "reads";
  var peg$c249 = "deduplicate";
  var peg$c250 = "keep_duplicates";
  var peg$c251 = "max";
  var peg$c252 = "min";
  var peg$c253 = "off";
  var peg$c254 = "indexing";
  var peg$c255 = "varying";
  var peg$c256 = "varchar";
  var peg$c257 = "character";
  var peg$c258 = "national";
  var peg$c259 = "int";
  var peg$c260 = "integer";
  var peg$c261 = "smallint";
  var peg$c262 = "real";
  var peg$c263 = "numeric";
  var peg$c264 = "decimal";
  var peg$c265 = "dec";
  var peg$c266 = "double";
  var peg$c267 = "precision";
  var peg$c268 = "json";

  var peg$r0 = /^[EGKMPT]/;
  var peg$r1 = /^[0-9]/;
  var peg$r2 = /^[^']/;
  var peg$r3 = /^[a-zA-Z_]/;
  var peg$r4 = /^[a-zA-Z0-9_]/;
  var peg$r5 = /^[ \t\n\r]/;

  var peg$e0 = peg$literalExpectation("COLUMN_VALUE", true);
  var peg$e1 = peg$literalExpectation("opaque_format_spec", false);
  var peg$e2 = peg$classExpectation(["E", "G", "K", "M", "P", "T"], false, false);
  var peg$e3 = peg$literalExpectation("sha2_512", false);
  var peg$e4 = peg$literalExpectation("v1", false);
  var peg$e5 = peg$literalExpectation("(", false);
  var peg$e6 = peg$literalExpectation(")", false);
  var peg$e7 = peg$literalExpectation("byte", true);
  var peg$e8 = peg$literalExpectation("char", true);
  var peg$e9 = peg$literalExpectation("nchar", true);
  var peg$e10 = peg$literalExpectation("nvarchar2", true);
  var peg$e11 = peg$literalExpectation("varchar2", true);
  var peg$e12 = peg$literalExpectation("binary_float", true);
  var peg$e13 = peg$literalExpectation("binary_double", true);
  var peg$e14 = peg$literalExpectation("float", true);
  var peg$e15 = peg$literalExpectation("number", true);
  var peg$e16 = peg$literalExpectation(",", false);
  var peg$e17 = peg$literalExpectation("long raw", true);
  var peg$e18 = peg$literalExpectation("long", true);
  var peg$e19 = peg$literalExpectation("raw", true);
  var peg$e20 = peg$literalExpectation("blob", true);
  var peg$e21 = peg$literalExpectation("clob", true);
  var peg$e22 = peg$literalExpectation("nclob", true);
  var peg$e23 = peg$literalExpectation("bfile", true);
  var peg$e24 = peg$literalExpectation("rowid", true);
  var peg$e25 = peg$literalExpectation("urowid", true);
  var peg$e26 = peg$literalExpectation("date", true);
  var peg$e27 = peg$literalExpectation("timestamp", true);
  var peg$e28 = peg$literalExpectation("with", true);
  var peg$e29 = peg$literalExpectation("local", true);
  var peg$e30 = peg$literalExpectation("time", true);
  var peg$e31 = peg$literalExpectation("zone", true);
  var peg$e32 = peg$literalExpectation("interval", true);
  var peg$e33 = peg$literalExpectation("year", true);
  var peg$e34 = peg$literalExpectation("to", false);
  var peg$e35 = peg$literalExpectation("month", true);
  var peg$e36 = peg$literalExpectation("day", true);
  var peg$e37 = peg$literalExpectation("second", true);
  var peg$e38 = peg$literalExpectation("SDO_Geometry", true);
  var peg$e39 = peg$literalExpectation("SDO_Topo_Geometry", true);
  var peg$e40 = peg$literalExpectation("SDO_GeoRaster", false);
  var peg$e41 = peg$literalExpectation("XMLType", true);
  var peg$e42 = peg$literalExpectation("URIType", true);
  var peg$e43 = peg$literalExpectation("sys.anydataset", true);
  var peg$e44 = peg$literalExpectation("sys.anydata", true);
  var peg$e45 = peg$literalExpectation("sys.anytype", true);
  var peg$e46 = peg$classExpectation([["0", "9"]], false, false);
  var peg$e47 = peg$classExpectation(["'"], true, false);
  var peg$e48 = peg$classExpectation([["a", "z"], ["A", "Z"], "_"], false, false);
  var peg$e49 = peg$classExpectation([["a", "z"], ["A", "Z"], ["0", "9"], "_"], false, false);
  var peg$e50 = peg$classExpectation([" ", "\t", "\n", "\r"], false, false);
  var peg$e51 = peg$literalExpectation("=", false);
  var peg$e52 = peg$literalExpectation(".", false);
  var peg$e53 = peg$literalExpectation(";", false);
  var peg$e54 = peg$literalExpectation("'", false);
  var peg$e55 = peg$literalExpectation(":", false);
  var peg$e56 = peg$literalExpectation("create", true);
  var peg$e57 = peg$literalExpectation("table", true);
  var peg$e58 = peg$literalExpectation("global", true);
  var peg$e59 = peg$literalExpectation("private", true);
  var peg$e60 = peg$literalExpectation("temporary", true);
  var peg$e61 = peg$literalExpectation("shared", true);
  var peg$e62 = peg$literalExpectation("duplicated", true);
  var peg$e63 = peg$literalExpectation("immutable", true);
  var peg$e64 = peg$literalExpectation("blockchain", true);
  var peg$e65 = peg$literalExpectation("sharing", true);
  var peg$e66 = peg$literalExpectation("metadata", true);
  var peg$e67 = peg$literalExpectation("data", true);
  var peg$e68 = peg$literalExpectation("extended", true);
  var peg$e69 = peg$literalExpectation("none", true);
  var peg$e70 = peg$literalExpectation("memoptimize", true);
  var peg$e71 = peg$literalExpectation("for", true);
  var peg$e72 = peg$literalExpectation("read", true);
  var peg$e73 = peg$literalExpectation("write", true);
  var peg$e74 = peg$literalExpectation("parent", true);
  var peg$e75 = peg$literalExpectation("no", true);
  var peg$e76 = peg$literalExpectation("on", true);
  var peg$e77 = peg$literalExpectation("not", true);
  var peg$e78 = peg$literalExpectation("into", true);
  var peg$e79 = peg$literalExpectation("drop", true);
  var peg$e80 = peg$literalExpectation("delete", true);
  var peg$e81 = peg$literalExpectation("until", true);
  var peg$e82 = peg$literalExpectation("days", true);
  var peg$e83 = peg$literalExpectation("idle", true);
  var peg$e84 = peg$literalExpectation("locked", true);
  var peg$e85 = peg$literalExpectation("after", true);
  var peg$e86 = peg$literalExpectation("insert", true);
  var peg$e87 = peg$literalExpectation("hashing", true);
  var peg$e88 = peg$literalExpectation("using", true);
  var peg$e89 = peg$literalExpectation("version", true);
  var peg$e90 = peg$literalExpectation("default", true);
  var peg$e91 = peg$literalExpectation("collation", true);
  var peg$e92 = peg$literalExpectation("collate", true);
  var peg$e93 = peg$literalExpectation("commit", true);
  var peg$e94 = peg$literalExpectation("preserve", true);
  var peg$e95 = peg$literalExpectation("definition", true);
  var peg$e96 = peg$literalExpectation("rows", true);
  var peg$e97 = peg$literalExpectation("sort", true);
  var peg$e98 = peg$literalExpectation("visible", true);
  var peg$e99 = peg$literalExpectation("invisible", true);
  var peg$e100 = peg$literalExpectation("null", true);
  var peg$e101 = peg$literalExpectation("generated", true);
  var peg$e102 = peg$literalExpectation("always", true);
  var peg$e103 = peg$literalExpectation("by", true);
  var peg$e104 = peg$literalExpectation("as", true);
  var peg$e105 = peg$literalExpectation("is", true);
  var peg$e106 = peg$literalExpectation("of", true);
  var peg$e107 = peg$literalExpectation("to", true);
  var peg$e108 = peg$literalExpectation("identity", true);
  var peg$e109 = peg$literalExpectation("start", true);
  var peg$e110 = peg$literalExpectation("salt", true);
  var peg$e111 = peg$literalExpectation("limit", true);
  var peg$e112 = peg$literalExpectation("value", true);
  var peg$e113 = peg$literalExpectation("increment", true);
  var peg$e114 = peg$literalExpectation("maxvalue", true);
  var peg$e115 = peg$literalExpectation("nomaxvalue", true);
  var peg$e116 = peg$literalExpectation("minvalue", true);
  var peg$e117 = peg$literalExpectation("nominvalue", true);
  var peg$e118 = peg$literalExpectation("cycle", true);
  var peg$e119 = peg$literalExpectation("nocycle", true);
  var peg$e120 = peg$literalExpectation("cache", true);
  var peg$e121 = peg$literalExpectation("nocache", true);
  var peg$e122 = peg$literalExpectation("order", true);
  var peg$e123 = peg$literalExpectation("noorder", true);
  var peg$e124 = peg$literalExpectation("encrypt", true);
  var peg$e125 = peg$literalExpectation("identified", true);
  var peg$e126 = peg$literalExpectation("constraint", true);
  var peg$e127 = peg$literalExpectation("unique", true);
  var peg$e128 = peg$literalExpectation("primary", true);
  var peg$e129 = peg$literalExpectation("key", true);
  var peg$e130 = peg$literalExpectation("check", true);
  var peg$e131 = peg$literalExpectation("references", true);
  var peg$e132 = peg$literalExpectation("cascade", true);
  var peg$e133 = peg$literalExpectation("set", true);
  var peg$e134 = peg$literalExpectation("ref", true);
  var peg$e135 = peg$literalExpectation("rely", true);
  var peg$e136 = peg$literalExpectation("norely", true);
  var peg$e137 = peg$literalExpectation("deferrable", true);
  var peg$e138 = peg$literalExpectation("deferred", true);
  var peg$e139 = peg$literalExpectation("initially", true);
  var peg$e140 = peg$literalExpectation("immediate", true);
  var peg$e141 = peg$literalExpectation("enable", true);
  var peg$e142 = peg$literalExpectation("disable", true);
  var peg$e143 = peg$literalExpectation("validate", true);
  var peg$e144 = peg$literalExpectation("novalidate", true);
  var peg$e145 = peg$literalExpectation("exceptions", true);
  var peg$e146 = peg$literalExpectation("scope", true);
  var peg$e147 = peg$literalExpectation("foreign", true);
  var peg$e148 = peg$literalExpectation("segment", true);
  var peg$e149 = peg$literalExpectation("creation", true);
  var peg$e150 = peg$literalExpectation("tablespace", true);
  var peg$e151 = peg$literalExpectation("logging", true);
  var peg$e152 = peg$literalExpectation("nologging", true);
  var peg$e153 = peg$literalExpectation("filesystem_like_logging", true);
  var peg$e154 = peg$literalExpectation("pctfree", true);
  var peg$e155 = peg$literalExpectation("pctused", true);
  var peg$e156 = peg$literalExpectation("initrans", true);
  var peg$e157 = peg$literalExpectation("storage", true);
  var peg$e158 = peg$literalExpectation("initial", true);
  var peg$e159 = peg$literalExpectation("next", true);
  var peg$e160 = peg$literalExpectation("minextents", true);
  var peg$e161 = peg$literalExpectation("maxextents", true);
  var peg$e162 = peg$literalExpectation("unlimited", true);
  var peg$e163 = peg$literalExpectation("maxsize", true);
  var peg$e164 = peg$literalExpectation("keep", true);
  var peg$e165 = peg$literalExpectation("recycle", true);
  var peg$e166 = peg$literalExpectation("optimal", true);
  var peg$e167 = peg$literalExpectation("pctincrease", true);
  var peg$e168 = peg$literalExpectation("freelists", true);
  var peg$e169 = peg$literalExpectation("freelist", true);
  var peg$e170 = peg$literalExpectation("groups", true);
  var peg$e171 = peg$literalExpectation("buffer_pool", true);
  var peg$e172 = peg$literalExpectation("flash_cache", true);
  var peg$e173 = peg$literalExpectation("cell_flash_cache", true);
  var peg$e174 = peg$literalExpectation("compress", true);
  var peg$e175 = peg$literalExpectation("row", true);
  var peg$e176 = peg$literalExpectation("store", true);
  var peg$e177 = peg$literalExpectation("basic", true);
  var peg$e178 = peg$literalExpectation("advanced", true);
  var peg$e179 = peg$literalExpectation("column", true);
  var peg$e180 = peg$literalExpectation("query", true);
  var peg$e181 = peg$literalExpectation("archive", true);
  var peg$e182 = peg$literalExpectation("low", true);
  var peg$e183 = peg$literalExpectation("high", true);
  var peg$e184 = peg$literalExpectation("row level locking", true);
  var peg$e185 = peg$literalExpectation("nocompress", true);
  var peg$e186 = peg$literalExpectation("level", true);
  var peg$e187 = peg$literalExpectation("locking", true);
  var peg$e188 = peg$literalExpectation("inmemory", true);
  var peg$e189 = peg$literalExpectation("memcompress", true);
  var peg$e190 = peg$literalExpectation("dml", true);
  var peg$e191 = peg$literalExpectation("capacity", true);
  var peg$e192 = peg$literalExpectation("auto", true);
  var peg$e193 = peg$literalExpectation("priority", true);
  var peg$e194 = peg$literalExpectation("medium", true);
  var peg$e195 = peg$literalExpectation("critical", true);
  var peg$e196 = peg$literalExpectation("distribute", true);
  var peg$e197 = peg$literalExpectation("range", true);
  var peg$e198 = peg$literalExpectation("partition", true);
  var peg$e199 = peg$literalExpectation("subpartition", true);
  var peg$e200 = peg$literalExpectation("service", true);
  var peg$e201 = peg$literalExpectation("all", true);
  var peg$e202 = peg$literalExpectation("duplicate", true);
  var peg$e203 = peg$literalExpectation("spatial", true);
  var peg$e204 = peg$literalExpectation("ilm", true);
  var peg$e205 = peg$literalExpectation("add", true);
  var peg$e206 = peg$literalExpectation("policy", true);
  var peg$e207 = peg$literalExpectation("disable_all", true);
  var peg$e208 = peg$literalExpectation("delete_all", true);
  var peg$e209 = peg$literalExpectation("enable_all", true);
  var peg$e210 = peg$literalExpectation("group", true);
  var peg$e211 = peg$literalExpectation("access", true);
  var peg$e212 = peg$literalExpectation("modification", true);
  var peg$e213 = peg$literalExpectation("months", true);
  var peg$e214 = peg$literalExpectation("years", true);
  var peg$e215 = peg$literalExpectation("tier", true);
  var peg$e216 = peg$literalExpectation("only", true);
  var peg$e217 = peg$literalExpectation("modify", true);
  var peg$e218 = peg$literalExpectation("cluster", true);
  var peg$e219 = peg$literalExpectation("index", true);
  var peg$e220 = peg$literalExpectation("external", true);
  var peg$e221 = peg$literalExpectation("reject", true);
  var peg$e222 = peg$literalExpectation("attributes", true);
  var peg$e223 = peg$literalExpectation("type", true);
  var peg$e224 = peg$literalExpectation("directory", true);
  var peg$e225 = peg$literalExpectation("location", true);
  var peg$e226 = peg$literalExpectation("heap", true);
  var peg$e227 = peg$literalExpectation("parameters", true);
  var peg$e228 = peg$literalExpectation("organization", true);
  var peg$e229 = peg$literalExpectation("mapping", true);
  var peg$e230 = peg$literalExpectation("nomapping", true);
  var peg$e231 = peg$literalExpectation("pctthreshold", true);
  var peg$e232 = peg$literalExpectation("including", true);
  var peg$e233 = peg$literalExpectation("overflow", true);
  var peg$e234 = peg$literalExpectation("period", true);
  var peg$e235 = peg$literalExpectation("supplemental", true);
  var peg$e236 = peg$literalExpectation("log", true);
  var peg$e237 = peg$literalExpectation("columns", true);
  var peg$e238 = peg$literalExpectation("substitutable", true);
  var peg$e239 = peg$literalExpectation("element", true);
  var peg$e240 = peg$literalExpectation("levels", true);
  var peg$e241 = peg$literalExpectation("at", true);
  var peg$e242 = peg$literalExpectation("nested", true);
  var peg$e243 = peg$literalExpectation("return", true);
  var peg$e244 = peg$literalExpectation("locator", true);
  var peg$e245 = peg$literalExpectation("retention", true);
  var peg$e246 = peg$literalExpectation("chunk", true);
  var peg$e247 = peg$literalExpectation("pctversion", true);
  var peg$e248 = peg$literalExpectation("freepools", true);
  var peg$e249 = peg$literalExpectation("varray", true);
  var peg$e250 = peg$literalExpectation("securefile", true);
  var peg$e251 = peg$literalExpectation("basicfile", true);
  var peg$e252 = peg$literalExpectation("lob", true);
  var peg$e253 = peg$literalExpectation("in", true);
  var peg$e254 = peg$literalExpectation("decrypt", true);
  var peg$e255 = peg$literalExpectation("reads", true);
  var peg$e256 = peg$literalExpectation("deduplicate", true);
  var peg$e257 = peg$literalExpectation("keep_duplicates", true);
  var peg$e258 = peg$literalExpectation("max", true);
  var peg$e259 = peg$literalExpectation("min", true);
  var peg$e260 = peg$literalExpectation("off", true);
  var peg$e261 = peg$literalExpectation("indexing", true);
  var peg$e262 = peg$literalExpectation("varying", true);
  var peg$e263 = peg$literalExpectation("varchar", true);
  var peg$e264 = peg$literalExpectation("character", true);
  var peg$e265 = peg$literalExpectation("national", true);
  var peg$e266 = peg$literalExpectation("int", true);
  var peg$e267 = peg$literalExpectation("integer", true);
  var peg$e268 = peg$literalExpectation("smallint", true);
  var peg$e269 = peg$literalExpectation("real", true);
  var peg$e270 = peg$literalExpectation("numeric", true);
  var peg$e271 = peg$literalExpectation("decimal", true);
  var peg$e272 = peg$literalExpectation("dec", true);
  var peg$e273 = peg$literalExpectation("double", true);
  var peg$e274 = peg$literalExpectation("precision", true);
  var peg$e275 = peg$literalExpectation("json", true);

  var peg$f0 = function(operation, object, type, s) { return s; };
  var peg$f1 = function(operation, object, type, schema, name, sharing, table, memoptimize_for, parent) { 
        return {
            name,
            type,
            table,
            object, 
            parent,
            schema,
            sharing,
            operation, 
            memoptimize_for,
        }; 
      };
  var peg$f2 = function(scope, temporary) { return { scope, temporary }; };
  var peg$f3 = function(shared) { return { shared }; };
  var peg$f4 = function(duplicated) { return { duplicated }; };
  var peg$f5 = function(immutable, blockchain) { return { immutable, blockchain }; };
  var peg$f6 = function(immutable) { return { immutable }; };
  var peg$f7 = function(sharing, attribute) {
        return { 
            sharing, 
            attribute: Array.isArray(attribute) ? 
                       attribute.filter(e => typeof e === 'string').join(' ') : 
                       attribute 
        };
    };
  var peg$f8 = function(clauses) {
      let optimize = {};
      clauses.forEach(( [operation] ) => {
        if (operation === 'read') optimize.read = 'read';
        if (operation === 'write') optimize.write = 'write';
      });
      return (optimize.read || optimize.write) ? optimize : null;
    };
  var peg$f9 = function(operation) {
      return operation;
    };
  var peg$f10 = function(s) { return s; };
  var peg$f11 = function(schema, table) {
        return { schema, table };
    };
  var peg$f12 = function(c) { return c; };
  var peg$f13 = function(relational_properties, blockchain_clauses, immutable_clauses, name) { return { name }; };
  var peg$f14 = function(relational_properties, blockchain_clauses, immutable_clauses, collation, operation) { return { operation }; };
  var peg$f15 = function(relational_properties, blockchain_clauses, immutable_clauses, collation, on_commit_definition, operation) { return { operation }; };
  var peg$f16 = function(relational_properties, blockchain_clauses, immutable_clauses, collation, on_commit_definition, on_commit_rows, physical_properties, table_properties) { 
        return { 
            collation,
            on_commit_rows,
            table_properties,
            immutable_clauses,
            blockchain_clauses,
            physical_properties,
            on_commit_definition,
            relational_properties,
         };
      };
  var peg$f17 = function(column_properties, read_only, indexing) {
        return {
            indexing,
            read_only,
            column_properties,
        }
    };
  var peg$f18 = function() { return 'read only'; };
  var peg$f19 = function() { return 'read write'; };
  var peg$f20 = function(mode) {
        return mode;
    };
  var peg$f21 = function(x) { return x; };
  var peg$f22 = function(xs) {
      return xs;
    };
  var peg$f23 = function(v, x, xs) { 
        return [x, ...xs]; 
      };
  var peg$f24 = function(v, p) { 
        return {...v, lob_partition: p }; 
      };
  var peg$f25 = function(l, x, xs) { 
        return [x, ...xs]; 
      };
  var peg$f26 = function(l, p) { 
        return {...l, lob_partition: p }; 
      };
  var peg$f27 = function(partition, x) { return x; };
  var peg$f28 = function(partition, options, name, x) { return x; };
  var peg$f29 = function(partition, options, name, opts) {
            return { name, options: opts };
        };
  var peg$f30 = function(partition, options, subpartition) {
        return { partition, options, subpartition };
      };
  var peg$f31 = function(lob, item, filetype, tablespace_set) { return { tablespace_set }; };
  var peg$f32 = function(lob, item, filetype, tablespace) { return { tablespace }; };
  var peg$f33 = function(lob, item, filetype, segname, tablespace_set) { return { tablespace_set }; };
  var peg$f34 = function(lob, item, filetype, segname, tablespace) { return { tablespace }; };
  var peg$f35 = function(lob, item, filetype, segname, tablespace) {
            return { segname, ...tablespace };
          };
  var peg$f36 = function(lob, item, filetype, rest) {
        return { lob, item, filetype, ...rest };
      };
  var peg$f37 = function(lob, items, x) { return x; };
  var peg$f38 = function(lob, items, store_as) { 
            return { items, store_as };
          };
  var peg$f39 = function(lob, item, x) { return x; };
  var peg$f40 = function(lob, item, store_as) { 
            return { item, store_as };
          };
  var peg$f41 = function(lob, rest) {
        return { lob, ...rest };
      };
  var peg$f42 = function(basicfile) { return { basicfile }; };
  var peg$f43 = function(securefile) { return { securefile }; };
  var peg$f44 = function(lob_segname) { return { lob_segname }; };
  var peg$f45 = function(lob_storage_params) { return { lob_storage_params }; };
  var peg$f46 = function(x) {
            return x;
        };
  var peg$f47 = function(xs) {
        return xs;
    };
  var peg$f48 = function(basicfile) { return { basicfile }; };
  var peg$f49 = function(securefile) { return { securefile }; };
  var peg$f50 = function(lob_storage_params) { return { lob_storage_params }; };
  var peg$f51 = function(x) {
            return x;
        };
  var peg$f52 = function(xs) {
        return xs;
    };
  var peg$f53 = function(varray, varray_item, substitutable_column) { return { substitutable_column }; };
  var peg$f54 = function(varray, varray_item, substitutable_column, varray_storage) { 
            return { substitutable_column, varray_storage }; 
        };
  var peg$f55 = function(varray, varray_item, rest) {
        return { varray, varray_item, ...rest };
      };
  var peg$f56 = function(store_as, segname) { return { segname }; };
  var peg$f57 = function(store_as, segname, storage_params) { 
                return { segname, storage_params }; 
            };
  var peg$f58 = function(store_as, opts) {
            return { ...opts };
        };
  var peg$f59 = function(store_as, lob) {
        return { store_as, lob };
      };
  var peg$f60 = function(lob_parameters, storage) { return { lob_parameters, storage }; };
  var peg$f61 = function(tablespace_set) { return { tablespace_set }; };
  var peg$f62 = function(tablespace) { return { tablespace }; };
  var peg$f63 = function(param) {
            return param;
        };
  var peg$f64 = function(params) {
        return params;
      };
  var peg$f65 = function(x) { return x; };
  var peg$f66 = function(xs) { return xs; };
  var peg$f67 = function(chunk) { return { chunk }; };
  var peg$f68 = function(pctversion) { return { pctversion }; };
  var peg$f69 = function(freepools) { return { freepools }; };
  var peg$f70 = function(enable) { 
        return { enable, storage_in_row: 'storage in row' };
      };
  var peg$f71 = function(encrypt, specs) { return { encrypt, specs }; };
  var peg$f72 = function(encrypt) { return { encrypt }; };
  var peg$f73 = function() { return 'cache reads'; };
  var peg$f74 = function(cache, logging) {
        return { cache, logging };
      };
  var peg$f75 = function(deduplicate) {
        return { deduplicate };
    };
  var peg$f76 = function(metric) { return { metric }; };
  var peg$f77 = function(metric, value) { return { metric, value }; };
  var peg$f78 = function(retention) {
        return { retention };
      };
  var peg$f79 = function(compression) { return { compress }; };
  var peg$f80 = function(compression, level) { return { compression, level }; };
  var peg$f81 = function(json, columns, lob_segname, params) {
        return { lob_segname, params };
      };
  var peg$f82 = function(json, columns, store_as) {
        return { json, columns, store_as };
      };
  var peg$f83 = function(x, p) { return p; };
  var peg$f84 = function(x, xs) {
        return [x, ...xs];
    };
  var peg$f85 = function(tablespace) { return { tablespace }; };
  var peg$f86 = function(storage) { return { storage }; };
  var peg$f87 = function(retention) { return { retention }; };
  var peg$f88 = function(chunck) { return { chunck }; };
  var peg$f89 = function(pctversion) { return { pctversion }; };
  var peg$f90 = function(freepools) { return { freepools }; };
  var peg$f91 = function(nested, item, substitutable_column, scope, storage_table, properties) {
            return { storage_table, properties };
        };
  var peg$f92 = function(nested, item, substitutable_column, scope, store_as, as, option) { return { as, option }; };
  var peg$f93 = function(nested, item, substitutable_column, scope, store_as, ret) {
        return {
            item,
            scope,
            nested,
            store_as,
            return: ret,
            substitutable_column,
        }
      };
  var peg$f94 = function(x) { return x; };
  var peg$f95 = function(xs) {
        return xs;
    };
  var peg$f96 = function(x) { return { ...x, property: 'object' }; };
  var peg$f97 = function(x) { return { ...x, property: 'physical' }; };
  var peg$f98 = function(x) { return { ...x, property: 'column' }; };
  var peg$f99 = function(column, e) { return e; };
  var peg$f100 = function(column, def, constraints) {
        return { column, default: def, constraints };
      };
  var peg$f101 = function(column, subsubstitutable_column) {
        return { column, subsubstitutable_column };
      };
  var peg$f102 = function(not, substitutable) {
        return { not, substitutable, at_all_levels: 'at all levels' };
      };
  var peg$f103 = function(element, type) {
        return { element, is_of_type: type };
      };
  var peg$f104 = function(deferred_segment_creation, segment_attributes, compression, inmemory_table, ilm) {
        return { 
            ilm,
            compression, 
            inmemory_table, 
            segment_attributes, 
            deferred_segment_creation, 
        };
      };
  var peg$f105 = function(deferred_segment_creation, external, partiton, attributes, external_table) { return 'reject limit'; };
  var peg$f106 = function(deferred_segment_creation, external, partiton, attributes, external_table, reject_limit) {
          return { external_partition: { reject_limit, external, partition, attributes, external_table } };
        };
  var peg$f107 = function(deferred_segment_creation, o) { return o; };
  var peg$f108 = function(deferred_segment_creation, organization) {
            return { organization };
        };
  var peg$f109 = function(deferred_segment_creation, rest) {
        return { deferred_segment_creation, ...rest }; 
      };
  var peg$f110 = function(option, external_table) { 
        return { option, external_table }; 
      };
  var peg$f111 = function(option, segment_attributes, heap_org) { 
        return { option, segment_attributes, heap_org }; 
      };
  var peg$f112 = function(option, segment_attributes, index_org) { 
        return { option, segment_attributes, index_org }; 
      };
  var peg$f113 = function(x) { return x; };
  var peg$f114 = function(options, overflow) {
        return { options, overflow };
      };
  var peg$f115 = function(column) { return column; };
  var peg$f116 = function(including, segment_attributes) {
        return { including, segment_attributes };
      };
  var peg$f117 = function(pctthreshold, value) { return { pctthreshold, value }; };
  var peg$f118 = function(compress, value) { return { compress, value }; };
  var peg$f119 = function(compress) { return { compress }; };
  var peg$f120 = function(mapping, table) { return { mapping, table }; };
  var peg$f121 = function(mapping) { return { mapping }; };
  var peg$f122 = function(table_compression, inmemory_table, ilm) {
        return { 
            ilm,
            inmemory_table,
            table_compression, 
        };
      };
  var peg$f123 = function(access_driver_type) {
        if(validAccessDrivers[access_driver_type.toUpperCase()] !== true) {
            throw new Error(`${access_driver_type} is not a valid access driver`);
        }
        return { access_driver_type }; 
      };
  var peg$f124 = function(type, data_props, opt) { return opt; };
  var peg$f125 = function(type, data_props, reject_limit, inmemory_table) {
        return { type, data_props, reject_limit, inmemory_table };
      };
  var peg$f126 = function(dir) { return dir; };
  var peg$f127 = function(default_directory, param) { return param; };
  var peg$f128 = function(default_directory, access_parameters, dirs) { return dirs; };
  var peg$f129 = function(default_directory, access_parameters, location) {
        return { default_directory, access_parameters, location };
      };
  var peg$f130 = function(x, e) { return e; };
  var peg$f131 = function(x, xs) {
        return [x, ...xs];
    };
  var peg$f132 = function(d) { return d; };
  var peg$f133 = function(directory, location_specifier) {
        return { directory, location_specifier };
    };
  var peg$f134 = function(spec) { return { spec }; };
  var peg$f135 = function(spec) { return { spec }; };
  var peg$f136 = function(clob, subquery) { return { using: clob, subquery }; };
  var peg$f137 = function(cluster, columns) {
        return { cluster, columns };
    };
  var peg$f138 = function(action, resource, policy) { return { action, resource, policy }; };
  var peg$f139 = function(action, policy_name) { return { action, policy_name }; };
  var peg$f140 = function(action) { return { action }; };
  var peg$f141 = function(body) { 
        return body; 
      };
  var peg$f142 = function(action, attributes) { return { action, attributes };};
  var peg$f143 = function(action, memcompress) { return { action, memcompress }; };
  var peg$f144 = function(action) { return { action }; };
  var peg$f145 = function(inmemory_action, target, on, function_name) { return { on, function_name }; };
  var peg$f146 = function(inmemory_action, target, after, period) { return 'no access'; };
  var peg$f147 = function(inmemory_action, target, after, period) { return 'no modification'; };
  var peg$f148 = function(inmemory_action, target, after, period, action) {
            return { after, period, action };
        };
  var peg$f149 = function(inmemory_action, target, when) {
        return { policy_type: 'inmemory', target, when, ...inmemory_action };
      };
  var peg$f150 = function(tablespace, target, on, function_name) { return { on, function_name }; };
  var peg$f151 = function(tablespace, target, after, period) { return 'no access'; };
  var peg$f152 = function(tablespace, target, after, period) { return 'no modification'; };
  var peg$f153 = function(tablespace, target, after, period, action) {
                return { after, period, action };
            };
  var peg$f154 = function(tablespace, target, when) {
            return { read_only: 'read only', target, when };
        };
  var peg$f155 = function(tablespace, target, on, function_name) { return { on, function_name }; };
  var peg$f156 = function(tablespace, target, when) {
            return { target, when };
        };
  var peg$f157 = function(tablespace, body) {
        return { tablespace, ...body, policy_type: 'tiering' };
      };
  var peg$f158 = function(compression, target, on, function_name) { return { on, function_name }; };
  var peg$f159 = function(compression, target, after, period) { return 'no access'; };
  var peg$f160 = function(compression, target, after, period) { return 'no modification'; };
  var peg$f161 = function(compression, target, after, period, action) {
            return { after, period, action };
        };
  var peg$f162 = function(compression, target, when) { 
        return { compression, target, when, policy_type: 'compression' }; 
      };
  var peg$f163 = function(store, level) { return { store, level }; };
  var peg$f164 = function(store) { return { store, for_query: 'for query' }; };
  var peg$f165 = function(compress, target, period) {
        return { compress, target, period, action: 'no modification', policy_type: 'compression' };
      };
  var peg$f166 = function(value, unit) {
        return { value, unit };
    };
  var peg$f167 = function(setting, attributes) { return { setting, attributes }; };
  var peg$f168 = function() { return { setting: 'no inmemory' }; };
  var peg$f169 = function(inmemory, column) {
        return { inmemory, column };
      };
  var peg$f170 = function(c) { return c; };
  var peg$f171 = function(x) { return x; };
  var peg$f172 = function(setting, memcompress) { return { setting, memcompress }; };
  var peg$f173 = function() { return { setting: 'no inmemory' }; };
  var peg$f174 = function(inmemory, columns) {
        return { inmemory, columns };
      };
  var peg$f175 = function(memcompress, priority, distribute, duplicate, spatial) {
        return { memcompress, priority, distribute, duplicate, spatial };
      };
  var peg$f176 = function(column) { return { column }; };
  var peg$f177 = function(all) { return `duplicate${ all ? ' all' : '' }`; };
  var peg$f178 = function() { return 'no duplicate'; };
  var peg$f179 = function() { return 'rowid range'; };
  var peg$f180 = function(x) { return `by ${x}`;};
  var peg$f181 = function(partition, x) { return x; };
  var peg$f182 = function(partition, for_service) {
        return { partition, for_service };
      };
  var peg$f183 = function(priority) {
        return priority;
    };
  var peg$f184 = function() { return { mode: 'no memcompress' }; };
  var peg$f185 = function() { return { mode: 'memcompress auto' }; };
  var peg$f186 = function(mode, target) { return { target }; };
  var peg$f187 = function(mode, target, level) { return { target, level }; };
  var peg$f188 = function(mode, compression_target) {
        return { mode, ...compression_target };
      };
  var peg$f189 = function(option) { return { option }; };
  var peg$f190 = function(store, option, level) { return { store, option, level }; };
  var peg$f191 = function(store, option, opt, level) { return { option: opt, level }; };
  var peg$f192 = function(store, option, target, no) { return no; };
  var peg$f193 = function(store, option, target, row_level_locking) { 
        return { store, option, for_query, row_level_locking };
      };
  var peg$f194 = function(s) { return s; };
  var peg$f195 = function(xs) {
        return xs;
    };
  var peg$f196 = function(name) { return { attribute: 'tablespace set', name }; };
  var peg$f197 = function(name) { return { attribute: 'tablespace', name }; };
  var peg$f198 = function(logging) { return { attribute: 'logging', logging }; };
  var peg$f199 = function(physical_attributes) { return { attribute: 'physical_attributes', physical_attributes }; };
  var peg$f200 = function(p) { return p; };
  var peg$f201 = function(xs) {
        return xs;
    };
  var peg$f202 = function(param, value) { return { param, value, attribute: 'param' }; };
  var peg$f203 = function(storage) { return { storage, attribute: 'storage' }; };
  var peg$f204 = function(o) { return o; };
  var peg$f205 = function(options) { 
        return { options }; 
    };
  var peg$f206 = function(initial, size) { return { initial, size }; };
  var peg$f207 = function(next, size) { return { next, size }; };
  var peg$f208 = function(pctincrease, value) { return { pctincrease, value }; };
  var peg$f209 = function(minextents, value) { return { minextents, value }; };
  var peg$f210 = function(maxextents, value) { return { minextents, value }; };
  var peg$f211 = function(encrypt) { return { encrypt }; };
  var peg$f212 = function(cache, option) { return { cache, option }; };
  var peg$f213 = function(buffer_pool, option) { return { buffer_pool, option }; };
  var peg$f214 = function(value) { return { freelist: 'freelist groups', value }; };
  var peg$f215 = function(value) { return { freelist: 'freelists', value }; };
  var peg$f216 = function(optimal, size) { return {optimal, size}; };
  var peg$f217 = function(maxsize, size) {
        return { maxsize, size };
    };
  var peg$f218 = function(value, byte) {
        return { value, byte };
    };
  var peg$f219 = function(x) { return x; };
  var peg$f220 = function(no_drop_clause, no_delete_clause) {
        return { no_drop_clause, no_delete_clause };
    };
  var peg$f221 = function(x) { return x; };
  var peg$f222 = function(until_days_idle) {
        return { no_drop: 'no drop', until_days_idle }
    };
  var peg$f223 = function(locked) { return { locked }; };
  var peg$f224 = function(x, locked) { 
            return { until_days_after_insert: x, locked }; 
        };
  var peg$f225 = function(l) {
        return { no_delete: 'no delete', ...l }
      };
  var peg$f226 = function(drop, row_retention, hash) {
        return { drop, row_retention, hash };
    };
  var peg$f227 = function(hashing) { 
        return { hashing, encrypt: 'sha2_512', version: 'v1' };
    };
  var peg$f228 = function(x, c) { return c; };
  var peg$f229 = function(x, xs) { 
        return [x, ...xs];
    };
  var peg$f230 = function(log_group_prop) { return { log_group_prop }; };
  var peg$f231 = function(id_key_prop) { return { id_key_prop }; };
  var peg$f232 = function(opts) {
        return { resource: 'supplental log', ...opts };
    };
  var peg$f233 = function(x, s) { return s; };
  var peg$f234 = function(x, xs) {
            return [x, ...xs];
        };
  var peg$f235 = function(columns) {
        return columns;
    };
  var peg$f236 = function(unique) { return { unique }; };
  var peg$f237 = function(all) { return { all }; };
  var peg$f238 = function() { return { primary_key: 'primary key' }; };
  var peg$f239 = function() { return { foreign_key: 'foreign key' }; };
  var peg$f240 = function(log_group, x, s) { return s; };
  var peg$f241 = function(log_group, x, xs) { 
        return [x, ...xs]; 
      };
  var peg$f242 = function(log_group, columns, always) {
        return { log_group, columns, always };
    };
  var peg$f243 = function(column) { return 'no log'; };
  var peg$f244 = function(column, no_log) {
        return { column, no_log };
    };
  var peg$f245 = function(time_column, start_time_column, end_time_column) { 
        return { start_time_column, end_time_column }; 
      };
  var peg$f246 = function(time_column, range) {
        return { resource: 'period', time_column, ...range };
      };
  var peg$f247 = function(x) { return {...x, resource: 'ref_constraint',}};
  var peg$f248 = function(scope, column, s) { return s; };
  var peg$f249 = function(scope, column, schema, name) {
        return { scope, schema, name, column }; 
      };
  var peg$f250 = function(ref, column, w, rowid) { 
        return { with: w, rowid, column }; 
      };
  var peg$f251 = function(n) { return n; };
  var peg$f252 = function(name, columns, reference, state) { 
        return { 
            name, 
            state,
            columns,
            reference, 
            foreign_key: 'foreign key'
        }; 
      };
  var peg$f253 = function(n) { return n; };
  var peg$f254 = function(name, unique, columns) { 
            return { unique, columns };
        };
  var peg$f255 = function(name, columns) { 
            return { primary_key: 'primary key', columns }; 
        };
  var peg$f256 = function(name, columns, reference) { 
            return { primary_key: 'primary key', columns, reference }; 
        };
  var peg$f257 = function(name, condition) { return { check: condition }; };
  var peg$f258 = function(name, constraint, state) {
      return {
        name, 
        state,
        constraint, 
        resource: 'constraint', 
      };
    };
  var peg$f259 = function(name, type, n) { return n; };
  var peg$f260 = function(name, type, collate, sort, visibility, default_or_identity, e, spec) { return { encrypt: e, spec}; };
  var peg$f261 = function(name, type, collate, sort, visibility, default_or_identity, encrypt, constraints) { 
        return { 
            name,
            type,
            sort,
            encrypt,
            collate,
            visibility,
            constraints,
            resource: 'column',
            ...default_or_identity,
        }; 
      };
  var peg$f262 = function(x) { return [{...x, resource: 'ref_constraint'}]; };
  var peg$f263 = function(scope, s) { return s; };
  var peg$f264 = function(scope, schema, name) {
        return { scope, schema, name }; 
      };
  var peg$f265 = function(w, rowid) {
        return { with: w, rowid }; 
      };
  var peg$f266 = function(n) { return n; };
  var peg$f267 = function(name, reference, state) {
        return { name, reference, state }; 
      };
  var peg$f268 = function(c) { return c; };
  var peg$f269 = function(clauses) {
      return clauses;
    };
  var peg$f270 = function(n) { return n; };
  var peg$f271 = function(name, not) { return { not_null: not ? 'not null' : 'null' }; };
  var peg$f272 = function(name, unique) { return { unique }; };
  var peg$f273 = function(name) { return { primary_key: 'primary key' }; };
  var peg$f274 = function(name, condition) { return { check: condition }; };
  var peg$f275 = function(name, constraint, state) {
      return { resource: 'constraint', name, constraint, state };
    };
  var peg$f276 = function(deferrable, initially) { return { deferrable, initially }; };
  var peg$f277 = function(initially, deferrable) { return { deferrable, initially }; };
  var peg$f278 = function(start, rely, using_index, enable, validate, exception) {
        return { ...start, rely, enable, using_index, validate, exception };
      };
  var peg$f279 = function(s) { return s; };
  var peg$f280 = function(schema, name) {
        return { table: { schema, name } };
    };
  var peg$f281 = function(not, d) { return `${not ? 'not ':''}${d}`; };
  var peg$f282 = function(initially, state) { return state; };
  var peg$f283 = function(s) { return s; };
  var peg$f284 = function(schema, name) { return { schema, name }; };
  var peg$f285 = function(object, c) { return c; };
  var peg$f286 = function(object, columns) { return 'set null'; };
  var peg$f287 = function(object, columns, x) { return x; };
  var peg$f288 = function(object, columns, on_delete) {
        return { type: 'reference', object, columns, on_delete };
      };
  var peg$f289 = function(x) {
        if (!validEncryptionAlgos[x.toUpperCase()]) throw new Error(`Invalid encryption algorithm: ${x}`);
        return x;
      };
  var peg$f290 = function(algorithm, password) { return password; };
  var peg$f291 = function(algorithm, identified_by_password, x) {
        if (!validIntegrityAlgos[x.toUpperCase()]) throw new Error(`Invalid integrity algorithm: ${x}`);
        return x;
      };
  var peg$f292 = function(algorithm, identified_by_password, integrity_algorith, no) { return `${no ? 'no ' : ''}salt`; };
  var peg$f293 = function(algorithm, identified_by_password, integrity_algorith, salt) {
        return { 
            salt,
            algorithm, 
            integrity_algorith, 
            identified_by_password, 
        };
      };
  var peg$f294 = function() { return 'on null'; };
  var peg$f295 = function(on_null, expr) {
        return { default: { on_null, expr } };
    };
  var peg$f296 = function(generated) { return { always }; };
  var peg$f297 = function(generated, def) { return 'on null'; };
  var peg$f298 = function(generated, def, on_null) { return { default: def, on_null }; };
  var peg$f299 = function(generated, when, options) {
        return { identity: { generated, ...when, options } };
      };
  var peg$f300 = function(clauses) {
      return clauses.reduce((acc, clause) => ({ ...acc, ...clause }), {});
    };
  var peg$f301 = function(order) { return { order }; };
  var peg$f302 = function(cycle) { return { cycle }; };
  var peg$f303 = function(cache, value) { return { cache, value }; };
  var peg$f304 = function(cache) { return { cache }; };
  var peg$f305 = function(minvalue, value) { return { minvalue, value }; };
  var peg$f306 = function(minvalue) { return { minvalue }; };
  var peg$f307 = function(maxvalue, value) { return { maxvalue, value }; };
  var peg$f308 = function(maxvalue) { return { maxvalue }; };
  var peg$f309 = function(value) { return { increment_by: value }; };
  var peg$f310 = function() { return 'limit value'; };
  var peg$f311 = function(value) { 
        return { start_with: value }; 
    };
  var peg$f312 = function(type, size) { return size; };
  var peg$f313 = function(type, size) {
        return { type, size };
      };
  var peg$f314 = function(type, size_and_semantics) { 
        return { 
            type, 
            size: size_and_semantics?.size || null, 
            semantics: size_and_semantics?.semantics || null 
        }; 
      };
  var peg$f315 = function(size, semantics) { return { size, semantics: semantics }; };
  var peg$f316 = function() { return "nchar"; };
  var peg$f317 = function() { return "nvarchar2"; };
  var peg$f318 = function() { return "char"; };
  var peg$f319 = function() { return "varchar2"; };
  var peg$f320 = function() { return { type: "binary_float" }; };
  var peg$f321 = function() { return { type: "binary_double" }; };
  var peg$f322 = function(p) { return p };
  var peg$f323 = function(precision) {
            return { type: "float", precision }; 
        };
  var peg$f324 = function(p, s) { return s };
  var peg$f325 = function(p, s) { return { p, s } };
  var peg$f326 = function(precision) {
            return { type: "number", precision: precision?.p, scale: precision?.s  }; 
        };
  var peg$f327 = function() { return { type: "long raw" }; };
  var peg$f328 = function() { return { type: "long" }; };
  var peg$f329 = function(size) { return { type: "raw", size }; };
  var peg$f330 = function(type) { return { type }; };
  var peg$f331 = function() { return { type: "rowid" }; };
  var peg$f332 = function(size) { return size };
  var peg$f333 = function(size) { return { type: "urowid", size }; };
  var peg$f334 = function() { return { type: "date" }; };
  var peg$f335 = function(p) { return p; };
  var peg$f336 = function(precision) { return "local" };
  var peg$f337 = function(precision, l) { return `with ${l?"local ":""}time zone`};
  var peg$f338 = function(precision, with_tz) { return { type: "timestamp", fractional_seconds_precision: precision, with_tz }; };
  var peg$f339 = function(p) { return p; };
  var peg$f340 = function(precision) { return { type: "interval year", year_precision: precision, to_month: "to month" }; };
  var peg$f341 = function(p) { return p; };
  var peg$f342 = function(day_precision, p) { return p; };
  var peg$f343 = function(day_precision, fractional_seconds_precision) { return { type: "interval day", day_precision, to_second: "to second", fractional_seconds_precision }; };
  var peg$f344 = function(type) { return { type: type.toLowerCase() }; };
  var peg$f345 = function(type) { return { type: type.toLowerCase() }; };
  var peg$f346 = function(type) { return { type: type.toLowerCase() }; };
  var peg$f347 = function(type, varying, size) { return { type, varying, size }; };
  var peg$f348 = function(type, varying, size) { return { type, varying, size }; };
  var peg$f349 = function(type, size) { return { type, size }; };
  var peg$f350 = function(type, char, varying, size) { return { type, char, varying, size }; };
  var peg$f351 = function(type) { return { type }; };
  var peg$f352 = function(type, s) { return s; };
  var peg$f353 = function(type, precision) { return { type, precision }; };
  var peg$f354 = function(type, p, s) { return s; };
  var peg$f355 = function(type, p, s) { return { p, s }; };
  var peg$f356 = function(type, ps) { return { type, precision: ps?.p, scale: ps?.s } };
  var peg$f357 = function(type) { return { type: type.filter(e => typeof e === 'string').join(' ') }; };
  var peg$f358 = function(x, c) { return c; };
  var peg$f359 = function(x, xs) { return [x, ...xs]; };
  var peg$f360 = function(digits) { return digits.join("");};
  var peg$f361 = function(s) { return s; };
  var peg$f362 = function(chars) { return chars.join(''); };
  var peg$f363 = function(name) {
        if(reservedKeywords[name.toUpperCase()] === true) {
            throw new Error(`${name} is a reserved keyword`);
        }
        return name;
    };
  var peg$f364 = function(start, rest) { return start + rest.join("") };
  var peg$f365 = function() { return 'create'; };
  var peg$f366 = function() { return 'table'; };
  var peg$f367 = function() { return 'global'; };
  var peg$f368 = function() { return 'private'; };
  var peg$f369 = function() { return 'temporary'; };
  var peg$f370 = function() { return 'shared'; };
  var peg$f371 = function() { return 'duplicated'; };
  var peg$f372 = function() { return 'immutable'; };
  var peg$f373 = function() { return 'blockchain'; };
  var peg$f374 = function() { return 'sharing'; };
  var peg$f375 = function() { return 'metadata'; };
  var peg$f376 = function() { return 'data'; };
  var peg$f377 = function() { return 'extended'; };
  var peg$f378 = function() { return 'none'; };
  var peg$f379 = function() { return 'memoptimize'; };
  var peg$f380 = function() { return 'for'; };
  var peg$f381 = function() { return 'read'; };
  var peg$f382 = function() { return 'write'; };
  var peg$f383 = function() { return 'parent'; };
  var peg$f384 = function() { return 'no'; };
  var peg$f385 = function() { return 'on'; };
  var peg$f386 = function() { return 'not'; };
  var peg$f387 = function() { return 'into'; };
  var peg$f388 = function() { return 'drop'; };
  var peg$f389 = function() { return 'delete'; };
  var peg$f390 = function() { return 'until'; };
  var peg$f391 = function() { return 'days'; };
  var peg$f392 = function() { return 'idle'; };
  var peg$f393 = function() { return 'locked'; };
  var peg$f394 = function() { return 'after'; };
  var peg$f395 = function() { return 'insert'; };
  var peg$f396 = function() { return 'hashing'; };
  var peg$f397 = function() { return 'using'; };
  var peg$f398 = function() { return 'version'; };
  var peg$f399 = function() { return 'default'; };
  var peg$f400 = function() { return 'collation'; };
  var peg$f401 = function() { return 'collate'; };
  var peg$f402 = function() { return 'commit'; };
  var peg$f403 = function() { return 'preserve'; };
  var peg$f404 = function() { return 'definition'; };
  var peg$f405 = function() { return 'rows'; };
  var peg$f406 = function() { return 'sort'; };
  var peg$f407 = function() { return 'visible'; };
  var peg$f408 = function() { return 'invisible'; };
  var peg$f409 = function() { return 'null'; };
  var peg$f410 = function() { return 'generated'; };
  var peg$f411 = function() { return 'always'; };
  var peg$f412 = function() { return 'by'; };
  var peg$f413 = function() { return 'as'; };
  var peg$f414 = function() { return 'is'; };
  var peg$f415 = function() { return 'of'; };
  var peg$f416 = function() { return 'to'; };
  var peg$f417 = function() { return 'identity'; };
  var peg$f418 = function() { return 'start'; };
  var peg$f419 = function() { return 'with'; };
  var peg$f420 = function() { return 'salt'; };
  var peg$f421 = function() { return 'limit'; };
  var peg$f422 = function() { return 'value'; };
  var peg$f423 = function() { return 'increment'; };
  var peg$f424 = function() { return 'maxvalue'; };
  var peg$f425 = function() { return 'nomaxvalue'; };
  var peg$f426 = function() { return 'minvalue'; };
  var peg$f427 = function() { return 'nominvalue'; };
  var peg$f428 = function() { return 'cycle'; };
  var peg$f429 = function() { return 'nocycle'; };
  var peg$f430 = function() { return 'cache'; };
  var peg$f431 = function() { return 'nocache'; };
  var peg$f432 = function() { return 'order'; };
  var peg$f433 = function() { return 'noorder'; };
  var peg$f434 = function() { return 'encrypt'; };
  var peg$f435 = function() { return 'identified'; };
  var peg$f436 = function() { return 'constraint'; };
  var peg$f437 = function() { return 'unique'; };
  var peg$f438 = function() { return 'primary'; };
  var peg$f439 = function() { return 'key'; };
  var peg$f440 = function() { return 'check'; };
  var peg$f441 = function() { return 'references'; };
  var peg$f442 = function() { return 'cascade'; };
  var peg$f443 = function() { return 'set'; };
  var peg$f444 = function() { return 'ref'; };
  var peg$f445 = function() { return 'rely'; };
  var peg$f446 = function() { return 'norely'; };
  var peg$f447 = function() { return 'deferrable'; };
  var peg$f448 = function() { return 'deferred'; };
  var peg$f449 = function() { return 'initially'; };
  var peg$f450 = function() { return 'immediate'; };
  var peg$f451 = function() { return 'enable'; };
  var peg$f452 = function() { return 'disable'; };
  var peg$f453 = function() { return 'validate'; };
  var peg$f454 = function() { return 'novalidate'; };
  var peg$f455 = function() { return 'exceptions'; };
  var peg$f456 = function() { return 'scope'; };
  var peg$f457 = function() { return 'foreign'; };
  var peg$f458 = function() { return 'segment'; };
  var peg$f459 = function() { return 'creation'; };
  var peg$f460 = function() { return 'tablespace'; };
  var peg$f461 = function() { return 'logging'; };
  var peg$f462 = function() { return 'nologging'; };
  var peg$f463 = function() { return 'filesystem_like_logging'; };
  var peg$f464 = function() { return 'pctfree'; };
  var peg$f465 = function() { return 'pctused'; };
  var peg$f466 = function() { return 'initrans'; };
  var peg$f467 = function() { return 'storage'; };
  var peg$f468 = function() { return 'initial'; };
  var peg$f469 = function() { return 'next'; };
  var peg$f470 = function() { return 'minextents'; };
  var peg$f471 = function() { return 'maxextents'; };
  var peg$f472 = function() { return 'unlimited'; };
  var peg$f473 = function() { return 'maxsize'; };
  var peg$f474 = function() { return 'keep'; };
  var peg$f475 = function() { return 'recycle'; };
  var peg$f476 = function() { return 'optimal'; };
  var peg$f477 = function() { return 'pctincrease'; };
  var peg$f478 = function() { return 'freelists'; };
  var peg$f479 = function() { return 'freelist'; };
  var peg$f480 = function() { return 'groups'; };
  var peg$f481 = function() { return 'buffer_pool'; };
  var peg$f482 = function() { return 'flash_cache'; };
  var peg$f483 = function() { return 'cell_flash_cache'; };
  var peg$f484 = function() { return 'compress'; };
  var peg$f485 = function() { return 'row'; };
  var peg$f486 = function() { return 'store'; };
  var peg$f487 = function() { return 'basic'; };
  var peg$f488 = function() { return 'advanced'; };
  var peg$f489 = function() { return 'column'; };
  var peg$f490 = function() { return 'query'; };
  var peg$f491 = function() { return 'archive'; };
  var peg$f492 = function() { return 'low'; };
  var peg$f493 = function() { return 'high'; };
  var peg$f494 = function() { return 'row level locking'; };
  var peg$f495 = function() { return 'nocompress'; };
  var peg$f496 = function() { return 'level'; };
  var peg$f497 = function() { return 'locking'; };
  var peg$f498 = function() { return 'inmemory'; };
  var peg$f499 = function() { return 'memcompress'; };
  var peg$f500 = function() { return 'dml'; };
  var peg$f501 = function() { return 'capacity'; };
  var peg$f502 = function() { return 'auto'; };
  var peg$f503 = function() { return 'priority'; };
  var peg$f504 = function() { return 'medium'; };
  var peg$f505 = function() { return 'critical'; };
  var peg$f506 = function() { return 'distribute'; };
  var peg$f507 = function() { return 'range'; };
  var peg$f508 = function() { return 'partition'; };
  var peg$f509 = function() { return 'subpartition'; };
  var peg$f510 = function() { return 'service'; };
  var peg$f511 = function() { return 'all'; };
  var peg$f512 = function() { return 'duplicate'; };
  var peg$f513 = function() { return 'spatial'; };
  var peg$f514 = function() { return 'ilm'; };
  var peg$f515 = function() { return 'add'; };
  var peg$f516 = function() { return 'policy'; };
  var peg$f517 = function() { return 'disable_all'; };
  var peg$f518 = function() { return 'delete_all'; };
  var peg$f519 = function() { return 'enable_all'; };
  var peg$f520 = function() { return 'group'; };
  var peg$f521 = function() { return 'access'; };
  var peg$f522 = function() { return 'modification'; };
  var peg$f523 = function() { return 'day'; };
  var peg$f524 = function() { return 'month'; };
  var peg$f525 = function() { return 'months'; };
  var peg$f526 = function() { return 'year'; };
  var peg$f527 = function() { return 'years'; };
  var peg$f528 = function() { return 'tier'; };
  var peg$f529 = function() { return 'only'; };
  var peg$f530 = function() { return 'modify'; };
  var peg$f531 = function() { return 'cluster'; };
  var peg$f532 = function() { return 'index'; };
  var peg$f533 = function() { return 'external'; };
  var peg$f534 = function() { return 'reject'; };
  var peg$f535 = function() { return 'attributes'; };
  var peg$f536 = function() { return 'type'; };
  var peg$f537 = function() { return 'directory'; };
  var peg$f538 = function() { return 'location'; };
  var peg$f539 = function() { return 'clob'; };
  var peg$f540 = function() { return 'heap'; };
  var peg$f541 = function() { return 'parameters'; };
  var peg$f542 = function() { return 'organization'; };
  var peg$f543 = function() { return 'mapping'; };
  var peg$f544 = function() { return 'nomapping'; };
  var peg$f545 = function() { return 'pctthreshold'; };
  var peg$f546 = function() { return 'including'; };
  var peg$f547 = function() { return 'overflow'; };
  var peg$f548 = function() { return 'period'; };
  var peg$f549 = function() { return 'supplemental'; };
  var peg$f550 = function() { return 'log'; };
  var peg$f551 = function() { return 'columns'; };
  var peg$f552 = function() { return 'substitutable'; };
  var peg$f553 = function() { return 'element'; };
  var peg$f554 = function() { return 'levels'; };
  var peg$f555 = function() { return 'at'; };
  var peg$f556 = function() { return 'nested'; };
  var peg$f557 = function() { return 'return'; };
  var peg$f558 = function() { return 'locator'; };
  var peg$f559 = function() { return 'local'; };
  var peg$f560 = function() { return 'retention'; };
  var peg$f561 = function() { return 'chunk'; };
  var peg$f562 = function() { return 'pctversion'; };
  var peg$f563 = function() { return 'freepools'; };
  var peg$f564 = function() { return 'varray'; };
  var peg$f565 = function() { return 'securefile'; };
  var peg$f566 = function() { return 'basicfile'; };
  var peg$f567 = function() { return 'lob'; };
  var peg$f568 = function() { return 'in'; };
  var peg$f569 = function() { return 'decrypt'; };
  var peg$f570 = function() { return 'reads'; };
  var peg$f571 = function() { return 'deduplicate'; };
  var peg$f572 = function() { return 'keep_duplicates'; };
  var peg$f573 = function() { return 'max'; };
  var peg$f574 = function() { return 'min'; };
  var peg$f575 = function() { return 'off'; };
  var peg$f576 = function() { return 'indexing'; };
  var peg$f577 = function() { return 'varying'; };
  var peg$f578 = function() { return 'varchar'; };
  var peg$f579 = function() { return 'character'; };
  var peg$f580 = function() { return 'char'; };
  var peg$f581 = function() { return 'nchar'; };
  var peg$f582 = function() { return 'national'; };
  var peg$f583 = function() { return 'int'; };
  var peg$f584 = function() { return 'integer'; };
  var peg$f585 = function() { return 'smallint'; };
  var peg$f586 = function() { return 'float'; };
  var peg$f587 = function() { return 'real'; };
  var peg$f588 = function() { return 'numeric'; };
  var peg$f589 = function() { return 'decimal'; };
  var peg$f590 = function() { return 'dec'; };
  var peg$f591 = function() { return 'double'; };
  var peg$f592 = function() { return 'precision'; };
  var peg$f593 = function() { return 'rowid'; };
  var peg$f594 = function() { return 'varchar2'; };
  var peg$f595 = function() { return 'json'; };
  var peg$currPos = options.peg$currPos | 0;
  var peg$savedPos = peg$currPos;
  var peg$posDetailsCache = [{ line: 1, column: 1 }];
  var peg$maxFailPos = peg$currPos;
  var peg$maxFailExpected = options.peg$maxFailExpected || [];
  var peg$silentFails = options.peg$silentFails | 0;

  var peg$result;

  if (options.startRule) {
    if (!(options.startRule in peg$startRuleFunctions)) {
      throw new Error("Can't start parsing from rule \"" + options.startRule + "\".");
    }

    peg$startRuleFunction = peg$startRuleFunctions[options.startRule];
  }

  function text() {
    return input.substring(peg$savedPos, peg$currPos);
  }

  function offset() {
    return peg$savedPos;
  }

  function range() {
    return {
      source: peg$source,
      start: peg$savedPos,
      end: peg$currPos
    };
  }

  function location() {
    return peg$computeLocation(peg$savedPos, peg$currPos);
  }

  function expected(description, location) {
    location = location !== undefined
      ? location
      : peg$computeLocation(peg$savedPos, peg$currPos);

    throw peg$buildStructuredError(
      [peg$otherExpectation(description)],
      input.substring(peg$savedPos, peg$currPos),
      location
    );
  }

  function error(message, location) {
    location = location !== undefined
      ? location
      : peg$computeLocation(peg$savedPos, peg$currPos);

    throw peg$buildSimpleError(message, location);
  }

  function peg$literalExpectation(text, ignoreCase) {
    return { type: "literal", text: text, ignoreCase: ignoreCase };
  }

  function peg$classExpectation(parts, inverted, ignoreCase) {
    return { type: "class", parts: parts, inverted: inverted, ignoreCase: ignoreCase };
  }

  function peg$anyExpectation() {
    return { type: "any" };
  }

  function peg$endExpectation() {
    return { type: "end" };
  }

  function peg$otherExpectation(description) {
    return { type: "other", description: description };
  }

  function peg$computePosDetails(pos) {
    var details = peg$posDetailsCache[pos];
    var p;

    if (details) {
      return details;
    } else {
      if (pos >= peg$posDetailsCache.length) {
        p = peg$posDetailsCache.length - 1;
      } else {
        p = pos;
        while (!peg$posDetailsCache[--p]) {}
      }

      details = peg$posDetailsCache[p];
      details = {
        line: details.line,
        column: details.column
      };

      while (p < pos) {
        if (input.charCodeAt(p) === 10) {
          details.line++;
          details.column = 1;
        } else {
          details.column++;
        }

        p++;
      }

      peg$posDetailsCache[pos] = details;

      return details;
    }
  }

  function peg$computeLocation(startPos, endPos, offset) {
    var startPosDetails = peg$computePosDetails(startPos);
    var endPosDetails = peg$computePosDetails(endPos);

    var res = {
      source: peg$source,
      start: {
        offset: startPos,
        line: startPosDetails.line,
        column: startPosDetails.column
      },
      end: {
        offset: endPos,
        line: endPosDetails.line,
        column: endPosDetails.column
      }
    };
    if (offset && peg$source && (typeof peg$source.offset === "function")) {
      res.start = peg$source.offset(res.start);
      res.end = peg$source.offset(res.end);
    }
    return res;
  }

  function peg$fail(expected) {
    if (peg$currPos < peg$maxFailPos) { return; }

    if (peg$currPos > peg$maxFailPos) {
      peg$maxFailPos = peg$currPos;
      peg$maxFailExpected = [];
    }

    peg$maxFailExpected.push(expected);
  }

  function peg$buildSimpleError(message, location) {
    return new peg$SyntaxError(message, null, null, location);
  }

  function peg$buildStructuredError(expected, found, location) {
    return new peg$SyntaxError(
      peg$SyntaxError.buildMessage(expected, found),
      expected,
      found,
      location
    );
  }

  function peg$parsestart() {
    var s0;

    s0 = peg$parsecreate_table_stmt();

    return s0;
  }

  function peg$parsecreate_table_stmt() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16;

    s0 = peg$currPos;
    s1 = peg$parseKW_CREATE();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_TABLE();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parsetable_type();
        if (s5 === peg$FAILED) {
          s5 = null;
        }
        s6 = peg$parse_();
        s7 = peg$currPos;
        s8 = peg$parseidentifier_name();
        if (s8 !== peg$FAILED) {
          s9 = peg$parse_();
          s10 = peg$parseDOT();
          if (s10 !== peg$FAILED) {
            s11 = peg$parse_();
            peg$savedPos = s7;
            s7 = peg$f0(s1, s3, s5, s8);
          } else {
            peg$currPos = s7;
            s7 = peg$FAILED;
          }
        } else {
          peg$currPos = s7;
          s7 = peg$FAILED;
        }
        if (s7 === peg$FAILED) {
          s7 = null;
        }
        s8 = peg$parseidentifier_name();
        if (s8 !== peg$FAILED) {
          s9 = peg$parse_();
          s10 = peg$parsetable_sharing_clause();
          if (s10 === peg$FAILED) {
            s10 = null;
          }
          s11 = peg$parserelational_table();
          s12 = peg$parsetable_memoptimize_clauses();
          s13 = peg$parse_();
          s14 = peg$parsetable_parent_clause();
          if (s14 === peg$FAILED) {
            s14 = null;
          }
          s15 = peg$parse_();
          s16 = peg$parseSEMI_COLON();
          if (s16 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f1(s1, s3, s5, s7, s8, s10, s11, s12, s14);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsetable_type() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parseKW_GLOBAL();
    if (s1 === peg$FAILED) {
      s1 = peg$parseKW_PRIVATE();
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_TEMPORARY();
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f2(s1, s3);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseKW_SHARED();
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$f3(s1);
      }
      s0 = s1;
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseKW_DUPLICATED();
        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$f4(s1);
        }
        s0 = s1;
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$parseKW_IMMUTABLE();
          if (s1 === peg$FAILED) {
            s1 = null;
          }
          s2 = peg$parse_();
          s3 = peg$parseKW_BLOCKCHAIN();
          if (s3 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f5(s1, s3);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$parseKW_IMMUTABLE();
            if (s1 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$f6(s1);
            }
            s0 = s1;
          }
        }
      }
    }

    return s0;
  }

  function peg$parsetable_sharing_clause() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8;

    s0 = peg$currPos;
    s1 = peg$parseKW_SHARING();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseEQ();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseKW_METADATA();
        if (s5 === peg$FAILED) {
          s5 = peg$parseKW_DATA();
          if (s5 === peg$FAILED) {
            s5 = peg$parseKW_NONE();
            if (s5 === peg$FAILED) {
              s5 = peg$currPos;
              s6 = peg$parseKW_EXTENDED();
              if (s6 !== peg$FAILED) {
                s7 = peg$parse_();
                s8 = peg$parseKW_DATA();
                if (s8 !== peg$FAILED) {
                  s6 = [s6, s7, s8];
                  s5 = s6;
                } else {
                  peg$currPos = s5;
                  s5 = peg$FAILED;
                }
              } else {
                peg$currPos = s5;
                s5 = peg$FAILED;
              }
            }
          }
        }
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f7(s1, s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsetable_memoptimize_clauses() {
    var s0, s1, s2, s3, s4;

    s0 = peg$currPos;
    s1 = [];
    s2 = peg$currPos;
    s3 = peg$parsetable_memoptimize_clause();
    if (s3 !== peg$FAILED) {
      s4 = peg$parse_();
      s3 = [s3, s4];
      s2 = s3;
    } else {
      peg$currPos = s2;
      s2 = peg$FAILED;
    }
    while (s2 !== peg$FAILED) {
      s1.push(s2);
      s2 = peg$currPos;
      s3 = peg$parsetable_memoptimize_clause();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s3 = [s3, s4];
        s2 = s3;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
    }
    peg$savedPos = s0;
    s1 = peg$f8(s1);
    s0 = s1;

    return s0;
  }

  function peg$parsetable_memoptimize_clause() {
    var s0, s1, s2, s3, s4, s5;

    s0 = peg$currPos;
    s1 = peg$parseKW_MEMOPTIMIZE();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_FOR();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseKW_READ();
        if (s5 === peg$FAILED) {
          s5 = peg$parseKW_WRITE();
        }
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f9(s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsetable_parent_clause() {
    var s0, s1, s2, s3, s4, s5, s6, s7;

    s0 = peg$currPos;
    s1 = peg$parseKW_PARENT();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$currPos;
      s4 = peg$parseidentifier_name();
      if (s4 !== peg$FAILED) {
        s5 = peg$parse_();
        s6 = peg$parseDOT();
        if (s6 !== peg$FAILED) {
          s7 = peg$parse_();
          peg$savedPos = s3;
          s3 = peg$f10(s4);
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
      if (s3 === peg$FAILED) {
        s3 = null;
      }
      s4 = peg$parseidentifier_name();
      if (s4 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f11(s3, s4);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parserelational_table() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16, s17;

    s0 = peg$currPos;
    s1 = peg$currPos;
    s2 = peg$parseLPAR();
    if (s2 !== peg$FAILED) {
      s3 = peg$parse_();
      s4 = peg$parserelational_properties();
      if (s4 !== peg$FAILED) {
        s5 = peg$parse_();
        s6 = peg$parseRPAR();
        if (s6 !== peg$FAILED) {
          peg$savedPos = s1;
          s1 = peg$f12(s4);
        } else {
          peg$currPos = s1;
          s1 = peg$FAILED;
        }
      } else {
        peg$currPos = s1;
        s1 = peg$FAILED;
      }
    } else {
      peg$currPos = s1;
      s1 = peg$FAILED;
    }
    if (s1 === peg$FAILED) {
      s1 = null;
    }
    s2 = peg$parseblockchain_table_clauses();
    if (s2 === peg$FAILED) {
      s2 = null;
    }
    s3 = peg$parse_();
    s4 = peg$parseimmutable_table_clauses();
    s5 = peg$parse_();
    s6 = peg$currPos;
    s7 = peg$parseKW_DEFAULT();
    if (s7 !== peg$FAILED) {
      s8 = peg$parse_();
      s9 = peg$parseKW_COLLATION();
      if (s9 !== peg$FAILED) {
        s10 = peg$parse_();
        s11 = peg$parseidentifier_name();
        if (s11 !== peg$FAILED) {
          peg$savedPos = s6;
          s6 = peg$f13(s1, s2, s4, s11);
        } else {
          peg$currPos = s6;
          s6 = peg$FAILED;
        }
      } else {
        peg$currPos = s6;
        s6 = peg$FAILED;
      }
    } else {
      peg$currPos = s6;
      s6 = peg$FAILED;
    }
    if (s6 === peg$FAILED) {
      s6 = null;
    }
    s7 = peg$parse_();
    s8 = peg$currPos;
    s9 = peg$parseKW_ON();
    if (s9 !== peg$FAILED) {
      s10 = peg$parse_();
      s11 = peg$parseKW_COMMIT();
      if (s11 !== peg$FAILED) {
        s12 = peg$parse_();
        s13 = peg$parseKW_DROP();
        if (s13 === peg$FAILED) {
          s13 = peg$parseKW_PRESERVE();
        }
        if (s13 !== peg$FAILED) {
          s14 = peg$parse_();
          s15 = peg$parseKW_DEFINITION();
          if (s15 !== peg$FAILED) {
            peg$savedPos = s8;
            s8 = peg$f14(s1, s2, s4, s6, s13);
          } else {
            peg$currPos = s8;
            s8 = peg$FAILED;
          }
        } else {
          peg$currPos = s8;
          s8 = peg$FAILED;
        }
      } else {
        peg$currPos = s8;
        s8 = peg$FAILED;
      }
    } else {
      peg$currPos = s8;
      s8 = peg$FAILED;
    }
    if (s8 === peg$FAILED) {
      s8 = null;
    }
    s9 = peg$parse_();
    s10 = peg$currPos;
    s11 = peg$parseKW_ON();
    if (s11 !== peg$FAILED) {
      s12 = peg$parse_();
      s13 = peg$parseKW_COMMIT();
      if (s13 !== peg$FAILED) {
        s14 = peg$parse_();
        s15 = peg$parseKW_DROP();
        if (s15 === peg$FAILED) {
          s15 = peg$parseKW_PRESERVE();
        }
        if (s15 !== peg$FAILED) {
          s16 = peg$parse_();
          s17 = peg$parseKW_ROWS();
          if (s17 !== peg$FAILED) {
            peg$savedPos = s10;
            s10 = peg$f15(s1, s2, s4, s6, s8, s15);
          } else {
            peg$currPos = s10;
            s10 = peg$FAILED;
          }
        } else {
          peg$currPos = s10;
          s10 = peg$FAILED;
        }
      } else {
        peg$currPos = s10;
        s10 = peg$FAILED;
      }
    } else {
      peg$currPos = s10;
      s10 = peg$FAILED;
    }
    if (s10 === peg$FAILED) {
      s10 = null;
    }
    s11 = peg$parse_();
    s12 = peg$parsephysical_properties();
    if (s12 === peg$FAILED) {
      s12 = null;
    }
    s13 = peg$parse_();
    s14 = peg$parsetable_properties();
    peg$savedPos = s0;
    s0 = peg$f16(s1, s2, s4, s6, s8, s10, s12, s14);

    return s0;
  }

  function peg$parsetable_properties() {
    var s0, s1, s2, s3, s4, s5;

    s0 = peg$currPos;
    s1 = peg$parsecolumn_properties();
    if (s1 === peg$FAILED) {
      s1 = null;
    }
    s2 = peg$parse_();
    s3 = peg$parseread_only_clause();
    if (s3 === peg$FAILED) {
      s3 = null;
    }
    s4 = peg$parse_();
    s5 = peg$parseindexing_clause();
    if (s5 === peg$FAILED) {
      s5 = null;
    }
    peg$savedPos = s0;
    s0 = peg$f17(s1, s3, s5);

    return s0;
  }

  function peg$parseread_only_clause() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parseKW_READ();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_ONLY();
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f18();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseKW_READ();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        s3 = peg$parseKW_WRITE();
        if (s3 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f19();
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    }

    return s0;
  }

  function peg$parseindexing_clause() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parseKW_INDEXING();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_ON();
      if (s3 === peg$FAILED) {
        s3 = peg$parseKW_OFF();
      }
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f20(s3);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsecolumn_properties() {
    var s0, s1, s2, s3, s4;

    s0 = peg$currPos;
    s1 = [];
    s2 = peg$currPos;
    s3 = peg$parse_();
    s4 = peg$parsecolumn_property();
    if (s4 !== peg$FAILED) {
      peg$savedPos = s2;
      s2 = peg$f21(s4);
    } else {
      peg$currPos = s2;
      s2 = peg$FAILED;
    }
    if (s2 !== peg$FAILED) {
      while (s2 !== peg$FAILED) {
        s1.push(s2);
        s2 = peg$currPos;
        s3 = peg$parse_();
        s4 = peg$parsecolumn_property();
        if (s4 !== peg$FAILED) {
          peg$savedPos = s2;
          s2 = peg$f21(s4);
        } else {
          peg$currPos = s2;
          s2 = peg$FAILED;
        }
      }
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f22(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parsecolumn_property() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12;

    s0 = peg$parseobject_type_col_properties();
    if (s0 === peg$FAILED) {
      s0 = peg$parsenested_table_col_properties();
      if (s0 === peg$FAILED) {
        s0 = peg$parseJSON_storage_clause();
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$parsevarray_col_properties();
          if (s1 !== peg$FAILED) {
            s2 = peg$currPos;
            s3 = peg$parse_();
            s4 = peg$parseLPAR();
            if (s4 !== peg$FAILED) {
              s5 = peg$parse_();
              s6 = peg$parseLOB_partition_storage();
              if (s6 !== peg$FAILED) {
                s7 = [];
                s8 = peg$currPos;
                s9 = peg$parse_();
                s10 = peg$parseCOMMA();
                if (s10 !== peg$FAILED) {
                  s11 = peg$parse_();
                  s12 = peg$parseLOB_partition_storage();
                  if (s12 !== peg$FAILED) {
                    s9 = [s9, s10, s11, s12];
                    s8 = s9;
                  } else {
                    peg$currPos = s8;
                    s8 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s8;
                  s8 = peg$FAILED;
                }
                while (s8 !== peg$FAILED) {
                  s7.push(s8);
                  s8 = peg$currPos;
                  s9 = peg$parse_();
                  s10 = peg$parseCOMMA();
                  if (s10 !== peg$FAILED) {
                    s11 = peg$parse_();
                    s12 = peg$parseLOB_partition_storage();
                    if (s12 !== peg$FAILED) {
                      s9 = [s9, s10, s11, s12];
                      s8 = s9;
                    } else {
                      peg$currPos = s8;
                      s8 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s8;
                    s8 = peg$FAILED;
                  }
                }
                s8 = peg$parse_();
                s9 = peg$parseRPAR();
                if (s9 !== peg$FAILED) {
                  peg$savedPos = s2;
                  s2 = peg$f23(s1, s6, s7);
                } else {
                  peg$currPos = s2;
                  s2 = peg$FAILED;
                }
              } else {
                peg$currPos = s2;
                s2 = peg$FAILED;
              }
            } else {
              peg$currPos = s2;
              s2 = peg$FAILED;
            }
            if (s2 === peg$FAILED) {
              s2 = null;
            }
            peg$savedPos = s0;
            s0 = peg$f24(s1, s2);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$parseLOB_storage_clause();
            if (s1 !== peg$FAILED) {
              s2 = peg$currPos;
              s3 = peg$parse_();
              s4 = peg$parseLPAR();
              if (s4 !== peg$FAILED) {
                s5 = peg$parse_();
                s6 = peg$parseLOB_partition_storage();
                if (s6 !== peg$FAILED) {
                  s7 = [];
                  s8 = peg$currPos;
                  s9 = peg$parse_();
                  s10 = peg$parseCOMMA();
                  if (s10 !== peg$FAILED) {
                    s11 = peg$parse_();
                    s12 = peg$parseLOB_partition_storage();
                    if (s12 !== peg$FAILED) {
                      s9 = [s9, s10, s11, s12];
                      s8 = s9;
                    } else {
                      peg$currPos = s8;
                      s8 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s8;
                    s8 = peg$FAILED;
                  }
                  while (s8 !== peg$FAILED) {
                    s7.push(s8);
                    s8 = peg$currPos;
                    s9 = peg$parse_();
                    s10 = peg$parseCOMMA();
                    if (s10 !== peg$FAILED) {
                      s11 = peg$parse_();
                      s12 = peg$parseLOB_partition_storage();
                      if (s12 !== peg$FAILED) {
                        s9 = [s9, s10, s11, s12];
                        s8 = s9;
                      } else {
                        peg$currPos = s8;
                        s8 = peg$FAILED;
                      }
                    } else {
                      peg$currPos = s8;
                      s8 = peg$FAILED;
                    }
                  }
                  s8 = peg$parse_();
                  s9 = peg$parseRPAR();
                  if (s9 !== peg$FAILED) {
                    peg$savedPos = s2;
                    s2 = peg$f25(s1, s6, s7);
                  } else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s2;
                  s2 = peg$FAILED;
                }
              } else {
                peg$currPos = s2;
                s2 = peg$FAILED;
              }
              if (s2 === peg$FAILED) {
                s2 = null;
              }
              peg$savedPos = s0;
              s0 = peg$f26(s1, s2);
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          }
        }
      }
    }

    return s0;
  }

  function peg$parseLOB_partition_storage() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16, s17;

    s0 = peg$currPos;
    s1 = peg$parseKW_PARTITION();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseidentifier_name();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = [];
        s6 = peg$currPos;
        s7 = peg$parse_();
        s8 = peg$parsevarray_col_properties();
        if (s8 === peg$FAILED) {
          s8 = peg$parseLOB_storage_clause();
        }
        if (s8 !== peg$FAILED) {
          peg$savedPos = s6;
          s6 = peg$f27(s3, s8);
        } else {
          peg$currPos = s6;
          s6 = peg$FAILED;
        }
        if (s6 !== peg$FAILED) {
          while (s6 !== peg$FAILED) {
            s5.push(s6);
            s6 = peg$currPos;
            s7 = peg$parse_();
            s8 = peg$parsevarray_col_properties();
            if (s8 === peg$FAILED) {
              s8 = peg$parseLOB_storage_clause();
            }
            if (s8 !== peg$FAILED) {
              peg$savedPos = s6;
              s6 = peg$f27(s3, s8);
            } else {
              peg$currPos = s6;
              s6 = peg$FAILED;
            }
          }
        } else {
          s5 = peg$FAILED;
        }
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$currPos;
          s8 = peg$parseLPAR();
          if (s8 !== peg$FAILED) {
            s9 = peg$parse_();
            s10 = peg$parseKW_SUBPARTITION();
            if (s10 !== peg$FAILED) {
              s11 = peg$parse_();
              s12 = peg$parseidentifier_name();
              if (s12 !== peg$FAILED) {
                s13 = peg$parse_();
                s14 = [];
                s15 = peg$currPos;
                s16 = peg$parse_();
                s17 = peg$parsevarray_col_properties();
                if (s17 === peg$FAILED) {
                  s17 = peg$parseLOB_partitioning_storage();
                }
                if (s17 !== peg$FAILED) {
                  peg$savedPos = s15;
                  s15 = peg$f28(s3, s5, s12, s17);
                } else {
                  peg$currPos = s15;
                  s15 = peg$FAILED;
                }
                if (s15 !== peg$FAILED) {
                  while (s15 !== peg$FAILED) {
                    s14.push(s15);
                    s15 = peg$currPos;
                    s16 = peg$parse_();
                    s17 = peg$parsevarray_col_properties();
                    if (s17 === peg$FAILED) {
                      s17 = peg$parseLOB_partitioning_storage();
                    }
                    if (s17 !== peg$FAILED) {
                      peg$savedPos = s15;
                      s15 = peg$f28(s3, s5, s12, s17);
                    } else {
                      peg$currPos = s15;
                      s15 = peg$FAILED;
                    }
                  }
                } else {
                  s14 = peg$FAILED;
                }
                if (s14 !== peg$FAILED) {
                  s15 = peg$parse_();
                  s16 = peg$parseRPAR();
                  if (s16 !== peg$FAILED) {
                    peg$savedPos = s7;
                    s7 = peg$f29(s3, s5, s12, s14);
                  } else {
                    peg$currPos = s7;
                    s7 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s7;
                  s7 = peg$FAILED;
                }
              } else {
                peg$currPos = s7;
                s7 = peg$FAILED;
              }
            } else {
              peg$currPos = s7;
              s7 = peg$FAILED;
            }
          } else {
            peg$currPos = s7;
            s7 = peg$FAILED;
          }
          if (s7 === peg$FAILED) {
            s7 = null;
          }
          peg$savedPos = s0;
          s0 = peg$f30(s3, s5, s7);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseLOB_partitioning_storage() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16, s17, s18, s19, s20, s21, s22, s23, s24, s25, s26;

    s0 = peg$currPos;
    s1 = peg$parseKW_LOB();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseLPAR();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseidentifier_name();
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parseLPAR();
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            s9 = peg$parseKW_STORE();
            if (s9 !== peg$FAILED) {
              s10 = peg$parse_();
              s11 = peg$parseKW_AS();
              if (s11 !== peg$FAILED) {
                s12 = peg$parseKW_BASICFILE();
                if (s12 === peg$FAILED) {
                  s12 = peg$parseKW_SECUREFILE();
                }
                if (s12 === peg$FAILED) {
                  s12 = null;
                }
                s13 = peg$parse_();
                s14 = peg$currPos;
                s15 = peg$parseLPAR();
                if (s15 !== peg$FAILED) {
                  s16 = peg$parse_();
                  s17 = peg$parseKW_TABLESPACE();
                  if (s17 !== peg$FAILED) {
                    s18 = peg$parse_();
                    s19 = peg$parseKW_SET();
                    if (s19 !== peg$FAILED) {
                      s20 = peg$parse_();
                      s21 = peg$parseidentifier_name();
                      if (s21 !== peg$FAILED) {
                        s22 = peg$parse_();
                        s23 = peg$parseRPAR();
                        if (s23 !== peg$FAILED) {
                          peg$savedPos = s14;
                          s14 = peg$f31(s1, s5, s12, s21);
                        } else {
                          peg$currPos = s14;
                          s14 = peg$FAILED;
                        }
                      } else {
                        peg$currPos = s14;
                        s14 = peg$FAILED;
                      }
                    } else {
                      peg$currPos = s14;
                      s14 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s14;
                    s14 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s14;
                  s14 = peg$FAILED;
                }
                if (s14 === peg$FAILED) {
                  s14 = peg$currPos;
                  s15 = peg$parseLPAR();
                  if (s15 !== peg$FAILED) {
                    s16 = peg$parse_();
                    s17 = peg$parseKW_TABLESPACE();
                    if (s17 !== peg$FAILED) {
                      s18 = peg$parse_();
                      s19 = peg$parseidentifier_name();
                      if (s19 !== peg$FAILED) {
                        s20 = peg$parse_();
                        s21 = peg$parseRPAR();
                        if (s21 !== peg$FAILED) {
                          peg$savedPos = s14;
                          s14 = peg$f32(s1, s5, s12, s19);
                        } else {
                          peg$currPos = s14;
                          s14 = peg$FAILED;
                        }
                      } else {
                        peg$currPos = s14;
                        s14 = peg$FAILED;
                      }
                    } else {
                      peg$currPos = s14;
                      s14 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s14;
                    s14 = peg$FAILED;
                  }
                  if (s14 === peg$FAILED) {
                    s14 = peg$currPos;
                    s15 = peg$parseidentifier_name();
                    if (s15 !== peg$FAILED) {
                      s16 = peg$parse_();
                      s17 = peg$currPos;
                      s18 = peg$parseLPAR();
                      if (s18 !== peg$FAILED) {
                        s19 = peg$parse_();
                        s20 = peg$parseKW_TABLESPACE();
                        if (s20 !== peg$FAILED) {
                          s21 = peg$parse_();
                          s22 = peg$parseKW_SET();
                          if (s22 !== peg$FAILED) {
                            s23 = peg$parse_();
                            s24 = peg$parseidentifier_name();
                            if (s24 !== peg$FAILED) {
                              s25 = peg$parse_();
                              s26 = peg$parseRPAR();
                              if (s26 !== peg$FAILED) {
                                peg$savedPos = s17;
                                s17 = peg$f33(s1, s5, s12, s15, s24);
                              } else {
                                peg$currPos = s17;
                                s17 = peg$FAILED;
                              }
                            } else {
                              peg$currPos = s17;
                              s17 = peg$FAILED;
                            }
                          } else {
                            peg$currPos = s17;
                            s17 = peg$FAILED;
                          }
                        } else {
                          peg$currPos = s17;
                          s17 = peg$FAILED;
                        }
                      } else {
                        peg$currPos = s17;
                        s17 = peg$FAILED;
                      }
                      if (s17 === peg$FAILED) {
                        s17 = peg$currPos;
                        s18 = peg$parseLPAR();
                        if (s18 !== peg$FAILED) {
                          s19 = peg$parse_();
                          s20 = peg$parseKW_TABLESPACE();
                          if (s20 !== peg$FAILED) {
                            s21 = peg$parse_();
                            s22 = peg$parseidentifier_name();
                            if (s22 !== peg$FAILED) {
                              s23 = peg$parse_();
                              s24 = peg$parseRPAR();
                              if (s24 !== peg$FAILED) {
                                peg$savedPos = s17;
                                s17 = peg$f34(s1, s5, s12, s15, s22);
                              } else {
                                peg$currPos = s17;
                                s17 = peg$FAILED;
                              }
                            } else {
                              peg$currPos = s17;
                              s17 = peg$FAILED;
                            }
                          } else {
                            peg$currPos = s17;
                            s17 = peg$FAILED;
                          }
                        } else {
                          peg$currPos = s17;
                          s17 = peg$FAILED;
                        }
                      }
                      if (s17 === peg$FAILED) {
                        s17 = null;
                      }
                      peg$savedPos = s14;
                      s14 = peg$f35(s1, s5, s12, s15, s17);
                    } else {
                      peg$currPos = s14;
                      s14 = peg$FAILED;
                    }
                  }
                }
                if (s14 === peg$FAILED) {
                  s14 = null;
                }
                peg$savedPos = s0;
                s0 = peg$f36(s1, s5, s12, s14);
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseLOB_storage_clause() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15;

    s0 = peg$currPos;
    s1 = peg$parseKW_LOB();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$currPos;
      s4 = peg$parseLPAR();
      if (s4 !== peg$FAILED) {
        s5 = peg$parse_();
        s6 = peg$parsecomma_separated_identifiers();
        if (s6 !== peg$FAILED) {
          s7 = peg$parse_();
          s8 = peg$parseRPAR();
          if (s8 !== peg$FAILED) {
            s9 = peg$parse_();
            s10 = peg$currPos;
            s11 = peg$parseKW_STORE();
            if (s11 !== peg$FAILED) {
              s12 = peg$parse_();
              s13 = peg$parseKW_AS();
              if (s13 !== peg$FAILED) {
                s14 = peg$parse_();
                s15 = peg$parseLOB_storage_store_as_wo_segname();
                if (s15 !== peg$FAILED) {
                  peg$savedPos = s10;
                  s10 = peg$f37(s1, s6, s15);
                } else {
                  peg$currPos = s10;
                  s10 = peg$FAILED;
                }
              } else {
                peg$currPos = s10;
                s10 = peg$FAILED;
              }
            } else {
              peg$currPos = s10;
              s10 = peg$FAILED;
            }
            if (s10 !== peg$FAILED) {
              peg$savedPos = s3;
              s3 = peg$f38(s1, s6, s10);
            } else {
              peg$currPos = s3;
              s3 = peg$FAILED;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
      if (s3 === peg$FAILED) {
        s3 = peg$currPos;
        s4 = peg$parseLPAR();
        if (s4 !== peg$FAILED) {
          s5 = peg$parse_();
          s6 = peg$parseidentifier_name();
          if (s6 !== peg$FAILED) {
            s7 = peg$parse_();
            s8 = peg$parseRPAR();
            if (s8 !== peg$FAILED) {
              s9 = peg$parse_();
              s10 = peg$currPos;
              s11 = peg$parseKW_STORE();
              if (s11 !== peg$FAILED) {
                s12 = peg$parse_();
                s13 = peg$parseKW_AS();
                if (s13 !== peg$FAILED) {
                  s14 = peg$parse_();
                  s15 = peg$parseLOB_storage_store_as_w_segname();
                  if (s15 !== peg$FAILED) {
                    peg$savedPos = s10;
                    s10 = peg$f39(s1, s6, s15);
                  } else {
                    peg$currPos = s10;
                    s10 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s10;
                  s10 = peg$FAILED;
                }
              } else {
                peg$currPos = s10;
                s10 = peg$FAILED;
              }
              if (s10 !== peg$FAILED) {
                peg$savedPos = s3;
                s3 = peg$f40(s1, s6, s10);
              } else {
                peg$currPos = s3;
                s3 = peg$FAILED;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$FAILED;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      }
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f41(s1, s3);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseLOB_storage_store_as_w_segname() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

    s0 = peg$currPos;
    s1 = [];
    s2 = peg$currPos;
    s3 = peg$parse_();
    s4 = peg$currPos;
    s5 = peg$parseKW_BASICFILE();
    if (s5 !== peg$FAILED) {
      peg$savedPos = s4;
      s5 = peg$f42(s5);
    }
    s4 = s5;
    if (s4 === peg$FAILED) {
      s4 = peg$currPos;
      s5 = peg$parseKW_SECUREFILE();
      if (s5 !== peg$FAILED) {
        peg$savedPos = s4;
        s5 = peg$f43(s5);
      }
      s4 = s5;
      if (s4 === peg$FAILED) {
        s4 = peg$currPos;
        s5 = peg$parseidentifier_name();
        if (s5 !== peg$FAILED) {
          peg$savedPos = s4;
          s5 = peg$f44(s5);
        }
        s4 = s5;
        if (s4 === peg$FAILED) {
          s4 = peg$currPos;
          s5 = peg$parseLPAR();
          if (s5 !== peg$FAILED) {
            s6 = peg$parse_();
            s7 = peg$parseLOB_storage_parameters();
            if (s7 !== peg$FAILED) {
              s8 = peg$parse_();
              s9 = peg$parseRPAR();
              if (s9 !== peg$FAILED) {
                peg$savedPos = s4;
                s4 = peg$f45(s7);
              } else {
                peg$currPos = s4;
                s4 = peg$FAILED;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$FAILED;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$FAILED;
          }
        }
      }
    }
    if (s4 !== peg$FAILED) {
      s5 = peg$parse_();
      peg$savedPos = s2;
      s2 = peg$f46(s4);
    } else {
      peg$currPos = s2;
      s2 = peg$FAILED;
    }
    if (s2 !== peg$FAILED) {
      while (s2 !== peg$FAILED) {
        s1.push(s2);
        s2 = peg$currPos;
        s3 = peg$parse_();
        s4 = peg$currPos;
        s5 = peg$parseKW_BASICFILE();
        if (s5 !== peg$FAILED) {
          peg$savedPos = s4;
          s5 = peg$f42(s5);
        }
        s4 = s5;
        if (s4 === peg$FAILED) {
          s4 = peg$currPos;
          s5 = peg$parseKW_SECUREFILE();
          if (s5 !== peg$FAILED) {
            peg$savedPos = s4;
            s5 = peg$f43(s5);
          }
          s4 = s5;
          if (s4 === peg$FAILED) {
            s4 = peg$currPos;
            s5 = peg$parseidentifier_name();
            if (s5 !== peg$FAILED) {
              peg$savedPos = s4;
              s5 = peg$f44(s5);
            }
            s4 = s5;
            if (s4 === peg$FAILED) {
              s4 = peg$currPos;
              s5 = peg$parseLPAR();
              if (s5 !== peg$FAILED) {
                s6 = peg$parse_();
                s7 = peg$parseLOB_storage_parameters();
                if (s7 !== peg$FAILED) {
                  s8 = peg$parse_();
                  s9 = peg$parseRPAR();
                  if (s9 !== peg$FAILED) {
                    peg$savedPos = s4;
                    s4 = peg$f45(s7);
                  } else {
                    peg$currPos = s4;
                    s4 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s4;
                  s4 = peg$FAILED;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$FAILED;
              }
            }
          }
        }
        if (s4 !== peg$FAILED) {
          s5 = peg$parse_();
          peg$savedPos = s2;
          s2 = peg$f46(s4);
        } else {
          peg$currPos = s2;
          s2 = peg$FAILED;
        }
      }
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f47(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parseLOB_storage_store_as_wo_segname() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

    s0 = peg$currPos;
    s1 = [];
    s2 = peg$currPos;
    s3 = peg$parse_();
    s4 = peg$currPos;
    s5 = peg$parseKW_BASICFILE();
    if (s5 !== peg$FAILED) {
      peg$savedPos = s4;
      s5 = peg$f48(s5);
    }
    s4 = s5;
    if (s4 === peg$FAILED) {
      s4 = peg$currPos;
      s5 = peg$parseKW_SECUREFILE();
      if (s5 !== peg$FAILED) {
        peg$savedPos = s4;
        s5 = peg$f49(s5);
      }
      s4 = s5;
      if (s4 === peg$FAILED) {
        s4 = peg$currPos;
        s5 = peg$parseLPAR();
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parseLOB_storage_parameters();
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            s9 = peg$parseRPAR();
            if (s9 !== peg$FAILED) {
              peg$savedPos = s4;
              s4 = peg$f50(s7);
            } else {
              peg$currPos = s4;
              s4 = peg$FAILED;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$FAILED;
          }
        } else {
          peg$currPos = s4;
          s4 = peg$FAILED;
        }
      }
    }
    if (s4 !== peg$FAILED) {
      s5 = peg$parse_();
      peg$savedPos = s2;
      s2 = peg$f51(s4);
    } else {
      peg$currPos = s2;
      s2 = peg$FAILED;
    }
    if (s2 !== peg$FAILED) {
      while (s2 !== peg$FAILED) {
        s1.push(s2);
        s2 = peg$currPos;
        s3 = peg$parse_();
        s4 = peg$currPos;
        s5 = peg$parseKW_BASICFILE();
        if (s5 !== peg$FAILED) {
          peg$savedPos = s4;
          s5 = peg$f48(s5);
        }
        s4 = s5;
        if (s4 === peg$FAILED) {
          s4 = peg$currPos;
          s5 = peg$parseKW_SECUREFILE();
          if (s5 !== peg$FAILED) {
            peg$savedPos = s4;
            s5 = peg$f49(s5);
          }
          s4 = s5;
          if (s4 === peg$FAILED) {
            s4 = peg$currPos;
            s5 = peg$parseLPAR();
            if (s5 !== peg$FAILED) {
              s6 = peg$parse_();
              s7 = peg$parseLOB_storage_parameters();
              if (s7 !== peg$FAILED) {
                s8 = peg$parse_();
                s9 = peg$parseRPAR();
                if (s9 !== peg$FAILED) {
                  peg$savedPos = s4;
                  s4 = peg$f50(s7);
                } else {
                  peg$currPos = s4;
                  s4 = peg$FAILED;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$FAILED;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$FAILED;
            }
          }
        }
        if (s4 !== peg$FAILED) {
          s5 = peg$parse_();
          peg$savedPos = s2;
          s2 = peg$f51(s4);
        } else {
          peg$currPos = s2;
          s2 = peg$FAILED;
        }
      }
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f52(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parsevarray_col_properties() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8;

    s0 = peg$currPos;
    s1 = peg$parseKW_VARRAY();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseidentifier_name();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$currPos;
        s6 = peg$parsesubstitutable_column_clause();
        if (s6 !== peg$FAILED) {
          peg$savedPos = s5;
          s6 = peg$f53(s1, s3, s6);
        }
        s5 = s6;
        if (s5 === peg$FAILED) {
          s5 = peg$currPos;
          s6 = peg$parsesubstitutable_column_clause();
          if (s6 === peg$FAILED) {
            s6 = null;
          }
          s7 = peg$parse_();
          s8 = peg$parsevarray_storage_clause();
          if (s8 !== peg$FAILED) {
            peg$savedPos = s5;
            s5 = peg$f54(s1, s3, s6, s8);
          } else {
            peg$currPos = s5;
            s5 = peg$FAILED;
          }
        }
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f55(s1, s3, s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsevarray_storage_clause() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16, s17;

    s0 = peg$currPos;
    s1 = peg$parseKW_STORE();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_AS();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseKW_SECUREFILE();
        if (s5 === peg$FAILED) {
          s5 = peg$parseKW_BASICFILE();
        }
        if (s5 === peg$FAILED) {
          s5 = null;
        }
        s6 = peg$parse_();
        s7 = peg$currPos;
        s8 = peg$parseKW_LOB();
        if (s8 !== peg$FAILED) {
          s9 = peg$parse_();
          s10 = peg$currPos;
          s11 = peg$parseidentifier_name();
          if (s11 !== peg$FAILED) {
            peg$savedPos = s10;
            s11 = peg$f56(s5, s11);
          }
          s10 = s11;
          if (s10 === peg$FAILED) {
            s10 = peg$currPos;
            s11 = peg$parseidentifier_name();
            if (s11 === peg$FAILED) {
              s11 = null;
            }
            s12 = peg$parse_();
            s13 = peg$parseLPAR();
            if (s13 !== peg$FAILED) {
              s14 = peg$parse_();
              s15 = peg$parseLOB_storage_parameters();
              if (s15 !== peg$FAILED) {
                s16 = peg$parse_();
                s17 = peg$parseRPAR();
                if (s17 !== peg$FAILED) {
                  peg$savedPos = s10;
                  s10 = peg$f57(s5, s11, s15);
                } else {
                  peg$currPos = s10;
                  s10 = peg$FAILED;
                }
              } else {
                peg$currPos = s10;
                s10 = peg$FAILED;
              }
            } else {
              peg$currPos = s10;
              s10 = peg$FAILED;
            }
          }
          if (s10 !== peg$FAILED) {
            peg$savedPos = s7;
            s7 = peg$f58(s5, s10);
          } else {
            peg$currPos = s7;
            s7 = peg$FAILED;
          }
        } else {
          peg$currPos = s7;
          s7 = peg$FAILED;
        }
        if (s7 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f59(s5, s7);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseLOB_storage_parameters() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

    s0 = peg$parsestorage_clause();
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = [];
      s2 = peg$currPos;
      s3 = peg$parse_();
      s4 = peg$currPos;
      s5 = peg$parseLOB_parameters();
      if (s5 !== peg$FAILED) {
        s6 = peg$parse_();
        s7 = peg$parsestorage_clause();
        if (s7 === peg$FAILED) {
          s7 = null;
        }
        peg$savedPos = s4;
        s4 = peg$f60(s5, s7);
      } else {
        peg$currPos = s4;
        s4 = peg$FAILED;
      }
      if (s4 === peg$FAILED) {
        s4 = peg$currPos;
        s5 = peg$parseKW_TABLESPACE();
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parseKW_SET();
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            s9 = peg$parseidentifier_name();
            if (s9 !== peg$FAILED) {
              peg$savedPos = s4;
              s4 = peg$f61(s9);
            } else {
              peg$currPos = s4;
              s4 = peg$FAILED;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$FAILED;
          }
        } else {
          peg$currPos = s4;
          s4 = peg$FAILED;
        }
        if (s4 === peg$FAILED) {
          s4 = peg$currPos;
          s5 = peg$parseKW_TABLESPACE();
          if (s5 !== peg$FAILED) {
            s6 = peg$parse_();
            s7 = peg$parseidentifier_name();
            if (s7 !== peg$FAILED) {
              peg$savedPos = s4;
              s4 = peg$f62(s7);
            } else {
              peg$currPos = s4;
              s4 = peg$FAILED;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$FAILED;
          }
        }
      }
      if (s4 !== peg$FAILED) {
        s5 = peg$parse_();
        peg$savedPos = s2;
        s2 = peg$f63(s4);
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        while (s2 !== peg$FAILED) {
          s1.push(s2);
          s2 = peg$currPos;
          s3 = peg$parse_();
          s4 = peg$currPos;
          s5 = peg$parseLOB_parameters();
          if (s5 !== peg$FAILED) {
            s6 = peg$parse_();
            s7 = peg$parsestorage_clause();
            if (s7 === peg$FAILED) {
              s7 = null;
            }
            peg$savedPos = s4;
            s4 = peg$f60(s5, s7);
          } else {
            peg$currPos = s4;
            s4 = peg$FAILED;
          }
          if (s4 === peg$FAILED) {
            s4 = peg$currPos;
            s5 = peg$parseKW_TABLESPACE();
            if (s5 !== peg$FAILED) {
              s6 = peg$parse_();
              s7 = peg$parseKW_SET();
              if (s7 !== peg$FAILED) {
                s8 = peg$parse_();
                s9 = peg$parseidentifier_name();
                if (s9 !== peg$FAILED) {
                  peg$savedPos = s4;
                  s4 = peg$f61(s9);
                } else {
                  peg$currPos = s4;
                  s4 = peg$FAILED;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$FAILED;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$FAILED;
            }
            if (s4 === peg$FAILED) {
              s4 = peg$currPos;
              s5 = peg$parseKW_TABLESPACE();
              if (s5 !== peg$FAILED) {
                s6 = peg$parse_();
                s7 = peg$parseidentifier_name();
                if (s7 !== peg$FAILED) {
                  peg$savedPos = s4;
                  s4 = peg$f62(s7);
                } else {
                  peg$currPos = s4;
                  s4 = peg$FAILED;
                }
              } else {
                peg$currPos = s4;
                s4 = peg$FAILED;
              }
            }
          }
          if (s4 !== peg$FAILED) {
            s5 = peg$parse_();
            peg$savedPos = s2;
            s2 = peg$f63(s4);
          } else {
            peg$currPos = s2;
            s2 = peg$FAILED;
          }
        }
      } else {
        s1 = peg$FAILED;
      }
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$f64(s1);
      }
      s0 = s1;
    }

    return s0;
  }

  function peg$parseLOB_parameters() {
    var s0, s1, s2, s3, s4;

    s0 = peg$currPos;
    s1 = [];
    s2 = peg$currPos;
    s3 = peg$parse_();
    s4 = peg$parseLOB_param();
    if (s4 !== peg$FAILED) {
      peg$savedPos = s2;
      s2 = peg$f65(s4);
    } else {
      peg$currPos = s2;
      s2 = peg$FAILED;
    }
    if (s2 !== peg$FAILED) {
      while (s2 !== peg$FAILED) {
        s1.push(s2);
        s2 = peg$currPos;
        s3 = peg$parse_();
        s4 = peg$parseLOB_param();
        if (s4 !== peg$FAILED) {
          peg$savedPos = s2;
          s2 = peg$f65(s4);
        } else {
          peg$currPos = s2;
          s2 = peg$FAILED;
        }
      }
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f66(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parseLOB_param() {
    var s0, s1, s2, s3, s4, s5, s6, s7;

    s0 = peg$currPos;
    s1 = peg$parseKW_CHUNK();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseinteger();
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f67(s3);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseKW_PCTVERSION();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        s3 = peg$parseinteger();
        if (s3 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f68(s3);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseKW_FREEPOOLS();
        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();
          s3 = peg$parseinteger();
          if (s3 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f69(s3);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$parseKW_ENABLE();
          if (s1 === peg$FAILED) {
            s1 = peg$parseKW_DISABLE();
          }
          if (s1 !== peg$FAILED) {
            s2 = peg$parse_();
            s3 = peg$parseKW_STORAGE();
            if (s3 !== peg$FAILED) {
              s4 = peg$parse_();
              s5 = peg$parseKW_IN();
              if (s5 !== peg$FAILED) {
                s6 = peg$parse_();
                s7 = peg$parseKW_ROW();
                if (s7 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s0 = peg$f70(s1);
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$parseKW_ENCRYPT();
            if (s1 !== peg$FAILED) {
              s2 = peg$parse_();
              s3 = peg$parseencryption_spec();
              peg$savedPos = s0;
              s0 = peg$f71(s1, s3);
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
            if (s0 === peg$FAILED) {
              s0 = peg$currPos;
              s1 = peg$parseKW_DECRYPT();
              if (s1 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$f72(s1);
              }
              s0 = s1;
              if (s0 === peg$FAILED) {
                s0 = peg$currPos;
                s1 = peg$parseKW_CACHE();
                if (s1 === peg$FAILED) {
                  s1 = peg$parseKW_NOCACHE();
                  if (s1 === peg$FAILED) {
                    s1 = peg$currPos;
                    s2 = peg$parseKW_CACHE();
                    if (s2 !== peg$FAILED) {
                      s3 = peg$parse_();
                      s4 = peg$parseKW_READS();
                      if (s4 !== peg$FAILED) {
                        peg$savedPos = s1;
                        s1 = peg$f73();
                      } else {
                        peg$currPos = s1;
                        s1 = peg$FAILED;
                      }
                    } else {
                      peg$currPos = s1;
                      s1 = peg$FAILED;
                    }
                  }
                }
                if (s1 !== peg$FAILED) {
                  s2 = peg$parse_();
                  s3 = peg$parselogging_clause();
                  if (s3 === peg$FAILED) {
                    s3 = null;
                  }
                  peg$savedPos = s0;
                  s0 = peg$f74(s1, s3);
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
                if (s0 === peg$FAILED) {
                  s0 = peg$parseLOB_deduplicate_clause();
                  if (s0 === peg$FAILED) {
                    s0 = peg$parseLOB_deduplicate_clause();
                    if (s0 === peg$FAILED) {
                      s0 = peg$parseLOB_compression_clause();
                    }
                  }
                }
              }
            }
          }
        }
      }
    }

    return s0;
  }

  function peg$parseLOB_deduplicate_clause() {
    var s0, s1;

    s0 = peg$currPos;
    s1 = peg$parseKW_DEDUPLICATE();
    if (s1 === peg$FAILED) {
      s1 = peg$parseKW_KEEP_DUPLICATES();
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f75(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parseLOB_retention_clause() {
    var s0, s1, s2, s3, s4, s5, s6;

    s0 = peg$currPos;
    s1 = peg$parseKW_RETENTION();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$currPos;
      s4 = peg$parseKW_MAX();
      if (s4 === peg$FAILED) {
        s4 = peg$parseKW_NONE();
        if (s4 === peg$FAILED) {
          s4 = peg$parseKW_AUTO();
        }
      }
      if (s4 !== peg$FAILED) {
        peg$savedPos = s3;
        s4 = peg$f76(s4);
      }
      s3 = s4;
      if (s3 === peg$FAILED) {
        s3 = peg$currPos;
        s4 = peg$parseKW_MIN();
        if (s4 !== peg$FAILED) {
          s5 = peg$parse_();
          s6 = peg$parseinteger();
          if (s6 !== peg$FAILED) {
            peg$savedPos = s3;
            s3 = peg$f77(s4, s6);
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      }
      if (s3 === peg$FAILED) {
        s3 = null;
      }
      peg$savedPos = s0;
      s0 = peg$f78(s3);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseLOB_compression_clause() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parseKW_NOCOMPRESS();
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f79(s1);
    }
    s0 = s1;
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseKW_COMPRESS();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        s3 = peg$parseKW_LOW();
        if (s3 === peg$FAILED) {
          s3 = peg$parseKW_MEDIUM();
          if (s3 === peg$FAILED) {
            s3 = peg$parseKW_HIGH();
          }
        }
        if (s3 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f80(s1, s3);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    }

    return s0;
  }

  function peg$parseJSON_storage_clause() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16;

    s0 = peg$currPos;
    s1 = peg$parseKW_JSON();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseLPAR();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parsecomma_separated_identifiers();
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parseRPAR();
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            s9 = peg$currPos;
            s10 = peg$parseKW_STORE();
            if (s10 !== peg$FAILED) {
              s11 = peg$parse_();
              s12 = peg$parseKW_AS();
              if (s12 !== peg$FAILED) {
                s13 = peg$parse_();
                s14 = peg$parseidentifier_name();
                if (s14 === peg$FAILED) {
                  s14 = null;
                }
                s15 = peg$parse_();
                s16 = peg$parseJSON_parameters();
                if (s16 === peg$FAILED) {
                  s16 = null;
                }
                peg$savedPos = s9;
                s9 = peg$f81(s1, s5, s14, s16);
              } else {
                peg$currPos = s9;
                s9 = peg$FAILED;
              }
            } else {
              peg$currPos = s9;
              s9 = peg$FAILED;
            }
            if (s9 !== peg$FAILED) {
              peg$savedPos = s0;
              s0 = peg$f82(s1, s5, s9);
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseJSON_parameters() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

    s0 = peg$currPos;
    s1 = peg$parseLPAR();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseJSON_param();
      if (s3 !== peg$FAILED) {
        s4 = [];
        s5 = peg$currPos;
        s6 = peg$parse_();
        s7 = peg$parseCOMMA();
        if (s7 !== peg$FAILED) {
          s8 = peg$parse_();
          s9 = peg$parseJSON_param();
          if (s9 !== peg$FAILED) {
            peg$savedPos = s5;
            s5 = peg$f83(s3, s9);
          } else {
            peg$currPos = s5;
            s5 = peg$FAILED;
          }
        } else {
          peg$currPos = s5;
          s5 = peg$FAILED;
        }
        while (s5 !== peg$FAILED) {
          s4.push(s5);
          s5 = peg$currPos;
          s6 = peg$parse_();
          s7 = peg$parseCOMMA();
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            s9 = peg$parseJSON_param();
            if (s9 !== peg$FAILED) {
              peg$savedPos = s5;
              s5 = peg$f83(s3, s9);
            } else {
              peg$currPos = s5;
              s5 = peg$FAILED;
            }
          } else {
            peg$currPos = s5;
            s5 = peg$FAILED;
          }
        }
        s5 = peg$parse_();
        s6 = peg$parseRPAR();
        if (s6 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f84(s3, s4);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseJSON_param() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parseKW_TABLESPACE();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseidentifier_name();
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f85(s3);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parsestorage_clause();
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$f86(s1);
      }
      s0 = s1;
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseKW_RETENTION();
        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$f87(s1);
        }
        s0 = s1;
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$parseKW_CHUNK();
          if (s1 !== peg$FAILED) {
            s2 = peg$parse_();
            s3 = peg$parseinteger();
            if (s3 !== peg$FAILED) {
              peg$savedPos = s0;
              s0 = peg$f88(s3);
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$parseKW_PCTVERSION();
            if (s1 !== peg$FAILED) {
              s2 = peg$parse_();
              s3 = peg$parseinteger();
              if (s3 !== peg$FAILED) {
                peg$savedPos = s0;
                s0 = peg$f89(s3);
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
            if (s0 === peg$FAILED) {
              s0 = peg$currPos;
              s1 = peg$parseKW_FREEPOOLS();
              if (s1 !== peg$FAILED) {
                s2 = peg$parse_();
                s3 = peg$parseinteger();
                if (s3 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s0 = peg$f90(s3);
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            }
          }
        }
      }
    }

    return s0;
  }

  function peg$parsenested_table_col_properties() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16, s17, s18;

    s0 = peg$currPos;
    s1 = peg$parseKW_NESTED();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_TABLE();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = input.substr(peg$currPos, 12);
        if (s5.toLowerCase() === peg$c0) {
          peg$currPos += 12;
        } else {
          s5 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e0); }
        }
        if (s5 === peg$FAILED) {
          s5 = peg$parseidentifier_name();
        }
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parsesubstitutable_column_clause();
          if (s7 === peg$FAILED) {
            s7 = null;
          }
          s8 = peg$parse_();
          s9 = peg$parseKW_LOCAL();
          if (s9 === peg$FAILED) {
            s9 = peg$parseKW_GLOBAL();
          }
          if (s9 === peg$FAILED) {
            s9 = null;
          }
          s10 = peg$parse_();
          s11 = peg$currPos;
          s12 = peg$parseKW_STORE();
          if (s12 !== peg$FAILED) {
            s13 = peg$parse_();
            s14 = peg$parseKW_AS();
            if (s14 !== peg$FAILED) {
              s15 = peg$parse_();
              s16 = peg$parseidentifier_name();
              if (s16 !== peg$FAILED) {
                s17 = peg$parse_();
                s18 = peg$parsenested_table_col_prop_store_props();
                if (s18 === peg$FAILED) {
                  s18 = null;
                }
                peg$savedPos = s11;
                s11 = peg$f91(s1, s5, s7, s9, s16, s18);
              } else {
                peg$currPos = s11;
                s11 = peg$FAILED;
              }
            } else {
              peg$currPos = s11;
              s11 = peg$FAILED;
            }
          } else {
            peg$currPos = s11;
            s11 = peg$FAILED;
          }
          if (s11 !== peg$FAILED) {
            s12 = peg$parse_();
            s13 = peg$currPos;
            s14 = peg$parseKW_RETURN();
            if (s14 !== peg$FAILED) {
              s15 = peg$parse_();
              s16 = peg$parseKW_AS();
              if (s16 === peg$FAILED) {
                s16 = null;
              }
              s17 = peg$parse_();
              s18 = peg$parseKW_LOCATOR();
              if (s18 === peg$FAILED) {
                s18 = peg$parseKW_VALUE();
              }
              if (s18 !== peg$FAILED) {
                peg$savedPos = s13;
                s13 = peg$f92(s1, s5, s7, s9, s11, s16, s18);
              } else {
                peg$currPos = s13;
                s13 = peg$FAILED;
              }
            } else {
              peg$currPos = s13;
              s13 = peg$FAILED;
            }
            if (s13 !== peg$FAILED) {
              peg$savedPos = s0;
              s0 = peg$f93(s1, s5, s7, s9, s11, s13);
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsenested_table_col_prop_store_props() {
    var s0, s1, s2, s3, s4, s5, s6, s7;

    s0 = peg$currPos;
    s1 = peg$parseLPAR();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = [];
      s4 = peg$currPos;
      s5 = peg$parse_();
      s6 = peg$parsenested_table_col_prop_store_prop();
      if (s6 !== peg$FAILED) {
        s7 = peg$parse_();
        peg$savedPos = s4;
        s4 = peg$f94(s6);
      } else {
        peg$currPos = s4;
        s4 = peg$FAILED;
      }
      if (s4 !== peg$FAILED) {
        while (s4 !== peg$FAILED) {
          s3.push(s4);
          s4 = peg$currPos;
          s5 = peg$parse_();
          s6 = peg$parsenested_table_col_prop_store_prop();
          if (s6 !== peg$FAILED) {
            s7 = peg$parse_();
            peg$savedPos = s4;
            s4 = peg$f94(s6);
          } else {
            peg$currPos = s4;
            s4 = peg$FAILED;
          }
        }
      } else {
        s3 = peg$FAILED;
      }
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseRPAR();
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f95(s3);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsenested_table_col_prop_store_prop() {
    var s0, s1, s2, s3, s4, s5;

    s0 = peg$currPos;
    s1 = peg$parseLPAR();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseobject_properties();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseRPAR();
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f96(s3);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parsephysical_properties();
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$f97(s1);
      }
      s0 = s1;
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parsecolumn_properties();
        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$f98(s1);
        }
        s0 = s1;
      }
    }

    return s0;
  }

  function peg$parseobject_properties() {
    var s0, s1, s2, s3, s4, s5, s6;

    s0 = peg$currPos;
    s1 = peg$parseidentifier_name();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$currPos;
      s4 = peg$parseKW_DEFAULT();
      if (s4 !== peg$FAILED) {
        s5 = peg$parse_();
        s6 = peg$parseinteger();
        if (s6 !== peg$FAILED) {
          peg$savedPos = s3;
          s3 = peg$f99(s1, s6);
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
      if (s3 === peg$FAILED) {
        s3 = null;
      }
      s4 = peg$parse_();
      s5 = peg$parsecolumn_constraints();
      if (s5 === peg$FAILED) {
        s5 = null;
      }
      peg$savedPos = s0;
      s0 = peg$f100(s1, s3, s5);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$parseout_of_line_constraint();
      if (s0 === peg$FAILED) {
        s0 = peg$parseout_of_line_ref_constraint();
        if (s0 === peg$FAILED) {
          s0 = peg$parsesupplemental_logging_props();
        }
      }
    }

    return s0;
  }

  function peg$parseobject_type_col_properties() {
    var s0, s1, s2, s3, s4, s5;

    s0 = peg$currPos;
    s1 = peg$parseKW_COLUMN();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseidentifier_name();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parsesubstitutable_column_clause();
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f101(s3, s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsesubstitutable_column_clause() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15;

    s0 = peg$currPos;
    s1 = peg$parseKW_NOT();
    if (s1 === peg$FAILED) {
      s1 = null;
    }
    s2 = peg$parse_();
    s3 = peg$parseKW_SUBSTITUTABLE();
    if (s3 !== peg$FAILED) {
      s4 = peg$parse_();
      s5 = peg$parseKW_AT();
      if (s5 !== peg$FAILED) {
        s6 = peg$parse_();
        s7 = peg$parseKW_ALL();
        if (s7 !== peg$FAILED) {
          s8 = peg$parse_();
          s9 = peg$parseKW_LEVELS();
          if (s9 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f102(s1, s3);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseKW_ELEMENT();
      if (s1 === peg$FAILED) {
        s1 = null;
      }
      s2 = peg$parse_();
      s3 = peg$parseKW_IS();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseKW_OF();
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parseKW_TYPE();
          if (s7 === peg$FAILED) {
            s7 = null;
          }
          s8 = peg$parse_();
          s9 = peg$parseLPAR();
          if (s9 !== peg$FAILED) {
            s10 = peg$parse_();
            s11 = peg$parseKW_ONLY();
            if (s11 !== peg$FAILED) {
              s12 = peg$parse_();
              s13 = peg$parseidentifier_name();
              if (s13 !== peg$FAILED) {
                s14 = peg$parse_();
                s15 = peg$parseRPAR();
                if (s15 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s0 = peg$f103(s1, s13);
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    }

    return s0;
  }

  function peg$parsephysical_properties() {
    var s0;

    s0 = peg$parsephysical_properties_1();
    if (s0 === peg$FAILED) {
      s0 = peg$parsephysical_properties_2();
      if (s0 === peg$FAILED) {
        s0 = peg$parsephysical_properties_3();
      }
    }

    return s0;
  }

  function peg$parsephysical_properties_1() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10;

    s0 = peg$currPos;
    s1 = peg$parsedeferred_segment_creation();
    if (s1 === peg$FAILED) {
      s1 = null;
    }
    s2 = peg$parse_();
    s3 = peg$parsesegment_attributes_clause();
    if (s3 !== peg$FAILED) {
      s4 = peg$parse_();
      s5 = peg$parsetable_compression();
      if (s5 === peg$FAILED) {
        s5 = null;
      }
      s6 = peg$parse_();
      s7 = peg$parseinmemory_table_clause();
      s8 = peg$parse_();
      s9 = peg$parseilm_clause();
      if (s9 === peg$FAILED) {
        s9 = null;
      }
      s10 = peg$parse_();
      peg$savedPos = s0;
      s0 = peg$f104(s1, s3, s5, s7, s9);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsephysical_properties_2() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15;

    s0 = peg$currPos;
    s1 = peg$parsedeferred_segment_creation();
    if (s1 === peg$FAILED) {
      s1 = null;
    }
    s2 = peg$parse_();
    s3 = peg$currPos;
    s4 = peg$parseKW_EXTERNAL();
    if (s4 !== peg$FAILED) {
      s5 = peg$parse_();
      s6 = peg$parseKW_PARTITION();
      if (s6 !== peg$FAILED) {
        s7 = peg$parse_();
        s8 = peg$parseKW_ATTRIBUTES();
        if (s8 !== peg$FAILED) {
          s9 = peg$parse_();
          s10 = peg$parseexternal_table_clause();
          if (s10 !== peg$FAILED) {
            s11 = peg$parse_();
            s12 = peg$currPos;
            s13 = peg$parseKW_REJECT();
            if (s13 !== peg$FAILED) {
              s14 = peg$parse_();
              s15 = peg$parseKW_LIMIT();
              if (s15 !== peg$FAILED) {
                peg$savedPos = s12;
                s12 = peg$f105(s1, s4, s6, s8, s10);
              } else {
                peg$currPos = s12;
                s12 = peg$FAILED;
              }
            } else {
              peg$currPos = s12;
              s12 = peg$FAILED;
            }
            if (s12 === peg$FAILED) {
              s12 = null;
            }
            peg$savedPos = s3;
            s3 = peg$f106(s1, s4, s6, s8, s10, s12);
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
    } else {
      peg$currPos = s3;
      s3 = peg$FAILED;
    }
    if (s3 === peg$FAILED) {
      s3 = peg$currPos;
      s4 = peg$currPos;
      s5 = peg$parseKW_ORGANIZATION();
      if (s5 !== peg$FAILED) {
        s6 = peg$parse_();
        s7 = peg$parsephysical_properties_organization();
        if (s7 !== peg$FAILED) {
          peg$savedPos = s4;
          s4 = peg$f107(s1, s7);
        } else {
          peg$currPos = s4;
          s4 = peg$FAILED;
        }
      } else {
        peg$currPos = s4;
        s4 = peg$FAILED;
      }
      if (s4 !== peg$FAILED) {
        peg$savedPos = s3;
        s4 = peg$f108(s1, s4);
      }
      s3 = s4;
    }
    if (s3 !== peg$FAILED) {
      peg$savedPos = s0;
      s0 = peg$f109(s1, s3);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsephysical_properties_organization() {
    var s0, s1, s2, s3, s4, s5;

    s0 = peg$currPos;
    s1 = peg$parseKW_EXTERNAL();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseexternal_table_clause();
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f110(s1, s3);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseKW_HEAP();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        s3 = peg$parsesegment_attributes_clause();
        if (s3 === peg$FAILED) {
          s3 = null;
        }
        s4 = peg$parse_();
        s5 = peg$parseheap_org_table_clause();
        peg$savedPos = s0;
        s0 = peg$f111(s1, s3, s5);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseKW_INDEX();
        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();
          s3 = peg$parsesegment_attributes_clause();
          if (s3 === peg$FAILED) {
            s3 = null;
          }
          s4 = peg$parse_();
          s5 = peg$parseindex_org_table_clause();
          peg$savedPos = s0;
          s0 = peg$f112(s1, s3, s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      }
    }

    return s0;
  }

  function peg$parseindex_org_table_clause() {
    var s0, s1, s2, s3, s4, s5;

    s0 = peg$currPos;
    s1 = [];
    s2 = peg$currPos;
    s3 = peg$parse_();
    s4 = peg$parseindex_org_table_option();
    if (s4 !== peg$FAILED) {
      s5 = peg$parse_();
      peg$savedPos = s2;
      s2 = peg$f113(s4);
    } else {
      peg$currPos = s2;
      s2 = peg$FAILED;
    }
    while (s2 !== peg$FAILED) {
      s1.push(s2);
      s2 = peg$currPos;
      s3 = peg$parse_();
      s4 = peg$parseindex_org_table_option();
      if (s4 !== peg$FAILED) {
        s5 = peg$parse_();
        peg$savedPos = s2;
        s2 = peg$f113(s4);
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
    }
    s2 = peg$parse_();
    s3 = peg$parseindex_org_overflow_clause();
    if (s3 === peg$FAILED) {
      s3 = null;
    }
    peg$savedPos = s0;
    s0 = peg$f114(s1, s3);

    return s0;
  }

  function peg$parseindex_org_overflow_clause() {
    var s0, s1, s2, s3, s4, s5;

    s0 = peg$currPos;
    s1 = peg$currPos;
    s2 = peg$parseKW_INCLUDING();
    if (s2 !== peg$FAILED) {
      s3 = peg$parse_();
      s4 = peg$parseidentifier_name();
      if (s4 !== peg$FAILED) {
        peg$savedPos = s1;
        s1 = peg$f115(s4);
      } else {
        peg$currPos = s1;
        s1 = peg$FAILED;
      }
    } else {
      peg$currPos = s1;
      s1 = peg$FAILED;
    }
    if (s1 === peg$FAILED) {
      s1 = null;
    }
    s2 = peg$parse_();
    s3 = peg$parseKW_OVERFLOW();
    if (s3 !== peg$FAILED) {
      s4 = peg$parse_();
      s5 = peg$parsesegment_attributes_clause();
      if (s5 === peg$FAILED) {
        s5 = null;
      }
      peg$savedPos = s0;
      s0 = peg$f116(s1, s5);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseindex_org_table_option() {
    var s0, s1, s2, s3;

    s0 = peg$parsemapping_table_clause();
    if (s0 === peg$FAILED) {
      s0 = peg$parseprefix_compression();
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseKW_PCTTHRESHOLD();
        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();
          s3 = peg$parseinteger();
          if (s3 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f117(s1, s3);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      }
    }

    return s0;
  }

  function peg$parseprefix_compression() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parseKW_COMPRESS();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseinteger();
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f118(s1, s3);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseKW_NOCOMPRESS();
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$f119(s1);
      }
      s0 = s1;
    }

    return s0;
  }

  function peg$parsemapping_table_clause() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parseKW_MAPPING();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_TABLE();
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f120(s1, s3);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseKW_NOMAPPING();
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$f121(s1);
      }
      s0 = s1;
    }

    return s0;
  }

  function peg$parseheap_org_table_clause() {
    var s0, s1, s2, s3, s4, s5, s6;

    s0 = peg$currPos;
    s1 = peg$parsetable_compression();
    if (s1 === peg$FAILED) {
      s1 = null;
    }
    s2 = peg$parse_();
    s3 = peg$parseinmemory_table_clause();
    s4 = peg$parse_();
    s5 = peg$parseilm_clause();
    if (s5 === peg$FAILED) {
      s5 = null;
    }
    s6 = peg$parse_();
    peg$savedPos = s0;
    s0 = peg$f122(s1, s3, s5);

    return s0;
  }

  function peg$parseexternal_table_clause() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14;

    s0 = peg$currPos;
    s1 = peg$parseLPAR();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$currPos;
      s4 = peg$parseKW_TYPE();
      if (s4 !== peg$FAILED) {
        s5 = peg$parse_();
        s6 = peg$parseidentifier_name();
        if (s6 !== peg$FAILED) {
          peg$savedPos = s3;
          s3 = peg$f123(s6);
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
      if (s3 === peg$FAILED) {
        s3 = null;
      }
      s4 = peg$parse_();
      s5 = peg$parseexternal_table_data_props();
      s6 = peg$parse_();
      s7 = peg$parseRPAR();
      if (s7 !== peg$FAILED) {
        s8 = peg$parse_();
        s9 = peg$currPos;
        s10 = peg$parseKW_REJECT();
        if (s10 !== peg$FAILED) {
          s11 = peg$parse_();
          s12 = peg$parseKW_LIMIT();
          if (s12 !== peg$FAILED) {
            s13 = peg$parse_();
            s14 = peg$parseKW_UNLIMITED();
            if (s14 === peg$FAILED) {
              s14 = peg$parseinteger();
            }
            if (s14 !== peg$FAILED) {
              peg$savedPos = s9;
              s9 = peg$f124(s3, s5, s14);
            } else {
              peg$currPos = s9;
              s9 = peg$FAILED;
            }
          } else {
            peg$currPos = s9;
            s9 = peg$FAILED;
          }
        } else {
          peg$currPos = s9;
          s9 = peg$FAILED;
        }
        if (s9 === peg$FAILED) {
          s9 = null;
        }
        s10 = peg$parse_();
        s11 = peg$parseinmemory_table_clause();
        s12 = peg$parse_();
        peg$savedPos = s0;
        s0 = peg$f125(s3, s5, s9, s11);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseexternal_table_data_props() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12;

    s0 = peg$currPos;
    s1 = peg$currPos;
    s2 = peg$parseKW_DEFAULT();
    if (s2 !== peg$FAILED) {
      s3 = peg$parse_();
      s4 = peg$parseKW_DIRECTORY();
      if (s4 !== peg$FAILED) {
        s5 = peg$parse_();
        s6 = peg$parseidentifier_name();
        if (s6 !== peg$FAILED) {
          peg$savedPos = s1;
          s1 = peg$f126(s6);
        } else {
          peg$currPos = s1;
          s1 = peg$FAILED;
        }
      } else {
        peg$currPos = s1;
        s1 = peg$FAILED;
      }
    } else {
      peg$currPos = s1;
      s1 = peg$FAILED;
    }
    if (s1 === peg$FAILED) {
      s1 = null;
    }
    s2 = peg$parse_();
    s3 = peg$currPos;
    s4 = peg$parseKW_ACCESS();
    if (s4 !== peg$FAILED) {
      s5 = peg$parse_();
      s6 = peg$parseKW_PARAMETERS();
      if (s6 !== peg$FAILED) {
        s7 = peg$parse_();
        s8 = peg$parseexternal_table_data_prop_access_param();
        if (s8 !== peg$FAILED) {
          peg$savedPos = s3;
          s3 = peg$f127(s1, s8);
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
    } else {
      peg$currPos = s3;
      s3 = peg$FAILED;
    }
    if (s3 === peg$FAILED) {
      s3 = null;
    }
    s4 = peg$parse_();
    s5 = peg$currPos;
    s6 = peg$parseKW_LOCATION();
    if (s6 !== peg$FAILED) {
      s7 = peg$parse_();
      s8 = peg$parseLPAR();
      if (s8 !== peg$FAILED) {
        s9 = peg$parse_();
        s10 = peg$parseexternal_table_data_prop_dirs();
        if (s10 !== peg$FAILED) {
          s11 = peg$parse_();
          s12 = peg$parseRPAR();
          if (s12 !== peg$FAILED) {
            peg$savedPos = s5;
            s5 = peg$f128(s1, s3, s10);
          } else {
            peg$currPos = s5;
            s5 = peg$FAILED;
          }
        } else {
          peg$currPos = s5;
          s5 = peg$FAILED;
        }
      } else {
        peg$currPos = s5;
        s5 = peg$FAILED;
      }
    } else {
      peg$currPos = s5;
      s5 = peg$FAILED;
    }
    if (s5 === peg$FAILED) {
      s5 = null;
    }
    s6 = peg$parse_();
    peg$savedPos = s0;
    s0 = peg$f129(s1, s3, s5);

    return s0;
  }

  function peg$parseexternal_table_data_prop_dirs() {
    var s0, s1, s2, s3, s4, s5, s6, s7;

    s0 = peg$currPos;
    s1 = peg$parseexternal_table_data_prop_dir();
    if (s1 !== peg$FAILED) {
      s2 = [];
      s3 = peg$currPos;
      s4 = peg$parse_();
      s5 = peg$parseCOMMA();
      if (s5 !== peg$FAILED) {
        s6 = peg$parse_();
        s7 = peg$parseexternal_table_data_prop_dir();
        if (s7 !== peg$FAILED) {
          peg$savedPos = s3;
          s3 = peg$f130(s1, s7);
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
      while (s3 !== peg$FAILED) {
        s2.push(s3);
        s3 = peg$currPos;
        s4 = peg$parse_();
        s5 = peg$parseCOMMA();
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parseexternal_table_data_prop_dir();
          if (s7 !== peg$FAILED) {
            peg$savedPos = s3;
            s3 = peg$f130(s1, s7);
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      }
      peg$savedPos = s0;
      s0 = peg$f131(s1, s2);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseexternal_table_data_prop_dir() {
    var s0, s1, s2, s3, s4, s5, s6, s7;

    s0 = peg$currPos;
    s1 = peg$currPos;
    s2 = peg$parseidentifier_name();
    if (s2 !== peg$FAILED) {
      s3 = peg$parse_();
      s4 = peg$parseCOLON();
      if (s4 !== peg$FAILED) {
        s5 = peg$parse_();
        peg$savedPos = s1;
        s1 = peg$f132(s2);
      } else {
        peg$currPos = s1;
        s1 = peg$FAILED;
      }
    } else {
      peg$currPos = s1;
      s1 = peg$FAILED;
    }
    if (s1 === peg$FAILED) {
      s1 = null;
    }
    s2 = peg$parse_();
    s3 = peg$parseSQUO();
    if (s3 !== peg$FAILED) {
      s4 = peg$parse_();
      s5 = peg$parseany();
      if (s5 !== peg$FAILED) {
        s6 = peg$parse_();
        s7 = peg$parseSQUO();
        if (s7 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f133(s1, s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseexternal_table_data_prop_access_param() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

    s0 = peg$currPos;
    s1 = peg$parseLPAR();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseSQUO();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        if (input.substr(peg$currPos, 18) === peg$c1) {
          s5 = peg$c1;
          peg$currPos += 18;
        } else {
          s5 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e1); }
        }
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parseSQUO();
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            s9 = peg$parseRPAR();
            if (s9 !== peg$FAILED) {
              peg$savedPos = s0;
              s0 = peg$f134(s5);
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseLPAR();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (input.substr(peg$currPos, 18) === peg$c1) {
          s3 = peg$c1;
          peg$currPos += 18;
        } else {
          s3 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e1); }
        }
        if (s3 !== peg$FAILED) {
          s4 = peg$parse_();
          s5 = peg$parseRPAR();
          if (s5 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f135(s3);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseKW_USING();
        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();
          s3 = peg$parseKW_CLOB();
          if (s3 !== peg$FAILED) {
            s4 = peg$parse_();
            s5 = peg$parsesubquery();
            peg$savedPos = s0;
            s0 = peg$f136(s3, s5);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      }
    }

    return s0;
  }

  function peg$parsephysical_properties_3() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

    s0 = peg$currPos;
    s1 = peg$parseKW_CLUSTER();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseidentifier_name();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseLPAR();
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parsecomma_separated_identifiers();
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            s9 = peg$parseRPAR();
            if (s9 !== peg$FAILED) {
              peg$savedPos = s0;
              s0 = peg$f137(s3, s7);
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseilm_clause() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8;

    s0 = peg$currPos;
    s1 = peg$parseKW_ILM();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$currPos;
      s4 = peg$parseKW_ADD();
      if (s4 !== peg$FAILED) {
        s5 = peg$parse_();
        s6 = peg$parseKW_POLICY();
        if (s6 !== peg$FAILED) {
          s7 = peg$parse_();
          s8 = peg$parseilm_policy_clause();
          if (s8 !== peg$FAILED) {
            peg$savedPos = s3;
            s3 = peg$f138(s4, s6, s8);
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
      if (s3 === peg$FAILED) {
        s3 = peg$currPos;
        s4 = peg$parseKW_DELETE();
        if (s4 === peg$FAILED) {
          s4 = peg$parseKW_DISABLE();
          if (s4 === peg$FAILED) {
            s4 = peg$parseKW_ENABLE();
          }
        }
        if (s4 !== peg$FAILED) {
          s5 = peg$parse_();
          s6 = peg$parseKW_POLICY();
          if (s6 !== peg$FAILED) {
            s7 = peg$parse_();
            s8 = peg$parseidentifier_name();
            if (s8 !== peg$FAILED) {
              peg$savedPos = s3;
              s3 = peg$f139(s4, s8);
            } else {
              peg$currPos = s3;
              s3 = peg$FAILED;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
        if (s3 === peg$FAILED) {
          s3 = peg$currPos;
          s4 = peg$parseKW_DELETE_ALL();
          if (s4 === peg$FAILED) {
            s4 = peg$parseKW_ENABLE_ALL();
            if (s4 === peg$FAILED) {
              s4 = peg$parseKW_DISABLE_ALL();
            }
          }
          if (s4 !== peg$FAILED) {
            peg$savedPos = s3;
            s4 = peg$f140(s4);
          }
          s3 = s4;
        }
      }
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f141(s3);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseilm_policy_clause() {
    var s0;

    s0 = peg$parseilm_compression_policy();
    if (s0 === peg$FAILED) {
      s0 = peg$parseilm_tiering_policy();
      if (s0 === peg$FAILED) {
        s0 = peg$parseilm_inmemory_policy();
      }
    }

    return s0;
  }

  function peg$parseilm_inmemory_policy() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15;

    s0 = peg$currPos;
    s1 = peg$currPos;
    s2 = peg$parseKW_SET();
    if (s2 !== peg$FAILED) {
      s3 = peg$parse_();
      s4 = peg$parseKW_INMEMORY();
      if (s4 !== peg$FAILED) {
        s5 = peg$parse_();
        s6 = peg$parseinmemory_attributes();
        peg$savedPos = s1;
        s1 = peg$f142(s2, s6);
      } else {
        peg$currPos = s1;
        s1 = peg$FAILED;
      }
    } else {
      peg$currPos = s1;
      s1 = peg$FAILED;
    }
    if (s1 === peg$FAILED) {
      s1 = peg$currPos;
      s2 = peg$parseKW_MODIFY();
      if (s2 !== peg$FAILED) {
        s3 = peg$parse_();
        s4 = peg$parseKW_INMEMORY();
        if (s4 !== peg$FAILED) {
          s5 = peg$parse_();
          s6 = peg$parseinmemory_memcompress();
          if (s6 !== peg$FAILED) {
            peg$savedPos = s1;
            s1 = peg$f143(s2, s6);
          } else {
            peg$currPos = s1;
            s1 = peg$FAILED;
          }
        } else {
          peg$currPos = s1;
          s1 = peg$FAILED;
        }
      } else {
        peg$currPos = s1;
        s1 = peg$FAILED;
      }
      if (s1 === peg$FAILED) {
        s1 = peg$currPos;
        s2 = peg$parseKW_NO();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          s4 = peg$parseKW_INMEMORY();
          if (s4 !== peg$FAILED) {
            peg$savedPos = s1;
            s1 = peg$f144(s2);
          } else {
            peg$currPos = s1;
            s1 = peg$FAILED;
          }
        } else {
          peg$currPos = s1;
          s1 = peg$FAILED;
        }
      }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_SEGMENT();
      if (s3 === peg$FAILED) {
        s3 = null;
      }
      s4 = peg$parse_();
      s5 = peg$currPos;
      s6 = peg$parseKW_ON();
      if (s6 !== peg$FAILED) {
        s7 = peg$parse_();
        s8 = peg$parseidentifier_name();
        if (s8 !== peg$FAILED) {
          peg$savedPos = s5;
          s5 = peg$f145(s1, s3, s6, s8);
        } else {
          peg$currPos = s5;
          s5 = peg$FAILED;
        }
      } else {
        peg$currPos = s5;
        s5 = peg$FAILED;
      }
      if (s5 === peg$FAILED) {
        s5 = peg$currPos;
        s6 = peg$parseKW_AFTER();
        if (s6 !== peg$FAILED) {
          s7 = peg$parse_();
          s8 = peg$parseilm_time_period();
          if (s8 !== peg$FAILED) {
            s9 = peg$parse_();
            s10 = peg$parseKW_OF();
            if (s10 !== peg$FAILED) {
              s11 = peg$parse_();
              s12 = peg$currPos;
              s13 = peg$parseKW_NO();
              if (s13 !== peg$FAILED) {
                s14 = peg$parse_();
                s15 = peg$parseKW_ACCESS();
                if (s15 !== peg$FAILED) {
                  peg$savedPos = s12;
                  s12 = peg$f146(s1, s3, s6, s8);
                } else {
                  peg$currPos = s12;
                  s12 = peg$FAILED;
                }
              } else {
                peg$currPos = s12;
                s12 = peg$FAILED;
              }
              if (s12 === peg$FAILED) {
                s12 = peg$currPos;
                s13 = peg$parseKW_NO();
                if (s13 !== peg$FAILED) {
                  s14 = peg$parse_();
                  s15 = peg$parseKW_MODIFICATION();
                  if (s15 !== peg$FAILED) {
                    peg$savedPos = s12;
                    s12 = peg$f147(s1, s3, s6, s8);
                  } else {
                    peg$currPos = s12;
                    s12 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s12;
                  s12 = peg$FAILED;
                }
                if (s12 === peg$FAILED) {
                  s12 = peg$parseKW_CREATION();
                }
              }
              if (s12 !== peg$FAILED) {
                peg$savedPos = s5;
                s5 = peg$f148(s1, s3, s6, s8, s12);
              } else {
                peg$currPos = s5;
                s5 = peg$FAILED;
              }
            } else {
              peg$currPos = s5;
              s5 = peg$FAILED;
            }
          } else {
            peg$currPos = s5;
            s5 = peg$FAILED;
          }
        } else {
          peg$currPos = s5;
          s5 = peg$FAILED;
        }
      }
      if (s5 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f149(s1, s3, s5);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseilm_tiering_policy() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16, s17, s18, s19, s20, s21, s22, s23, s24;

    s0 = peg$currPos;
    s1 = peg$parseKW_TIER();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_TO();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseidentifier_name();
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$currPos;
          s8 = peg$parseKW_READ();
          if (s8 !== peg$FAILED) {
            s9 = peg$parse_();
            s10 = peg$parseKW_ONLY();
            if (s10 !== peg$FAILED) {
              s11 = peg$parse_();
              s12 = peg$parseKW_SEGMENT();
              if (s12 === peg$FAILED) {
                s12 = peg$parseKW_GROUP();
              }
              if (s12 === peg$FAILED) {
                s12 = null;
              }
              s13 = peg$parse_();
              s14 = peg$currPos;
              s15 = peg$parseKW_ON();
              if (s15 !== peg$FAILED) {
                s16 = peg$parse_();
                s17 = peg$parseidentifier_name();
                if (s17 !== peg$FAILED) {
                  peg$savedPos = s14;
                  s14 = peg$f150(s5, s12, s15, s17);
                } else {
                  peg$currPos = s14;
                  s14 = peg$FAILED;
                }
              } else {
                peg$currPos = s14;
                s14 = peg$FAILED;
              }
              if (s14 === peg$FAILED) {
                s14 = peg$currPos;
                s15 = peg$parseKW_AFTER();
                if (s15 !== peg$FAILED) {
                  s16 = peg$parse_();
                  s17 = peg$parseilm_time_period();
                  if (s17 !== peg$FAILED) {
                    s18 = peg$parse_();
                    s19 = peg$parseKW_OF();
                    if (s19 !== peg$FAILED) {
                      s20 = peg$parse_();
                      s21 = peg$currPos;
                      s22 = peg$parseKW_NO();
                      if (s22 !== peg$FAILED) {
                        s23 = peg$parse_();
                        s24 = peg$parseKW_ACCESS();
                        if (s24 !== peg$FAILED) {
                          peg$savedPos = s21;
                          s21 = peg$f151(s5, s12, s15, s17);
                        } else {
                          peg$currPos = s21;
                          s21 = peg$FAILED;
                        }
                      } else {
                        peg$currPos = s21;
                        s21 = peg$FAILED;
                      }
                      if (s21 === peg$FAILED) {
                        s21 = peg$currPos;
                        s22 = peg$parseKW_NO();
                        if (s22 !== peg$FAILED) {
                          s23 = peg$parse_();
                          s24 = peg$parseKW_MODIFICATION();
                          if (s24 !== peg$FAILED) {
                            peg$savedPos = s21;
                            s21 = peg$f152(s5, s12, s15, s17);
                          } else {
                            peg$currPos = s21;
                            s21 = peg$FAILED;
                          }
                        } else {
                          peg$currPos = s21;
                          s21 = peg$FAILED;
                        }
                        if (s21 === peg$FAILED) {
                          s21 = peg$parseKW_CREATION();
                        }
                      }
                      if (s21 !== peg$FAILED) {
                        peg$savedPos = s14;
                        s14 = peg$f153(s5, s12, s15, s17, s21);
                      } else {
                        peg$currPos = s14;
                        s14 = peg$FAILED;
                      }
                    } else {
                      peg$currPos = s14;
                      s14 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s14;
                    s14 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s14;
                  s14 = peg$FAILED;
                }
              }
              if (s14 === peg$FAILED) {
                s14 = null;
              }
              peg$savedPos = s7;
              s7 = peg$f154(s5, s12, s14);
            } else {
              peg$currPos = s7;
              s7 = peg$FAILED;
            }
          } else {
            peg$currPos = s7;
            s7 = peg$FAILED;
          }
          if (s7 === peg$FAILED) {
            s7 = peg$currPos;
            s8 = peg$parseKW_SEGMENT();
            if (s8 === peg$FAILED) {
              s8 = peg$parseKW_GROUP();
            }
            if (s8 === peg$FAILED) {
              s8 = null;
            }
            s9 = peg$parse_();
            s10 = peg$currPos;
            s11 = peg$parseKW_ON();
            if (s11 !== peg$FAILED) {
              s12 = peg$parse_();
              s13 = peg$parseidentifier_name();
              if (s13 !== peg$FAILED) {
                peg$savedPos = s10;
                s10 = peg$f155(s5, s8, s11, s13);
              } else {
                peg$currPos = s10;
                s10 = peg$FAILED;
              }
            } else {
              peg$currPos = s10;
              s10 = peg$FAILED;
            }
            if (s10 === peg$FAILED) {
              s10 = null;
            }
            peg$savedPos = s7;
            s7 = peg$f156(s5, s8, s10);
          }
          if (s7 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f157(s5, s7);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseilm_compression_policy() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15;

    s0 = peg$currPos;
    s1 = peg$parsetable_compression();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_SEGMENT();
      if (s3 === peg$FAILED) {
        s3 = peg$parseKW_GROUP();
      }
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$currPos;
        s6 = peg$parseKW_ON();
        if (s6 !== peg$FAILED) {
          s7 = peg$parse_();
          s8 = peg$parseidentifier_name();
          if (s8 !== peg$FAILED) {
            peg$savedPos = s5;
            s5 = peg$f158(s1, s3, s6, s8);
          } else {
            peg$currPos = s5;
            s5 = peg$FAILED;
          }
        } else {
          peg$currPos = s5;
          s5 = peg$FAILED;
        }
        if (s5 === peg$FAILED) {
          s5 = peg$currPos;
          s6 = peg$parseKW_AFTER();
          if (s6 !== peg$FAILED) {
            s7 = peg$parse_();
            s8 = peg$parseilm_time_period();
            if (s8 !== peg$FAILED) {
              s9 = peg$parse_();
              s10 = peg$parseKW_OF();
              if (s10 !== peg$FAILED) {
                s11 = peg$parse_();
                s12 = peg$currPos;
                s13 = peg$parseKW_NO();
                if (s13 !== peg$FAILED) {
                  s14 = peg$parse_();
                  s15 = peg$parseKW_ACCESS();
                  if (s15 !== peg$FAILED) {
                    peg$savedPos = s12;
                    s12 = peg$f159(s1, s3, s6, s8);
                  } else {
                    peg$currPos = s12;
                    s12 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s12;
                  s12 = peg$FAILED;
                }
                if (s12 === peg$FAILED) {
                  s12 = peg$currPos;
                  s13 = peg$parseKW_NO();
                  if (s13 !== peg$FAILED) {
                    s14 = peg$parse_();
                    s15 = peg$parseKW_MODIFICATION();
                    if (s15 !== peg$FAILED) {
                      peg$savedPos = s12;
                      s12 = peg$f160(s1, s3, s6, s8);
                    } else {
                      peg$currPos = s12;
                      s12 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s12;
                    s12 = peg$FAILED;
                  }
                  if (s12 === peg$FAILED) {
                    s12 = peg$parseKW_CREATION();
                  }
                }
                if (s12 !== peg$FAILED) {
                  peg$savedPos = s5;
                  s5 = peg$f161(s1, s3, s6, s8, s12);
                } else {
                  peg$currPos = s5;
                  s5 = peg$FAILED;
                }
              } else {
                peg$currPos = s5;
                s5 = peg$FAILED;
              }
            } else {
              peg$currPos = s5;
              s5 = peg$FAILED;
            }
          } else {
            peg$currPos = s5;
            s5 = peg$FAILED;
          }
        }
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f162(s1, s3, s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$currPos;
      s2 = peg$parseKW_ROW();
      if (s2 !== peg$FAILED) {
        s3 = peg$parse_();
        s4 = peg$parseKW_STORE();
        if (s4 !== peg$FAILED) {
          s5 = peg$parse_();
          s6 = peg$parseKW_COMPRESS();
          if (s6 !== peg$FAILED) {
            s7 = peg$parse_();
            s8 = peg$parseKW_ADVANCED();
            if (s8 !== peg$FAILED) {
              peg$savedPos = s1;
              s1 = peg$f163(s2, s8);
            } else {
              peg$currPos = s1;
              s1 = peg$FAILED;
            }
          } else {
            peg$currPos = s1;
            s1 = peg$FAILED;
          }
        } else {
          peg$currPos = s1;
          s1 = peg$FAILED;
        }
      } else {
        peg$currPos = s1;
        s1 = peg$FAILED;
      }
      if (s1 === peg$FAILED) {
        s1 = peg$currPos;
        s2 = peg$parseKW_COLUMN();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          s4 = peg$parseKW_STORE();
          if (s4 !== peg$FAILED) {
            s5 = peg$parse_();
            s6 = peg$parseKW_COMPRESS();
            if (s6 !== peg$FAILED) {
              s7 = peg$parse_();
              s8 = peg$parseKW_FOR();
              if (s8 !== peg$FAILED) {
                s9 = peg$parse_();
                s10 = peg$parseKW_QUERY();
                if (s10 !== peg$FAILED) {
                  peg$savedPos = s1;
                  s1 = peg$f164(s2);
                } else {
                  peg$currPos = s1;
                  s1 = peg$FAILED;
                }
              } else {
                peg$currPos = s1;
                s1 = peg$FAILED;
              }
            } else {
              peg$currPos = s1;
              s1 = peg$FAILED;
            }
          } else {
            peg$currPos = s1;
            s1 = peg$FAILED;
          }
        } else {
          peg$currPos = s1;
          s1 = peg$FAILED;
        }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        s3 = peg$parseKW_ROW();
        if (s3 !== peg$FAILED) {
          s4 = peg$parse_();
          s5 = peg$parseKW_AFTER();
          if (s5 !== peg$FAILED) {
            s6 = peg$parse_();
            s7 = peg$parseilm_time_period();
            if (s7 !== peg$FAILED) {
              s8 = peg$parse_();
              s9 = peg$parseKW_OF();
              if (s9 !== peg$FAILED) {
                s10 = peg$parse_();
                s11 = peg$parseKW_NO();
                if (s11 !== peg$FAILED) {
                  s12 = peg$parse_();
                  s13 = peg$parseKW_MODIFICATION();
                  if (s13 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s0 = peg$f165(s1, s3, s7);
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    }

    return s0;
  }

  function peg$parseilm_time_period() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parseinteger();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_DAY();
      if (s3 === peg$FAILED) {
        s3 = peg$parseKW_DAYS();
        if (s3 === peg$FAILED) {
          s3 = peg$parseKW_MONTH();
          if (s3 === peg$FAILED) {
            s3 = peg$parseKW_MONTHS();
            if (s3 === peg$FAILED) {
              s3 = peg$parseKW_YEAR();
              if (s3 === peg$FAILED) {
                s3 = peg$parseKW_YEARS();
              }
            }
          }
        }
      }
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f166(s1, s3);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseinmemory_table_clause() {
    var s0, s1, s2, s3, s4;

    s0 = peg$currPos;
    s1 = peg$currPos;
    s2 = peg$parseKW_INMEMORY();
    if (s2 !== peg$FAILED) {
      s3 = peg$parse_();
      s4 = peg$parseinmemory_attributes();
      peg$savedPos = s1;
      s1 = peg$f167(s2, s4);
    } else {
      peg$currPos = s1;
      s1 = peg$FAILED;
    }
    if (s1 === peg$FAILED) {
      s1 = peg$currPos;
      s2 = peg$parseKW_NO();
      if (s2 !== peg$FAILED) {
        s3 = peg$parse_();
        s4 = peg$parseKW_INMEMORY();
        if (s4 !== peg$FAILED) {
          peg$savedPos = s1;
          s1 = peg$f168();
        } else {
          peg$currPos = s1;
          s1 = peg$FAILED;
        }
      } else {
        peg$currPos = s1;
        s1 = peg$FAILED;
      }
    }
    if (s1 === peg$FAILED) {
      s1 = null;
    }
    s2 = peg$parse_();
    s3 = peg$parseinmemory_column_clause();
    if (s3 === peg$FAILED) {
      s3 = null;
    }
    s4 = peg$parse_();
    peg$savedPos = s0;
    s0 = peg$f169(s1, s3);

    return s0;
  }

  function peg$parseinmemory_column_clause() {
    var s0, s1, s2, s3, s4;

    s0 = peg$currPos;
    s1 = [];
    s2 = peg$currPos;
    s3 = peg$parse_();
    s4 = peg$parseinmemory_column_def();
    if (s4 !== peg$FAILED) {
      peg$savedPos = s2;
      s2 = peg$f170(s4);
    } else {
      peg$currPos = s2;
      s2 = peg$FAILED;
    }
    if (s2 !== peg$FAILED) {
      while (s2 !== peg$FAILED) {
        s1.push(s2);
        s2 = peg$currPos;
        s3 = peg$parse_();
        s4 = peg$parseinmemory_column_def();
        if (s4 !== peg$FAILED) {
          peg$savedPos = s2;
          s2 = peg$f170(s4);
        } else {
          peg$currPos = s2;
          s2 = peg$FAILED;
        }
      }
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f171(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parseinmemory_column_def() {
    var s0, s1, s2, s3, s4, s5, s6, s7;

    s0 = peg$currPos;
    s1 = peg$currPos;
    s2 = peg$parseKW_INMEMORY();
    if (s2 !== peg$FAILED) {
      s3 = peg$parse_();
      s4 = peg$parseinmemory_memcompress();
      if (s4 === peg$FAILED) {
        s4 = null;
      }
      peg$savedPos = s1;
      s1 = peg$f172(s2, s4);
    } else {
      peg$currPos = s1;
      s1 = peg$FAILED;
    }
    if (s1 === peg$FAILED) {
      s1 = peg$currPos;
      s2 = peg$parseKW_NO();
      if (s2 !== peg$FAILED) {
        s3 = peg$parse_();
        s4 = peg$parseKW_INMEMORY();
        if (s4 !== peg$FAILED) {
          peg$savedPos = s1;
          s1 = peg$f173();
        } else {
          peg$currPos = s1;
          s1 = peg$FAILED;
        }
      } else {
        peg$currPos = s1;
        s1 = peg$FAILED;
      }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseLPAR();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parsecomma_separated_identifiers();
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parseRPAR();
          if (s7 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f174(s1, s5);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseinmemory_attributes() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10;

    s0 = peg$currPos;
    s1 = peg$parseinmemory_memcompress();
    if (s1 === peg$FAILED) {
      s1 = null;
    }
    s2 = peg$parse_();
    s3 = peg$parseinmemory_priority();
    if (s3 === peg$FAILED) {
      s3 = null;
    }
    s4 = peg$parse_();
    s5 = peg$parseinmemory_distribute();
    if (s5 === peg$FAILED) {
      s5 = null;
    }
    s6 = peg$parse_();
    s7 = peg$parseinmemory_duplicate();
    if (s7 === peg$FAILED) {
      s7 = null;
    }
    s8 = peg$parse_();
    s9 = peg$parseinmemory_spatial();
    if (s9 === peg$FAILED) {
      s9 = null;
    }
    s10 = peg$parse_();
    peg$savedPos = s0;
    s0 = peg$f175(s1, s3, s5, s7, s9);

    return s0;
  }

  function peg$parseinmemory_spatial() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parseKW_SPATIAL();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseidentifier_name();
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f176(s3);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseinmemory_duplicate() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parseKW_DUPLICATE();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_ALL();
      if (s3 === peg$FAILED) {
        s3 = null;
      }
      peg$savedPos = s0;
      s0 = peg$f177(s3);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseKW_NO();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        s3 = peg$parseKW_DUPLICATE();
        if (s3 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f178();
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    }

    return s0;
  }

  function peg$parseinmemory_distribute() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10;

    s0 = peg$currPos;
    s1 = peg$parseKW_DISTRIBUTE();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_AUTO();
      if (s3 === peg$FAILED) {
        s3 = peg$currPos;
        s4 = peg$parseKW_BY();
        if (s4 !== peg$FAILED) {
          s5 = peg$parse_();
          s6 = peg$parseKW_PARTITION();
          if (s6 === peg$FAILED) {
            s6 = peg$parseKW_SUBPARTITION();
            if (s6 === peg$FAILED) {
              s6 = peg$currPos;
              s7 = peg$parseKW_ROWID();
              if (s7 !== peg$FAILED) {
                s8 = peg$parse_();
                s9 = peg$parseKW_RANGE();
                if (s9 !== peg$FAILED) {
                  peg$savedPos = s6;
                  s6 = peg$f179();
                } else {
                  peg$currPos = s6;
                  s6 = peg$FAILED;
                }
              } else {
                peg$currPos = s6;
                s6 = peg$FAILED;
              }
            }
          }
          if (s6 !== peg$FAILED) {
            peg$savedPos = s3;
            s3 = peg$f180(s6);
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      }
      if (s3 === peg$FAILED) {
        s3 = null;
      }
      s4 = peg$parse_();
      s5 = peg$currPos;
      s6 = peg$parseKW_FOR();
      if (s6 !== peg$FAILED) {
        s7 = peg$parse_();
        s8 = peg$parseKW_SERVICE();
        if (s8 !== peg$FAILED) {
          s9 = peg$parse_();
          s10 = peg$parseKW_DEFAULT();
          if (s10 === peg$FAILED) {
            s10 = peg$parseKW_ALL();
            if (s10 === peg$FAILED) {
              s10 = peg$parseidentifier_name();
              if (s10 === peg$FAILED) {
                s10 = peg$parseKW_NONE();
              }
            }
          }
          if (s10 !== peg$FAILED) {
            peg$savedPos = s5;
            s5 = peg$f181(s3, s10);
          } else {
            peg$currPos = s5;
            s5 = peg$FAILED;
          }
        } else {
          peg$currPos = s5;
          s5 = peg$FAILED;
        }
      } else {
        peg$currPos = s5;
        s5 = peg$FAILED;
      }
      if (s5 === peg$FAILED) {
        s5 = null;
      }
      peg$savedPos = s0;
      s0 = peg$f182(s3, s5);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseinmemory_priority() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parseKW_PRIORITY();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_NONE();
      if (s3 === peg$FAILED) {
        s3 = peg$parseKW_LOW();
        if (s3 === peg$FAILED) {
          s3 = peg$parseKW_MEDIUM();
          if (s3 === peg$FAILED) {
            s3 = peg$parseKW_HIGH();
            if (s3 === peg$FAILED) {
              s3 = peg$parseKW_CRITICAL();
            }
          }
        }
      }
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f183(s3);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseinmemory_memcompress() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8;

    s0 = peg$currPos;
    s1 = peg$parseKW_NO();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_MEMCOMPRESS();
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f184();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseKW_MEMCOMPRESS();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        s3 = peg$parseKW_AUTO();
        if (s3 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f185();
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseKW_MEMCOMPRESS();
        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();
          s3 = peg$parseKW_FOR();
          if (s3 !== peg$FAILED) {
            s4 = peg$parse_();
            s5 = peg$currPos;
            s6 = peg$parseKW_DML();
            if (s6 !== peg$FAILED) {
              peg$savedPos = s5;
              s6 = peg$f186(s1, s6);
            }
            s5 = s6;
            if (s5 === peg$FAILED) {
              s5 = peg$currPos;
              s6 = peg$parseKW_QUERY();
              if (s6 === peg$FAILED) {
                s6 = peg$parseKW_CAPACITY();
              }
              if (s6 !== peg$FAILED) {
                s7 = peg$parse_();
                s8 = peg$parseKW_LOW();
                if (s8 === peg$FAILED) {
                  s8 = peg$parseKW_HIGH();
                }
                if (s8 === peg$FAILED) {
                  s8 = null;
                }
                peg$savedPos = s5;
                s5 = peg$f187(s1, s6, s8);
              } else {
                peg$currPos = s5;
                s5 = peg$FAILED;
              }
            }
            if (s5 === peg$FAILED) {
              s5 = null;
            }
            peg$savedPos = s0;
            s0 = peg$f188(s1, s5);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      }
    }

    return s0;
  }

  function peg$parsetable_compression() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16;

    s0 = peg$currPos;
    s1 = peg$parseKW_COMPRESS();
    if (s1 === peg$FAILED) {
      s1 = peg$parseKW_NOCOMPRESS();
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f189(s1);
    }
    s0 = s1;
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseKW_ROW();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        s3 = peg$parseKW_STORE();
        if (s3 !== peg$FAILED) {
          s4 = peg$parse_();
          s5 = peg$parseKW_COMPRESS();
          if (s5 !== peg$FAILED) {
            s6 = peg$parse_();
            s7 = peg$parseKW_BASIC();
            if (s7 === peg$FAILED) {
              s7 = peg$parseKW_ADVANCED();
            }
            if (s7 === peg$FAILED) {
              s7 = null;
            }
            peg$savedPos = s0;
            s0 = peg$f190(s1, s5, s7);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseKW_COLUMN();
        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();
          s3 = peg$parseKW_STORE();
          if (s3 !== peg$FAILED) {
            s4 = peg$parse_();
            s5 = peg$parseKW_COMPRESS();
            if (s5 !== peg$FAILED) {
              s6 = peg$parse_();
              s7 = peg$currPos;
              s8 = peg$parseKW_FOR();
              if (s8 !== peg$FAILED) {
                s9 = peg$parse_();
                s10 = peg$parseKW_QUERY();
                if (s10 === peg$FAILED) {
                  s10 = peg$parseKW_ARCHIVE();
                }
                if (s10 !== peg$FAILED) {
                  s11 = peg$parse_();
                  s12 = peg$parseKW_LOW();
                  if (s12 === peg$FAILED) {
                    s12 = peg$parseKW_HIGH();
                  }
                  if (s12 === peg$FAILED) {
                    s12 = null;
                  }
                  peg$savedPos = s7;
                  s7 = peg$f191(s1, s5, s10, s12);
                } else {
                  peg$currPos = s7;
                  s7 = peg$FAILED;
                }
              } else {
                peg$currPos = s7;
                s7 = peg$FAILED;
              }
              if (s7 === peg$FAILED) {
                s7 = null;
              }
              s8 = peg$parse_();
              s9 = peg$currPos;
              s10 = peg$parseKW_NO();
              if (s10 !== peg$FAILED) {
                s11 = peg$parse_();
                s12 = peg$parseKW_ROW();
                if (s12 !== peg$FAILED) {
                  s13 = peg$parse_();
                  s14 = peg$parseKW_LEVEL();
                  if (s14 !== peg$FAILED) {
                    s15 = peg$parse_();
                    s16 = peg$parseKW_LOCKING();
                    if (s16 !== peg$FAILED) {
                      peg$savedPos = s9;
                      s9 = peg$f192(s1, s5, s7, s10);
                    } else {
                      peg$currPos = s9;
                      s9 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s9;
                    s9 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s9;
                  s9 = peg$FAILED;
                }
              } else {
                peg$currPos = s9;
                s9 = peg$FAILED;
              }
              if (s9 === peg$FAILED) {
                s9 = null;
              }
              peg$savedPos = s0;
              s0 = peg$f193(s1, s5, s7, s9);
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      }
    }

    return s0;
  }

  function peg$parsesegment_attributes_clause() {
    var s0, s1, s2, s3, s4;

    s0 = peg$currPos;
    s1 = [];
    s2 = peg$currPos;
    s3 = peg$parse_();
    s4 = peg$parsesegment_attribute();
    if (s4 !== peg$FAILED) {
      peg$savedPos = s2;
      s2 = peg$f194(s4);
    } else {
      peg$currPos = s2;
      s2 = peg$FAILED;
    }
    if (s2 !== peg$FAILED) {
      while (s2 !== peg$FAILED) {
        s1.push(s2);
        s2 = peg$currPos;
        s3 = peg$parse_();
        s4 = peg$parsesegment_attribute();
        if (s4 !== peg$FAILED) {
          peg$savedPos = s2;
          s2 = peg$f194(s4);
        } else {
          peg$currPos = s2;
          s2 = peg$FAILED;
        }
      }
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f195(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parsesegment_attribute() {
    var s0, s1, s2, s3, s4, s5;

    s0 = peg$currPos;
    s1 = peg$parseKW_TABLESPACE();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_SET();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseidentifier_name();
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f196(s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseKW_TABLESPACE();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        s3 = peg$parseidentifier_name();
        if (s3 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f197(s3);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parselogging_clause();
        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$f198(s1);
        }
        s0 = s1;
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$parsephysical_attributes_clause();
          if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$f199(s1);
          }
          s0 = s1;
        }
      }
    }

    return s0;
  }

  function peg$parsephysical_attributes_clause() {
    var s0, s1, s2, s3, s4, s5;

    s0 = peg$currPos;
    s1 = [];
    s2 = peg$currPos;
    s3 = peg$parse_();
    s4 = peg$parsephysical_attribute();
    if (s4 !== peg$FAILED) {
      s5 = peg$parse_();
      peg$savedPos = s2;
      s2 = peg$f200(s4);
    } else {
      peg$currPos = s2;
      s2 = peg$FAILED;
    }
    if (s2 !== peg$FAILED) {
      while (s2 !== peg$FAILED) {
        s1.push(s2);
        s2 = peg$currPos;
        s3 = peg$parse_();
        s4 = peg$parsephysical_attribute();
        if (s4 !== peg$FAILED) {
          s5 = peg$parse_();
          peg$savedPos = s2;
          s2 = peg$f200(s4);
        } else {
          peg$currPos = s2;
          s2 = peg$FAILED;
        }
      }
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f201(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parsephysical_attribute() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parseKW_PCTFREE();
    if (s1 === peg$FAILED) {
      s1 = peg$parseKW_PCTUSED();
      if (s1 === peg$FAILED) {
        s1 = peg$parseKW_INITRANS();
      }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseinteger();
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f202(s1, s3);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parsestorage_clause();
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$f203(s1);
      }
      s0 = s1;
    }

    return s0;
  }

  function peg$parsestorage_clause() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8;

    s0 = peg$currPos;
    s1 = peg$parseKW_STORAGE();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseLPAR();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = [];
        s6 = peg$currPos;
        s7 = peg$parsestorage_option();
        if (s7 !== peg$FAILED) {
          s8 = peg$parse_();
          peg$savedPos = s6;
          s6 = peg$f204(s7);
        } else {
          peg$currPos = s6;
          s6 = peg$FAILED;
        }
        if (s6 !== peg$FAILED) {
          while (s6 !== peg$FAILED) {
            s5.push(s6);
            s6 = peg$currPos;
            s7 = peg$parsestorage_option();
            if (s7 !== peg$FAILED) {
              s8 = peg$parse_();
              peg$savedPos = s6;
              s6 = peg$f204(s7);
            } else {
              peg$currPos = s6;
              s6 = peg$FAILED;
            }
          }
        } else {
          s5 = peg$FAILED;
        }
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parseRPAR();
          if (s7 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f205(s5);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsestorage_option() {
    var s0, s1, s2, s3, s4, s5;

    s0 = peg$currPos;
    s1 = peg$parseKW_INITIAL();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parsesize_clause();
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f206(s1, s3);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseKW_NEXT();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        s3 = peg$parsesize_clause();
        if (s3 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f207(s1, s3);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseKW_PCTINCREASE();
        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();
          s3 = peg$parseinteger();
          if (s3 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f208(s1, s3);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$parseKW_MINEXTENTS();
          if (s1 !== peg$FAILED) {
            s2 = peg$parse_();
            s3 = peg$parseinteger();
            if (s3 !== peg$FAILED) {
              peg$savedPos = s0;
              s0 = peg$f209(s1, s3);
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$parseKW_MAXEXTENTS();
            if (s1 !== peg$FAILED) {
              s2 = peg$parse_();
              s3 = peg$parseinteger();
              if (s3 === peg$FAILED) {
                s3 = peg$parseKW_UNLIMITED();
              }
              if (s3 !== peg$FAILED) {
                peg$savedPos = s0;
                s0 = peg$f210(s1, s3);
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
            if (s0 === peg$FAILED) {
              s0 = peg$parsemaxsize_clause();
              if (s0 === peg$FAILED) {
                s0 = peg$currPos;
                s1 = peg$parseKW_ENCRYPT();
                if (s1 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s1 = peg$f211(s1);
                }
                s0 = s1;
                if (s0 === peg$FAILED) {
                  s0 = peg$currPos;
                  s1 = peg$parseKW_FLASH_CACHE();
                  if (s1 === peg$FAILED) {
                    s1 = peg$parseKW_CELL_FLASH_CACHE();
                  }
                  if (s1 !== peg$FAILED) {
                    s2 = peg$parse_();
                    s3 = peg$parseKW_KEEP();
                    if (s3 === peg$FAILED) {
                      s3 = peg$parseKW_NONE();
                      if (s3 === peg$FAILED) {
                        s3 = peg$parseKW_DEFAULT();
                      }
                    }
                    if (s3 !== peg$FAILED) {
                      peg$savedPos = s0;
                      s0 = peg$f212(s1, s3);
                    } else {
                      peg$currPos = s0;
                      s0 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                  if (s0 === peg$FAILED) {
                    s0 = peg$currPos;
                    s1 = peg$parseKW_BUFFER_POOL();
                    if (s1 !== peg$FAILED) {
                      s2 = peg$parse_();
                      s3 = peg$parseKW_KEEP();
                      if (s3 === peg$FAILED) {
                        s3 = peg$parseKW_RECYCLE();
                        if (s3 === peg$FAILED) {
                          s3 = peg$parseKW_DEFAULT();
                        }
                      }
                      if (s3 !== peg$FAILED) {
                        peg$savedPos = s0;
                        s0 = peg$f213(s1, s3);
                      } else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                      }
                    } else {
                      peg$currPos = s0;
                      s0 = peg$FAILED;
                    }
                    if (s0 === peg$FAILED) {
                      s0 = peg$currPos;
                      s1 = peg$parseKW_FREELIST();
                      if (s1 !== peg$FAILED) {
                        s2 = peg$parse_();
                        s3 = peg$parseKW_GROUPS();
                        if (s3 !== peg$FAILED) {
                          s4 = peg$parse_();
                          s5 = peg$parseinteger();
                          if (s5 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s0 = peg$f214(s5);
                          } else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                          }
                        } else {
                          peg$currPos = s0;
                          s0 = peg$FAILED;
                        }
                      } else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                      }
                      if (s0 === peg$FAILED) {
                        s0 = peg$currPos;
                        s1 = peg$parseKW_FREELISTS();
                        if (s1 !== peg$FAILED) {
                          s2 = peg$parse_();
                          s3 = peg$parseinteger();
                          if (s3 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s0 = peg$f215(s3);
                          } else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                          }
                        } else {
                          peg$currPos = s0;
                          s0 = peg$FAILED;
                        }
                        if (s0 === peg$FAILED) {
                          s0 = peg$currPos;
                          s1 = peg$parseKW_OPTIMAL();
                          if (s1 !== peg$FAILED) {
                            s2 = peg$parse_();
                            s3 = peg$parsesize_clause();
                            if (s3 === peg$FAILED) {
                              s3 = peg$parseKW_NULL();
                            }
                            if (s3 === peg$FAILED) {
                              s3 = null;
                            }
                            peg$savedPos = s0;
                            s0 = peg$f216(s1, s3);
                          } else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }

    return s0;
  }

  function peg$parsemaxsize_clause() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parseKW_MAXSIZE();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parsesize_clause();
      if (s3 === peg$FAILED) {
        s3 = peg$parseKW_UNLIMITED();
      }
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f217(s1, s3);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsesize_clause() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parseinteger();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = input.charAt(peg$currPos);
      if (peg$r0.test(s3)) {
        peg$currPos++;
      } else {
        s3 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e2); }
      }
      if (s3 === peg$FAILED) {
        s3 = null;
      }
      peg$savedPos = s0;
      s0 = peg$f218(s1, s3);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsedeferred_segment_creation() {
    var s0, s1, s2, s3, s4, s5;

    s0 = peg$currPos;
    s1 = peg$parseKW_SEGMENT();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_CREATION();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseKW_DEFERRED();
        if (s5 === peg$FAILED) {
          s5 = peg$parseKW_IMMEDIATE();
        }
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f219(s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseimmutable_table_clauses() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parseimmutable_table_no_drop_clause();
    if (s1 === peg$FAILED) {
      s1 = null;
    }
    s2 = peg$parse_();
    s3 = peg$parseimmutable_table_no_delete_clause();
    if (s3 === peg$FAILED) {
      s3 = null;
    }
    peg$savedPos = s0;
    s0 = peg$f220(s1, s3);

    return s0;
  }

  function peg$parseimmutable_table_no_drop_clause() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12;

    s0 = peg$currPos;
    s1 = peg$parseKW_NO();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_DROP();
      if (s3 !== peg$FAILED) {
        s4 = peg$currPos;
        s5 = peg$parse_();
        s6 = peg$parseKW_UNTIL();
        if (s6 !== peg$FAILED) {
          s7 = peg$parse_();
          s8 = peg$parseinteger();
          if (s8 !== peg$FAILED) {
            s9 = peg$parse_();
            s10 = peg$parseKW_DAYS();
            if (s10 !== peg$FAILED) {
              s11 = peg$parse_();
              s12 = peg$parseKW_IDLE();
              if (s12 !== peg$FAILED) {
                peg$savedPos = s4;
                s4 = peg$f221(s8);
              } else {
                peg$currPos = s4;
                s4 = peg$FAILED;
              }
            } else {
              peg$currPos = s4;
              s4 = peg$FAILED;
            }
          } else {
            peg$currPos = s4;
            s4 = peg$FAILED;
          }
        } else {
          peg$currPos = s4;
          s4 = peg$FAILED;
        }
        if (s4 === peg$FAILED) {
          s4 = null;
        }
        peg$savedPos = s0;
        s0 = peg$f222(s4);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseimmutable_table_no_delete_clause() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16, s17;

    s0 = peg$currPos;
    s1 = peg$parseKW_NO();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_DELETE();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$currPos;
        s6 = peg$parseKW_LOCKED();
        if (s6 !== peg$FAILED) {
          peg$savedPos = s5;
          s6 = peg$f223(s6);
        }
        s5 = s6;
        if (s5 === peg$FAILED) {
          s5 = peg$currPos;
          s6 = peg$parse_();
          s7 = peg$parseKW_UNTIL();
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            s9 = peg$parseinteger();
            if (s9 !== peg$FAILED) {
              s10 = peg$parse_();
              s11 = peg$parseKW_DAYS();
              if (s11 !== peg$FAILED) {
                s12 = peg$parse_();
                s13 = peg$parseKW_AFTER();
                if (s13 !== peg$FAILED) {
                  s14 = peg$parse_();
                  s15 = peg$parseKW_INSERT();
                  if (s15 !== peg$FAILED) {
                    s16 = peg$parse_();
                    s17 = peg$parseKW_LOCKED();
                    if (s17 === peg$FAILED) {
                      s17 = null;
                    }
                    peg$savedPos = s5;
                    s5 = peg$f224(s9, s17);
                  } else {
                    peg$currPos = s5;
                    s5 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s5;
                  s5 = peg$FAILED;
                }
              } else {
                peg$currPos = s5;
                s5 = peg$FAILED;
              }
            } else {
              peg$currPos = s5;
              s5 = peg$FAILED;
            }
          } else {
            peg$currPos = s5;
            s5 = peg$FAILED;
          }
        }
        if (s5 === peg$FAILED) {
          s5 = null;
        }
        peg$savedPos = s0;
        s0 = peg$f225(s5);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseblockchain_table_clauses() {
    var s0, s1, s2, s3, s4, s5;

    s0 = peg$currPos;
    s1 = peg$parseimmutable_table_no_drop_clause();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseimmutable_table_no_delete_clause();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseblockchain_hash_and_data_format_clause();
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f226(s1, s3, s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseblockchain_hash_and_data_format_clause() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

    s0 = peg$currPos;
    s1 = peg$parseKW_HASHING();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_USING();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        if (input.substr(peg$currPos, 8) === peg$c2) {
          s5 = peg$c2;
          peg$currPos += 8;
        } else {
          s5 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e3); }
        }
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parseKW_VERSION();
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            if (input.substr(peg$currPos, 2) === peg$c3) {
              s9 = peg$c3;
              peg$currPos += 2;
            } else {
              s9 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$e4); }
            }
            if (s9 !== peg$FAILED) {
              peg$savedPos = s0;
              s0 = peg$f227(s1);
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parserelational_properties() {
    var s0, s1, s2, s3, s4, s5, s6, s7;

    s0 = peg$currPos;
    s1 = peg$parserelational_property();
    if (s1 !== peg$FAILED) {
      s2 = [];
      s3 = peg$currPos;
      s4 = peg$parse_();
      s5 = peg$parseCOMMA();
      if (s5 !== peg$FAILED) {
        s6 = peg$parse_();
        s7 = peg$parserelational_property();
        if (s7 !== peg$FAILED) {
          peg$savedPos = s3;
          s3 = peg$f228(s1, s7);
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
      while (s3 !== peg$FAILED) {
        s2.push(s3);
        s3 = peg$currPos;
        s4 = peg$parse_();
        s5 = peg$parseCOMMA();
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parserelational_property();
          if (s7 !== peg$FAILED) {
            peg$savedPos = s3;
            s3 = peg$f228(s1, s7);
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      }
      peg$savedPos = s0;
      s0 = peg$f229(s1, s2);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parserelational_property() {
    var s0;

    s0 = peg$parsecolumn_definition();
    if (s0 === peg$FAILED) {
      s0 = peg$parseout_of_line_property();
      if (s0 === peg$FAILED) {
        s0 = peg$parseperiod_definition();
        if (s0 === peg$FAILED) {
          s0 = peg$parsesupplemental_logging_props();
        }
      }
    }

    return s0;
  }

  function peg$parsesupplemental_logging_props() {
    var s0, s1, s2, s3, s4, s5, s6;

    s0 = peg$currPos;
    s1 = peg$parseKW_SUPPLEMENTAL();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_LOG();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$currPos;
        s6 = peg$parsesupplemental_log_grp_clause();
        if (s6 !== peg$FAILED) {
          peg$savedPos = s5;
          s6 = peg$f230(s6);
        }
        s5 = s6;
        if (s5 === peg$FAILED) {
          s5 = peg$currPos;
          s6 = peg$parsesupplemental_id_key_clause();
          if (s6 !== peg$FAILED) {
            peg$savedPos = s5;
            s6 = peg$f231(s6);
          }
          s5 = s6;
        }
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f232(s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsesupplemental_id_key_clause() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12;

    s0 = peg$currPos;
    s1 = peg$parseKW_DATA();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseLPAR();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$currPos;
        s6 = peg$parsesupplemental_id_key_column();
        if (s6 !== peg$FAILED) {
          s7 = [];
          s8 = peg$currPos;
          s9 = peg$parse_();
          s10 = peg$parseCOMMA();
          if (s10 !== peg$FAILED) {
            s11 = peg$parse_();
            s12 = peg$parsesupplemental_id_key_column();
            if (s12 !== peg$FAILED) {
              peg$savedPos = s8;
              s8 = peg$f233(s6, s12);
            } else {
              peg$currPos = s8;
              s8 = peg$FAILED;
            }
          } else {
            peg$currPos = s8;
            s8 = peg$FAILED;
          }
          while (s8 !== peg$FAILED) {
            s7.push(s8);
            s8 = peg$currPos;
            s9 = peg$parse_();
            s10 = peg$parseCOMMA();
            if (s10 !== peg$FAILED) {
              s11 = peg$parse_();
              s12 = peg$parsesupplemental_id_key_column();
              if (s12 !== peg$FAILED) {
                peg$savedPos = s8;
                s8 = peg$f233(s6, s12);
              } else {
                peg$currPos = s8;
                s8 = peg$FAILED;
              }
            } else {
              peg$currPos = s8;
              s8 = peg$FAILED;
            }
          }
          peg$savedPos = s5;
          s5 = peg$f234(s6, s7);
        } else {
          peg$currPos = s5;
          s5 = peg$FAILED;
        }
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parseRPAR();
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            s9 = peg$parseKW_COLUMNS();
            if (s9 !== peg$FAILED) {
              peg$savedPos = s0;
              s0 = peg$f235(s5);
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsesupplemental_id_key_column() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parseKW_UNIQUE();
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f236(s1);
    }
    s0 = s1;
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseKW_ALL();
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$f237(s1);
      }
      s0 = s1;
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseKW_PRIMARY();
        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();
          s3 = peg$parseKW_KEY();
          if (s3 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f238();
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$parseKW_FOREIGN();
          if (s1 !== peg$FAILED) {
            s2 = peg$parse_();
            s3 = peg$parseKW_KEY();
            if (s3 !== peg$FAILED) {
              peg$savedPos = s0;
              s0 = peg$f239();
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        }
      }
    }

    return s0;
  }

  function peg$parsesupplemental_log_grp_clause() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14;

    s0 = peg$currPos;
    s1 = peg$parseKW_GROUP();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseidentifier_name();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseLPAR();
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$currPos;
          s8 = peg$parsesupplemental_log_grp_column();
          if (s8 !== peg$FAILED) {
            s9 = [];
            s10 = peg$currPos;
            s11 = peg$parse_();
            s12 = peg$parseCOMMA();
            if (s12 !== peg$FAILED) {
              s13 = peg$parse_();
              s14 = peg$parsesupplemental_log_grp_column();
              if (s14 !== peg$FAILED) {
                peg$savedPos = s10;
                s10 = peg$f240(s3, s8, s14);
              } else {
                peg$currPos = s10;
                s10 = peg$FAILED;
              }
            } else {
              peg$currPos = s10;
              s10 = peg$FAILED;
            }
            while (s10 !== peg$FAILED) {
              s9.push(s10);
              s10 = peg$currPos;
              s11 = peg$parse_();
              s12 = peg$parseCOMMA();
              if (s12 !== peg$FAILED) {
                s13 = peg$parse_();
                s14 = peg$parsesupplemental_log_grp_column();
                if (s14 !== peg$FAILED) {
                  peg$savedPos = s10;
                  s10 = peg$f240(s3, s8, s14);
                } else {
                  peg$currPos = s10;
                  s10 = peg$FAILED;
                }
              } else {
                peg$currPos = s10;
                s10 = peg$FAILED;
              }
            }
            peg$savedPos = s7;
            s7 = peg$f241(s3, s8, s9);
          } else {
            peg$currPos = s7;
            s7 = peg$FAILED;
          }
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            s9 = peg$parseRPAR();
            if (s9 !== peg$FAILED) {
              s10 = peg$parse_();
              s11 = peg$parseKW_ALWAYS();
              if (s11 === peg$FAILED) {
                s11 = null;
              }
              peg$savedPos = s0;
              s0 = peg$f242(s3, s7, s11);
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsesupplemental_log_grp_column() {
    var s0, s1, s2, s3, s4, s5, s6;

    s0 = peg$currPos;
    s1 = peg$parseidentifier_name();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$currPos;
      s4 = peg$parseKW_NO();
      if (s4 !== peg$FAILED) {
        s5 = peg$parse_();
        s6 = peg$parseKW_LOG();
        if (s6 !== peg$FAILED) {
          peg$savedPos = s3;
          s3 = peg$f243(s1);
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
      if (s3 === peg$FAILED) {
        s3 = null;
      }
      peg$savedPos = s0;
      s0 = peg$f244(s1, s3);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseperiod_definition() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16;

    s0 = peg$currPos;
    s1 = peg$parseKW_PERIOD();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_FOR();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseidentifier_name();
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$currPos;
          s8 = peg$parseLPAR();
          if (s8 !== peg$FAILED) {
            s9 = peg$parse_();
            s10 = peg$parseidentifier_name();
            if (s10 !== peg$FAILED) {
              s11 = peg$parse_();
              s12 = peg$parseCOMMA();
              if (s12 !== peg$FAILED) {
                s13 = peg$parse_();
                s14 = peg$parseidentifier_name();
                if (s14 !== peg$FAILED) {
                  s15 = peg$parse_();
                  s16 = peg$parseRPAR();
                  if (s16 !== peg$FAILED) {
                    peg$savedPos = s7;
                    s7 = peg$f245(s5, s10, s14);
                  } else {
                    peg$currPos = s7;
                    s7 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s7;
                  s7 = peg$FAILED;
                }
              } else {
                peg$currPos = s7;
                s7 = peg$FAILED;
              }
            } else {
              peg$currPos = s7;
              s7 = peg$FAILED;
            }
          } else {
            peg$currPos = s7;
            s7 = peg$FAILED;
          }
          if (s7 === peg$FAILED) {
            s7 = null;
          }
          peg$savedPos = s0;
          s0 = peg$f246(s5, s7);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseout_of_line_property() {
    var s0, s1;

    s0 = peg$parseout_of_line_constraint();
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseout_of_line_ref_constraint();
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$f247(s1);
      }
      s0 = s1;
    }

    return s0;
  }

  function peg$parseout_of_line_ref_constraint() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16, s17;

    s0 = peg$currPos;
    s1 = peg$parseKW_SCOPE();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_FOR();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseLPAR();
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parseidentifier_name();
          if (s7 !== peg$FAILED) {
            s8 = peg$parse_();
            s9 = peg$parseRPAR();
            if (s9 !== peg$FAILED) {
              s10 = peg$parse_();
              s11 = peg$parseKW_IS();
              if (s11 !== peg$FAILED) {
                s12 = peg$parse_();
                s13 = peg$currPos;
                s14 = peg$parseidentifier_name();
                if (s14 !== peg$FAILED) {
                  s15 = peg$parse_();
                  s16 = peg$parseDOT();
                  if (s16 !== peg$FAILED) {
                    s17 = peg$parse_();
                    peg$savedPos = s13;
                    s13 = peg$f248(s1, s7, s14);
                  } else {
                    peg$currPos = s13;
                    s13 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s13;
                  s13 = peg$FAILED;
                }
                if (s13 === peg$FAILED) {
                  s13 = null;
                }
                s14 = peg$parseidentifier_name();
                if (s14 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s0 = peg$f249(s1, s7, s13, s14);
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseKW_REF();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        s3 = peg$parseLPAR();
        if (s3 !== peg$FAILED) {
          s4 = peg$parse_();
          s5 = peg$parseidentifier_name();
          if (s5 !== peg$FAILED) {
            s6 = peg$parse_();
            s7 = peg$parseRPAR();
            if (s7 !== peg$FAILED) {
              s8 = peg$parse_();
              s9 = peg$parseKW_WITH();
              if (s9 !== peg$FAILED) {
                s10 = peg$parse_();
                s11 = peg$parseKW_ROWID();
                if (s11 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s0 = peg$f250(s1, s5, s9, s11);
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parseKW_CONSTRAINT();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          s4 = peg$parseidentifier_name();
          if (s4 !== peg$FAILED) {
            peg$savedPos = s1;
            s1 = peg$f251(s4);
          } else {
            peg$currPos = s1;
            s1 = peg$FAILED;
          }
        } else {
          peg$currPos = s1;
          s1 = peg$FAILED;
        }
        if (s1 === peg$FAILED) {
          s1 = null;
        }
        s2 = peg$parse_();
        s3 = peg$parseKW_FOREIGN();
        if (s3 !== peg$FAILED) {
          s4 = peg$parse_();
          s5 = peg$parseKW_KEY();
          if (s5 !== peg$FAILED) {
            s6 = peg$parse_();
            s7 = peg$parseLPAR();
            if (s7 !== peg$FAILED) {
              s8 = peg$parse_();
              s9 = peg$parsecomma_separated_identifiers();
              if (s9 !== peg$FAILED) {
                s10 = peg$parse_();
                s11 = peg$parseRPAR();
                if (s11 !== peg$FAILED) {
                  s12 = peg$parse_();
                  s13 = peg$parsereferences_clause();
                  if (s13 !== peg$FAILED) {
                    s14 = peg$parse_();
                    s15 = peg$parseconstraint_state();
                    if (s15 === peg$FAILED) {
                      s15 = null;
                    }
                    peg$savedPos = s0;
                    s0 = peg$f252(s1, s9, s13, s15);
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      }
    }

    return s0;
  }

  function peg$parseout_of_line_constraint() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14;

    s0 = peg$currPos;
    s1 = peg$currPos;
    s2 = peg$parseKW_CONSTRAINT();
    if (s2 !== peg$FAILED) {
      s3 = peg$parse_();
      s4 = peg$parseidentifier_name();
      if (s4 !== peg$FAILED) {
        peg$savedPos = s1;
        s1 = peg$f253(s4);
      } else {
        peg$currPos = s1;
        s1 = peg$FAILED;
      }
    } else {
      peg$currPos = s1;
      s1 = peg$FAILED;
    }
    if (s1 === peg$FAILED) {
      s1 = null;
    }
    s2 = peg$parse_();
    s3 = peg$currPos;
    s4 = peg$parseKW_UNIQUE();
    if (s4 !== peg$FAILED) {
      s5 = peg$parse_();
      s6 = peg$parseLPAR();
      if (s6 !== peg$FAILED) {
        s7 = peg$parse_();
        s8 = peg$parsecomma_separated_identifiers();
        if (s8 !== peg$FAILED) {
          s9 = peg$parse_();
          s10 = peg$parseRPAR();
          if (s10 !== peg$FAILED) {
            peg$savedPos = s3;
            s3 = peg$f254(s1, s4, s8);
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
    } else {
      peg$currPos = s3;
      s3 = peg$FAILED;
    }
    if (s3 === peg$FAILED) {
      s3 = peg$currPos;
      s4 = peg$parseKW_PRIMARY();
      if (s4 !== peg$FAILED) {
        s5 = peg$parse_();
        s6 = peg$parseKW_KEY();
        if (s6 !== peg$FAILED) {
          s7 = peg$parse_();
          s8 = peg$parseLPAR();
          if (s8 !== peg$FAILED) {
            s9 = peg$parse_();
            s10 = peg$parsecomma_separated_identifiers();
            if (s10 !== peg$FAILED) {
              s11 = peg$parse_();
              s12 = peg$parseRPAR();
              if (s12 !== peg$FAILED) {
                peg$savedPos = s3;
                s3 = peg$f255(s1, s10);
              } else {
                peg$currPos = s3;
                s3 = peg$FAILED;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$FAILED;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
      if (s3 === peg$FAILED) {
        s3 = peg$currPos;
        s4 = peg$parseKW_FOREIGN();
        if (s4 !== peg$FAILED) {
          s5 = peg$parse_();
          s6 = peg$parseKW_KEY();
          if (s6 !== peg$FAILED) {
            s7 = peg$parse_();
            s8 = peg$parseLPAR();
            if (s8 !== peg$FAILED) {
              s9 = peg$parse_();
              s10 = peg$parsecomma_separated_identifiers();
              if (s10 !== peg$FAILED) {
                s11 = peg$parse_();
                s12 = peg$parseRPAR();
                if (s12 !== peg$FAILED) {
                  s13 = peg$parse_();
                  s14 = peg$parsereferences_clause();
                  if (s14 !== peg$FAILED) {
                    peg$savedPos = s3;
                    s3 = peg$f256(s1, s10, s14);
                  } else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s3;
                  s3 = peg$FAILED;
                }
              } else {
                peg$currPos = s3;
                s3 = peg$FAILED;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$FAILED;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
        if (s3 === peg$FAILED) {
          s3 = peg$currPos;
          s4 = peg$parseKW_CHECK();
          if (s4 !== peg$FAILED) {
            s5 = peg$parse_();
            s6 = peg$parseLPAR();
            if (s6 !== peg$FAILED) {
              s7 = peg$parse_();
              s8 = peg$parsecondition();
              s9 = peg$parse_();
              s10 = peg$parseRPAR();
              if (s10 !== peg$FAILED) {
                peg$savedPos = s3;
                s3 = peg$f257(s1, s8);
              } else {
                peg$currPos = s3;
                s3 = peg$FAILED;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$FAILED;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        }
      }
    }
    if (s3 !== peg$FAILED) {
      s4 = peg$parse_();
      s5 = peg$parseconstraint_state();
      if (s5 === peg$FAILED) {
        s5 = null;
      }
      peg$savedPos = s0;
      s0 = peg$f258(s1, s3, s5);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsecolumn_definition() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16;

    s0 = peg$currPos;
    s1 = peg$parseidentifier_name();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parsedata_type();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$currPos;
        s6 = peg$parseKW_COLLATE();
        if (s6 !== peg$FAILED) {
          s7 = peg$parse_();
          s8 = peg$parseidentifier_name();
          if (s8 !== peg$FAILED) {
            peg$savedPos = s5;
            s5 = peg$f259(s1, s3, s8);
          } else {
            peg$currPos = s5;
            s5 = peg$FAILED;
          }
        } else {
          peg$currPos = s5;
          s5 = peg$FAILED;
        }
        if (s5 === peg$FAILED) {
          s5 = null;
        }
        s6 = peg$parse_();
        s7 = peg$parseKW_SORT();
        if (s7 === peg$FAILED) {
          s7 = null;
        }
        s8 = peg$parse_();
        s9 = peg$parseKW_VISIBLE();
        if (s9 === peg$FAILED) {
          s9 = peg$parseKW_INVISIBLE();
        }
        if (s9 === peg$FAILED) {
          s9 = null;
        }
        s10 = peg$parse_();
        s11 = peg$parsecolumn_default_clause();
        if (s11 === peg$FAILED) {
          s11 = peg$parseidentity_clause();
        }
        if (s11 === peg$FAILED) {
          s11 = null;
        }
        s12 = peg$parse_();
        s13 = peg$currPos;
        s14 = peg$parseKW_ENCRYPT();
        if (s14 !== peg$FAILED) {
          s15 = peg$parse_();
          s16 = peg$parseencryption_spec();
          peg$savedPos = s13;
          s13 = peg$f260(s1, s3, s5, s7, s9, s11, s14, s16);
        } else {
          peg$currPos = s13;
          s13 = peg$FAILED;
        }
        if (s13 === peg$FAILED) {
          s13 = null;
        }
        s14 = peg$parse_();
        s15 = peg$parsecolumn_constraints();
        if (s15 === peg$FAILED) {
          s15 = null;
        }
        s16 = peg$parse_();
        peg$savedPos = s0;
        s0 = peg$f261(s1, s3, s5, s7, s9, s11, s13, s15);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsecolumn_constraints() {
    var s0, s1;

    s0 = peg$currPos;
    s1 = peg$parseinline_ref_constraint();
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f262(s1);
    }
    s0 = s1;
    if (s0 === peg$FAILED) {
      s0 = peg$parseinline_constraints();
    }

    return s0;
  }

  function peg$parseinline_ref_constraint() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

    s0 = peg$currPos;
    s1 = peg$parseKW_SCOPE();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_IS();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$currPos;
        s6 = peg$parseidentifier_name();
        if (s6 !== peg$FAILED) {
          s7 = peg$parse_();
          s8 = peg$parseDOT();
          if (s8 !== peg$FAILED) {
            s9 = peg$parse_();
            peg$savedPos = s5;
            s5 = peg$f263(s1, s6);
          } else {
            peg$currPos = s5;
            s5 = peg$FAILED;
          }
        } else {
          peg$currPos = s5;
          s5 = peg$FAILED;
        }
        if (s5 === peg$FAILED) {
          s5 = null;
        }
        s6 = peg$parseidentifier_name();
        if (s6 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f264(s1, s5, s6);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseKW_WITH();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        s3 = peg$parseKW_ROWID();
        if (s3 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f265(s1, s3);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = peg$parseKW_CONSTRAINT();
        if (s2 !== peg$FAILED) {
          s3 = peg$parse_();
          s4 = peg$parseidentifier_name();
          if (s4 !== peg$FAILED) {
            peg$savedPos = s1;
            s1 = peg$f266(s4);
          } else {
            peg$currPos = s1;
            s1 = peg$FAILED;
          }
        } else {
          peg$currPos = s1;
          s1 = peg$FAILED;
        }
        if (s1 === peg$FAILED) {
          s1 = null;
        }
        s2 = peg$parse_();
        s3 = peg$parsereferences_clause();
        if (s3 !== peg$FAILED) {
          s4 = peg$parse_();
          s5 = peg$parseconstraint_state();
          if (s5 === peg$FAILED) {
            s5 = null;
          }
          peg$savedPos = s0;
          s0 = peg$f267(s1, s3, s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      }
    }

    return s0;
  }

  function peg$parseinline_constraints() {
    var s0, s1, s2, s3, s4;

    s0 = peg$currPos;
    s1 = [];
    s2 = peg$currPos;
    s3 = peg$parse_();
    s4 = peg$parseinline_constraint();
    if (s4 !== peg$FAILED) {
      peg$savedPos = s2;
      s2 = peg$f268(s4);
    } else {
      peg$currPos = s2;
      s2 = peg$FAILED;
    }
    while (s2 !== peg$FAILED) {
      s1.push(s2);
      s2 = peg$currPos;
      s3 = peg$parse_();
      s4 = peg$parseinline_constraint();
      if (s4 !== peg$FAILED) {
        peg$savedPos = s2;
        s2 = peg$f268(s4);
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
    }
    peg$savedPos = s0;
    s1 = peg$f269(s1);
    s0 = s1;

    return s0;
  }

  function peg$parseinline_constraint() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10;

    s0 = peg$currPos;
    s1 = peg$currPos;
    s2 = peg$parseKW_CONSTRAINT();
    if (s2 !== peg$FAILED) {
      s3 = peg$parse_();
      s4 = peg$parseidentifier_name();
      if (s4 !== peg$FAILED) {
        peg$savedPos = s1;
        s1 = peg$f270(s4);
      } else {
        peg$currPos = s1;
        s1 = peg$FAILED;
      }
    } else {
      peg$currPos = s1;
      s1 = peg$FAILED;
    }
    if (s1 === peg$FAILED) {
      s1 = null;
    }
    s2 = peg$parse_();
    s3 = peg$currPos;
    s4 = peg$parseKW_NOT();
    if (s4 === peg$FAILED) {
      s4 = null;
    }
    s5 = peg$parse_();
    s6 = peg$parseKW_NULL();
    if (s6 !== peg$FAILED) {
      peg$savedPos = s3;
      s3 = peg$f271(s1, s4);
    } else {
      peg$currPos = s3;
      s3 = peg$FAILED;
    }
    if (s3 === peg$FAILED) {
      s3 = peg$currPos;
      s4 = peg$parseKW_UNIQUE();
      if (s4 !== peg$FAILED) {
        peg$savedPos = s3;
        s4 = peg$f272(s1, s4);
      }
      s3 = s4;
      if (s3 === peg$FAILED) {
        s3 = peg$currPos;
        s4 = peg$parseKW_PRIMARY();
        if (s4 !== peg$FAILED) {
          s5 = peg$parse_();
          s6 = peg$parseKW_KEY();
          if (s6 !== peg$FAILED) {
            peg$savedPos = s3;
            s3 = peg$f273(s1);
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
        if (s3 === peg$FAILED) {
          s3 = peg$currPos;
          s4 = peg$parseKW_CHECK();
          if (s4 !== peg$FAILED) {
            s5 = peg$parse_();
            s6 = peg$parseLPAR();
            if (s6 !== peg$FAILED) {
              s7 = peg$parse_();
              s8 = peg$parsecondition();
              s9 = peg$parse_();
              s10 = peg$parseRPAR();
              if (s10 !== peg$FAILED) {
                peg$savedPos = s3;
                s3 = peg$f274(s1, s8);
              } else {
                peg$currPos = s3;
                s3 = peg$FAILED;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$FAILED;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
          if (s3 === peg$FAILED) {
            s3 = peg$parsereferences_clause();
          }
        }
      }
    }
    if (s3 !== peg$FAILED) {
      s4 = peg$parse_();
      s5 = peg$parseconstraint_state();
      if (s5 === peg$FAILED) {
        s5 = null;
      }
      peg$savedPos = s0;
      s0 = peg$f275(s1, s3, s5);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseconstraint_state() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11;

    s0 = peg$currPos;
    s1 = peg$currPos;
    s2 = peg$parsedeferrable_clause();
    if (s2 !== peg$FAILED) {
      s3 = peg$parse_();
      s4 = peg$parseinitially_clause();
      if (s4 === peg$FAILED) {
        s4 = null;
      }
      peg$savedPos = s1;
      s1 = peg$f276(s2, s4);
    } else {
      peg$currPos = s1;
      s1 = peg$FAILED;
    }
    if (s1 === peg$FAILED) {
      s1 = peg$currPos;
      s2 = peg$parseinitially_clause();
      if (s2 !== peg$FAILED) {
        s3 = peg$parse_();
        s4 = peg$parsedeferrable_clause();
        if (s4 === peg$FAILED) {
          s4 = null;
        }
        peg$savedPos = s1;
        s1 = peg$f277(s2, s4);
      } else {
        peg$currPos = s1;
        s1 = peg$FAILED;
      }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_RELY();
      if (s3 === peg$FAILED) {
        s3 = peg$parseKW_NORELY();
      }
      if (s3 === peg$FAILED) {
        s3 = null;
      }
      s4 = peg$parse_();
      s5 = peg$parseusing_index_clause();
      s6 = peg$parse_();
      s7 = peg$parseKW_ENABLE();
      if (s7 === peg$FAILED) {
        s7 = peg$parseKW_DISABLE();
      }
      if (s7 === peg$FAILED) {
        s7 = null;
      }
      s8 = peg$parse_();
      s9 = peg$parseKW_VALIDATE();
      if (s9 === peg$FAILED) {
        s9 = peg$parseKW_NOVALIDATE();
      }
      if (s9 === peg$FAILED) {
        s9 = null;
      }
      s10 = peg$parse_();
      s11 = peg$parseexception_clause();
      if (s11 === peg$FAILED) {
        s11 = null;
      }
      peg$savedPos = s0;
      s0 = peg$f278(s1, s3, s5, s7, s9, s11);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseexception_clause() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

    s0 = peg$currPos;
    s1 = peg$parseKW_EXCEPTIONS();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_INTO();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$currPos;
        s6 = peg$parseidentifier_name();
        if (s6 !== peg$FAILED) {
          s7 = peg$parse_();
          s8 = peg$parseDOT();
          if (s8 !== peg$FAILED) {
            s9 = peg$parse_();
            peg$savedPos = s5;
            s5 = peg$f279(s6);
          } else {
            peg$currPos = s5;
            s5 = peg$FAILED;
          }
        } else {
          peg$currPos = s5;
          s5 = peg$FAILED;
        }
        if (s5 === peg$FAILED) {
          s5 = null;
        }
        s6 = peg$parseidentifier_name();
        if (s6 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f280(s5, s6);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseusing_index_clause() {
    var s0;

    s0 = '';

    return s0;
  }

  function peg$parsedeferrable_clause() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parseKW_NOT();
    if (s1 === peg$FAILED) {
      s1 = null;
    }
    s2 = peg$parse_();
    s3 = peg$parseKW_DEFERRABLE();
    if (s3 !== peg$FAILED) {
      peg$savedPos = s0;
      s0 = peg$f281(s1, s3);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseinitially_clause() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parseKW_INITIALLY();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_DEFERRED();
      if (s3 === peg$FAILED) {
        s3 = peg$parseKW_IMMEDIATE();
      }
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f282(s1, s3);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsereferences_clause() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15;

    s0 = peg$currPos;
    s1 = peg$parseKW_REFERENCES();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$currPos;
      s4 = peg$currPos;
      s5 = peg$parseidentifier_name();
      if (s5 !== peg$FAILED) {
        s6 = peg$parse_();
        s7 = peg$parseDOT();
        if (s7 !== peg$FAILED) {
          s8 = peg$parse_();
          peg$savedPos = s4;
          s4 = peg$f283(s5);
        } else {
          peg$currPos = s4;
          s4 = peg$FAILED;
        }
      } else {
        peg$currPos = s4;
        s4 = peg$FAILED;
      }
      if (s4 === peg$FAILED) {
        s4 = null;
      }
      s5 = peg$parse_();
      s6 = peg$parseidentifier_name();
      if (s6 !== peg$FAILED) {
        peg$savedPos = s3;
        s3 = peg$f284(s4, s6);
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$currPos;
        s6 = peg$parseLPAR();
        if (s6 !== peg$FAILED) {
          s7 = peg$parse_();
          s8 = peg$parsecomma_separated_identifiers();
          if (s8 !== peg$FAILED) {
            s9 = peg$parse_();
            s10 = peg$parseRPAR();
            if (s10 !== peg$FAILED) {
              peg$savedPos = s5;
              s5 = peg$f285(s3, s8);
            } else {
              peg$currPos = s5;
              s5 = peg$FAILED;
            }
          } else {
            peg$currPos = s5;
            s5 = peg$FAILED;
          }
        } else {
          peg$currPos = s5;
          s5 = peg$FAILED;
        }
        if (s5 === peg$FAILED) {
          s5 = null;
        }
        s6 = peg$parse_();
        s7 = peg$currPos;
        s8 = peg$parseKW_ON();
        if (s8 !== peg$FAILED) {
          s9 = peg$parse_();
          s10 = peg$parseKW_DELETE();
          if (s10 !== peg$FAILED) {
            s11 = peg$parse_();
            s12 = peg$parseKW_CASCADE();
            if (s12 === peg$FAILED) {
              s12 = peg$currPos;
              s13 = peg$parseKW_SET();
              if (s13 !== peg$FAILED) {
                s14 = peg$parse_();
                s15 = peg$parseKW_NULL();
                if (s15 !== peg$FAILED) {
                  peg$savedPos = s12;
                  s12 = peg$f286(s3, s5);
                } else {
                  peg$currPos = s12;
                  s12 = peg$FAILED;
                }
              } else {
                peg$currPos = s12;
                s12 = peg$FAILED;
              }
            }
            if (s12 !== peg$FAILED) {
              peg$savedPos = s7;
              s7 = peg$f287(s3, s5, s12);
            } else {
              peg$currPos = s7;
              s7 = peg$FAILED;
            }
          } else {
            peg$currPos = s7;
            s7 = peg$FAILED;
          }
        } else {
          peg$currPos = s7;
          s7 = peg$FAILED;
        }
        if (s7 === peg$FAILED) {
          s7 = null;
        }
        peg$savedPos = s0;
        s0 = peg$f288(s3, s5, s7);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseencryption_spec() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10;

    s0 = peg$currPos;
    s1 = peg$currPos;
    s2 = peg$parseKW_USING();
    if (s2 !== peg$FAILED) {
      s3 = peg$parse_();
      s4 = peg$parsesingle_quoted_str();
      if (s4 !== peg$FAILED) {
        peg$savedPos = s1;
        s1 = peg$f289(s4);
      } else {
        peg$currPos = s1;
        s1 = peg$FAILED;
      }
    } else {
      peg$currPos = s1;
      s1 = peg$FAILED;
    }
    if (s1 === peg$FAILED) {
      s1 = null;
    }
    s2 = peg$parse_();
    s3 = peg$currPos;
    s4 = peg$parseKW_IDENTIFIED();
    if (s4 !== peg$FAILED) {
      s5 = peg$parse_();
      s6 = peg$parseKW_BY();
      if (s6 !== peg$FAILED) {
        s7 = peg$parse_();
        s8 = peg$parseident_name();
        if (s8 !== peg$FAILED) {
          peg$savedPos = s3;
          s3 = peg$f290(s1, s8);
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
    } else {
      peg$currPos = s3;
      s3 = peg$FAILED;
    }
    if (s3 === peg$FAILED) {
      s3 = null;
    }
    s4 = peg$parse_();
    s5 = peg$currPos;
    s6 = peg$parsesingle_quoted_str();
    if (s6 !== peg$FAILED) {
      peg$savedPos = s5;
      s6 = peg$f291(s1, s3, s6);
    }
    s5 = s6;
    if (s5 === peg$FAILED) {
      s5 = null;
    }
    s6 = peg$parse_();
    s7 = peg$currPos;
    s8 = peg$parseKW_NO();
    if (s8 === peg$FAILED) {
      s8 = null;
    }
    s9 = peg$parse_();
    s10 = peg$parseKW_SALT();
    if (s10 !== peg$FAILED) {
      peg$savedPos = s7;
      s7 = peg$f292(s1, s3, s5, s8);
    } else {
      peg$currPos = s7;
      s7 = peg$FAILED;
    }
    if (s7 === peg$FAILED) {
      s7 = null;
    }
    peg$savedPos = s0;
    s0 = peg$f293(s1, s3, s5, s7);

    return s0;
  }

  function peg$parsecolumn_default_clause() {
    var s0, s1, s2, s3, s4, s5, s6;

    s0 = peg$currPos;
    s1 = peg$parseKW_DEFAULT();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$currPos;
      s4 = peg$parseKW_ON();
      if (s4 !== peg$FAILED) {
        s5 = peg$parse_();
        s6 = peg$parseKW_NULL();
        if (s6 !== peg$FAILED) {
          peg$savedPos = s3;
          s3 = peg$f294();
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
      if (s3 === peg$FAILED) {
        s3 = null;
      }
      s4 = peg$parse_();
      s5 = peg$parseinteger();
      if (s5 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f295(s3, s5);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseidentity_clause() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10;

    s0 = peg$currPos;
    s1 = peg$parseKW_GENERATED();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$currPos;
      s4 = peg$parseKW_ALWAYS();
      if (s4 !== peg$FAILED) {
        peg$savedPos = s3;
        s4 = peg$f296(s1);
      }
      s3 = s4;
      if (s3 === peg$FAILED) {
        s3 = peg$currPos;
        s4 = peg$parseKW_BY();
        if (s4 !== peg$FAILED) {
          s5 = peg$parse_();
          s6 = peg$parseKW_DEFAULT();
          if (s6 !== peg$FAILED) {
            s7 = peg$currPos;
            s8 = peg$parseKW_ON();
            if (s8 !== peg$FAILED) {
              s9 = peg$parse_();
              s10 = peg$parseKW_NULL();
              if (s10 !== peg$FAILED) {
                peg$savedPos = s7;
                s7 = peg$f297(s1, s6);
              } else {
                peg$currPos = s7;
                s7 = peg$FAILED;
              }
            } else {
              peg$currPos = s7;
              s7 = peg$FAILED;
            }
            if (s7 === peg$FAILED) {
              s7 = null;
            }
            peg$savedPos = s3;
            s3 = peg$f298(s1, s6, s7);
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      }
      if (s3 === peg$FAILED) {
        s3 = null;
      }
      s4 = peg$parse_();
      s5 = peg$parseKW_AS();
      if (s5 !== peg$FAILED) {
        s6 = peg$parse_();
        s7 = peg$parseKW_IDENTITY();
        if (s7 !== peg$FAILED) {
          s8 = peg$parse_();
          s9 = peg$parseidentity_options();
          if (s9 === peg$FAILED) {
            s9 = null;
          }
          peg$savedPos = s0;
          s0 = peg$f299(s1, s3, s9);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseidentity_options() {
    var s0, s1, s2, s3, s4, s5;

    s0 = peg$currPos;
    s1 = peg$parseLPAR();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = [];
      s4 = peg$parseorder_clause();
      if (s4 === peg$FAILED) {
        s4 = peg$parsecycle_clause();
        if (s4 === peg$FAILED) {
          s4 = peg$parsecache_clause();
          if (s4 === peg$FAILED) {
            s4 = peg$parseminvalue_clause();
            if (s4 === peg$FAILED) {
              s4 = peg$parsemaxvalue_clause();
              if (s4 === peg$FAILED) {
                s4 = peg$parseincrement_clause();
                if (s4 === peg$FAILED) {
                  s4 = peg$parsestart_clause();
                }
              }
            }
          }
        }
      }
      if (s4 !== peg$FAILED) {
        while (s4 !== peg$FAILED) {
          s3.push(s4);
          s4 = peg$parseorder_clause();
          if (s4 === peg$FAILED) {
            s4 = peg$parsecycle_clause();
            if (s4 === peg$FAILED) {
              s4 = peg$parsecache_clause();
              if (s4 === peg$FAILED) {
                s4 = peg$parseminvalue_clause();
                if (s4 === peg$FAILED) {
                  s4 = peg$parsemaxvalue_clause();
                  if (s4 === peg$FAILED) {
                    s4 = peg$parseincrement_clause();
                    if (s4 === peg$FAILED) {
                      s4 = peg$parsestart_clause();
                    }
                  }
                }
              }
            }
          }
        }
      } else {
        s3 = peg$FAILED;
      }
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseRPAR();
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f300(s3);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseorder_clause() {
    var s0, s1;

    s0 = peg$currPos;
    s1 = peg$parseKW_ORDER();
    if (s1 === peg$FAILED) {
      s1 = peg$parseKW_NOORDER();
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f301(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parsecycle_clause() {
    var s0, s1;

    s0 = peg$currPos;
    s1 = peg$parseKW_CYCLE();
    if (s1 === peg$FAILED) {
      s1 = peg$parseKW_NOCYCLE();
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f302(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parsecache_clause() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parseKW_CACHE();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseinteger();
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f303(s1, s3);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseKW_NOCACHE();
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$f304(s1);
      }
      s0 = s1;
    }

    return s0;
  }

  function peg$parseminvalue_clause() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parseKW_MINVALUE();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseinteger();
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f305(s1, s3);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseKW_NOMINVALUE();
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$f306(s1);
      }
      s0 = s1;
    }

    return s0;
  }

  function peg$parsemaxvalue_clause() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parseKW_MAXVALUE();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseinteger();
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f307(s1, s3);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseKW_NOMAXVALUE();
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$f308(s1);
      }
      s0 = s1;
    }

    return s0;
  }

  function peg$parseincrement_clause() {
    var s0, s1, s2, s3, s4, s5;

    s0 = peg$currPos;
    s1 = peg$parseKW_INCREMENT();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_BY();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseinteger();
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f309(s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsestart_clause() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8;

    s0 = peg$currPos;
    s1 = peg$parseKW_START();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_WITH();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseinteger();
        if (s5 === peg$FAILED) {
          s5 = peg$currPos;
          s6 = peg$parseKW_LIMIT();
          if (s6 !== peg$FAILED) {
            s7 = peg$parse_();
            s8 = peg$parseKW_VALUE();
            if (s8 !== peg$FAILED) {
              peg$savedPos = s5;
              s5 = peg$f310();
            } else {
              peg$currPos = s5;
              s5 = peg$FAILED;
            }
          } else {
            peg$currPos = s5;
            s5 = peg$FAILED;
          }
        }
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f311(s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsedata_type() {
    var s0;

    s0 = peg$parseansi_supported_data_type();
    if (s0 === peg$FAILED) {
      s0 = peg$parseoracle_supplied_type();
      if (s0 === peg$FAILED) {
        s0 = peg$parseoracle_built_in_data_type();
      }
    }

    return s0;
  }

  function peg$parseoracle_built_in_data_type() {
    var s0;

    s0 = peg$parsecharacter_data_type();
    if (s0 === peg$FAILED) {
      s0 = peg$parsenumber_data_type();
      if (s0 === peg$FAILED) {
        s0 = peg$parserowid_data_type();
        if (s0 === peg$FAILED) {
          s0 = peg$parselong_and_raw_data_type();
          if (s0 === peg$FAILED) {
            s0 = peg$parsedatetime_data_type();
            if (s0 === peg$FAILED) {
              s0 = peg$parselarge_object_data_type();
            }
          }
        }
      }
    }

    return s0;
  }

  function peg$parsecharacter_data_type() {
    var s0;

    s0 = peg$parsecharacter_data_type_with_size();
    if (s0 === peg$FAILED) {
      s0 = peg$parsecharacter_data_type_with_size_and_semantics();
    }

    return s0;
  }

  function peg$parsecharacter_data_type_with_size() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8;

    s0 = peg$currPos;
    s1 = peg$parsecharacter_data_type_name();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 40) {
        s4 = peg$c4;
        peg$currPos++;
      } else {
        s4 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e5); }
      }
      if (s4 !== peg$FAILED) {
        s5 = peg$parse_();
        s6 = peg$parseinteger();
        if (s6 !== peg$FAILED) {
          s7 = peg$parse_();
          if (input.charCodeAt(peg$currPos) === 41) {
            s8 = peg$c5;
            peg$currPos++;
          } else {
            s8 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e6); }
          }
          if (s8 !== peg$FAILED) {
            peg$savedPos = s3;
            s3 = peg$f312(s1, s6);
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
      if (s3 === peg$FAILED) {
        s3 = null;
      }
      peg$savedPos = s0;
      s0 = peg$f313(s1, s3);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsecharacter_data_type_with_size_and_semantics() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parsecharacter_data_type_name_with_semantics();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parsecharacter_data_type_size_and_semantics();
      if (s3 === peg$FAILED) {
        s3 = null;
      }
      peg$savedPos = s0;
      s0 = peg$f314(s1, s3);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsecharacter_data_type_size_and_semantics() {
    var s0, s1, s2, s3, s4, s5, s6, s7;

    s0 = peg$currPos;
    if (input.charCodeAt(peg$currPos) === 40) {
      s1 = peg$c4;
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e5); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseinteger();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = input.substr(peg$currPos, 4);
        if (s5.toLowerCase() === peg$c6) {
          peg$currPos += 4;
        } else {
          s5 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e7); }
        }
        if (s5 === peg$FAILED) {
          s5 = input.substr(peg$currPos, 4);
          if (s5.toLowerCase() === peg$c7) {
            peg$currPos += 4;
          } else {
            s5 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e8); }
          }
        }
        if (s5 === peg$FAILED) {
          s5 = null;
        }
        s6 = peg$parse_();
        if (input.charCodeAt(peg$currPos) === 41) {
          s7 = peg$c5;
          peg$currPos++;
        } else {
          s7 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e6); }
        }
        if (s7 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f315(s3, s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsecharacter_data_type_name() {
    var s0, s1;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c8) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e9); }
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f316();
    }
    s0 = s1;
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = input.substr(peg$currPos, 9);
      if (s1.toLowerCase() === peg$c9) {
        peg$currPos += 9;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e10); }
      }
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$f317();
      }
      s0 = s1;
    }

    return s0;
  }

  function peg$parsecharacter_data_type_name_with_semantics() {
    var s0, s1;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c7) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e8); }
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f318();
    }
    s0 = s1;
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = input.substr(peg$currPos, 8);
      if (s1.toLowerCase() === peg$c10) {
        peg$currPos += 8;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e11); }
      }
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$f319();
      }
      s0 = s1;
    }

    return s0;
  }

  function peg$parsenumber_data_type() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 12);
    if (s1.toLowerCase() === peg$c11) {
      peg$currPos += 12;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e12); }
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f320();
    }
    s0 = s1;
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = input.substr(peg$currPos, 13);
      if (s1.toLowerCase() === peg$c12) {
        peg$currPos += 13;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e13); }
      }
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$f321();
      }
      s0 = s1;
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = input.substr(peg$currPos, 5);
        if (s1.toLowerCase() === peg$c13) {
          peg$currPos += 5;
        } else {
          s1 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e14); }
        }
        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();
          s3 = peg$currPos;
          if (input.charCodeAt(peg$currPos) === 40) {
            s4 = peg$c4;
            peg$currPos++;
          } else {
            s4 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e5); }
          }
          if (s4 !== peg$FAILED) {
            s5 = peg$parse_();
            s6 = peg$parseinteger();
            if (s6 !== peg$FAILED) {
              s7 = peg$parse_();
              if (input.charCodeAt(peg$currPos) === 41) {
                s8 = peg$c5;
                peg$currPos++;
              } else {
                s8 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$e6); }
              }
              if (s8 !== peg$FAILED) {
                peg$savedPos = s3;
                s3 = peg$f322(s6);
              } else {
                peg$currPos = s3;
                s3 = peg$FAILED;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$FAILED;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
          if (s3 === peg$FAILED) {
            s3 = null;
          }
          peg$savedPos = s0;
          s0 = peg$f323(s3);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = input.substr(peg$currPos, 6);
          if (s1.toLowerCase() === peg$c14) {
            peg$currPos += 6;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e15); }
          }
          if (s1 !== peg$FAILED) {
            s2 = peg$parse_();
            s3 = peg$currPos;
            if (input.charCodeAt(peg$currPos) === 40) {
              s4 = peg$c4;
              peg$currPos++;
            } else {
              s4 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$e5); }
            }
            if (s4 !== peg$FAILED) {
              s5 = peg$parse_();
              s6 = peg$parseinteger();
              if (s6 !== peg$FAILED) {
                s7 = peg$parse_();
                s8 = peg$currPos;
                if (input.charCodeAt(peg$currPos) === 44) {
                  s9 = peg$c15;
                  peg$currPos++;
                } else {
                  s9 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$e16); }
                }
                if (s9 !== peg$FAILED) {
                  s10 = peg$parse_();
                  s11 = peg$parseinteger();
                  if (s11 !== peg$FAILED) {
                    peg$savedPos = s8;
                    s8 = peg$f324(s6, s11);
                  } else {
                    peg$currPos = s8;
                    s8 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s8;
                  s8 = peg$FAILED;
                }
                if (s8 === peg$FAILED) {
                  s8 = null;
                }
                s9 = peg$parse_();
                if (input.charCodeAt(peg$currPos) === 41) {
                  s10 = peg$c5;
                  peg$currPos++;
                } else {
                  s10 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$e6); }
                }
                if (s10 !== peg$FAILED) {
                  peg$savedPos = s3;
                  s3 = peg$f325(s6, s8);
                } else {
                  peg$currPos = s3;
                  s3 = peg$FAILED;
                }
              } else {
                peg$currPos = s3;
                s3 = peg$FAILED;
              }
            } else {
              peg$currPos = s3;
              s3 = peg$FAILED;
            }
            if (s3 === peg$FAILED) {
              s3 = null;
            }
            peg$savedPos = s0;
            s0 = peg$f326(s3);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        }
      }
    }

    return s0;
  }

  function peg$parselong_and_raw_data_type() {
    var s0, s1, s2, s3, s4, s5, s6, s7;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c16) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e17); }
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f327();
    }
    s0 = s1;
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = input.substr(peg$currPos, 4);
      if (s1.toLowerCase() === peg$c17) {
        peg$currPos += 4;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e18); }
      }
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$f328();
      }
      s0 = s1;
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = input.substr(peg$currPos, 3);
        if (s1.toLowerCase() === peg$c18) {
          peg$currPos += 3;
        } else {
          s1 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e19); }
        }
        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();
          if (input.charCodeAt(peg$currPos) === 40) {
            s3 = peg$c4;
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e5); }
          }
          if (s3 !== peg$FAILED) {
            s4 = peg$parse_();
            s5 = peg$parseinteger();
            if (s5 !== peg$FAILED) {
              s6 = peg$parse_();
              if (input.charCodeAt(peg$currPos) === 41) {
                s7 = peg$c5;
                peg$currPos++;
              } else {
                s7 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$e6); }
              }
              if (s7 !== peg$FAILED) {
                peg$savedPos = s0;
                s0 = peg$f329(s5);
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      }
    }

    return s0;
  }

  function peg$parselarge_object_data_type() {
    var s0, s1;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c19) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e20); }
    }
    if (s1 === peg$FAILED) {
      s1 = input.substr(peg$currPos, 4);
      if (s1.toLowerCase() === peg$c20) {
        peg$currPos += 4;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e21); }
      }
      if (s1 === peg$FAILED) {
        s1 = input.substr(peg$currPos, 5);
        if (s1.toLowerCase() === peg$c21) {
          peg$currPos += 5;
        } else {
          s1 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e22); }
        }
        if (s1 === peg$FAILED) {
          s1 = input.substr(peg$currPos, 5);
          if (s1.toLowerCase() === peg$c22) {
            peg$currPos += 5;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e23); }
          }
        }
      }
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f330(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parserowid_data_type() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c23) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e24); }
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f331();
    }
    s0 = s1;
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = input.substr(peg$currPos, 6);
      if (s1.toLowerCase() === peg$c24) {
        peg$currPos += 6;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e25); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        s3 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 40) {
          s4 = peg$c4;
          peg$currPos++;
        } else {
          s4 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e5); }
        }
        if (s4 !== peg$FAILED) {
          s5 = peg$parse_();
          s6 = peg$parseinteger();
          if (s6 !== peg$FAILED) {
            s7 = peg$parse_();
            if (input.charCodeAt(peg$currPos) === 41) {
              s8 = peg$c5;
              peg$currPos++;
            } else {
              s8 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$e6); }
            }
            if (s8 !== peg$FAILED) {
              peg$savedPos = s3;
              s3 = peg$f332(s6);
            } else {
              peg$currPos = s3;
              s3 = peg$FAILED;
            }
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
        if (s3 === peg$FAILED) {
          s3 = null;
        }
        peg$savedPos = s0;
        s0 = peg$f333(s3);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    }

    return s0;
  }

  function peg$parsedatetime_data_type() {
    var s0, s1;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c25) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e26); }
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f334();
    }
    s0 = s1;
    if (s0 === peg$FAILED) {
      s0 = peg$parsedatetime_type_timestamp();
      if (s0 === peg$FAILED) {
        s0 = peg$parsedatetime_type_interval_day();
        if (s0 === peg$FAILED) {
          s0 = peg$parsedatetime_type_interval_year();
        }
      }
    }

    return s0;
  }

  function peg$parsedatetime_type_timestamp() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 9);
    if (s1.toLowerCase() === peg$c26) {
      peg$currPos += 9;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e27); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 40) {
        s4 = peg$c4;
        peg$currPos++;
      } else {
        s4 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e5); }
      }
      if (s4 !== peg$FAILED) {
        s5 = peg$parse_();
        s6 = peg$parseinteger();
        if (s6 !== peg$FAILED) {
          s7 = peg$parse_();
          if (input.charCodeAt(peg$currPos) === 41) {
            s8 = peg$c5;
            peg$currPos++;
          } else {
            s8 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e6); }
          }
          if (s8 !== peg$FAILED) {
            peg$savedPos = s3;
            s3 = peg$f335(s6);
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
      if (s3 === peg$FAILED) {
        s3 = null;
      }
      s4 = peg$parse_();
      s5 = peg$currPos;
      s6 = input.substr(peg$currPos, 4);
      if (s6.toLowerCase() === peg$c27) {
        peg$currPos += 4;
      } else {
        s6 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e28); }
      }
      if (s6 !== peg$FAILED) {
        s7 = peg$parse_();
        s8 = peg$currPos;
        s9 = input.substr(peg$currPos, 5);
        if (s9.toLowerCase() === peg$c28) {
          peg$currPos += 5;
        } else {
          s9 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e29); }
        }
        if (s9 !== peg$FAILED) {
          peg$savedPos = s8;
          s9 = peg$f336(s3);
        }
        s8 = s9;
        if (s8 === peg$FAILED) {
          s8 = null;
        }
        s9 = peg$parse_();
        s10 = input.substr(peg$currPos, 4);
        if (s10.toLowerCase() === peg$c29) {
          peg$currPos += 4;
        } else {
          s10 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e30); }
        }
        if (s10 !== peg$FAILED) {
          s11 = peg$parse_();
          s12 = input.substr(peg$currPos, 4);
          if (s12.toLowerCase() === peg$c30) {
            peg$currPos += 4;
          } else {
            s12 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e31); }
          }
          if (s12 !== peg$FAILED) {
            peg$savedPos = s5;
            s5 = peg$f337(s3, s8);
          } else {
            peg$currPos = s5;
            s5 = peg$FAILED;
          }
        } else {
          peg$currPos = s5;
          s5 = peg$FAILED;
        }
      } else {
        peg$currPos = s5;
        s5 = peg$FAILED;
      }
      if (s5 === peg$FAILED) {
        s5 = null;
      }
      peg$savedPos = s0;
      s0 = peg$f338(s3, s5);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsedatetime_type_interval_year() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c31) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e32); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = input.substr(peg$currPos, 4);
      if (s3.toLowerCase() === peg$c32) {
        peg$currPos += 4;
      } else {
        s3 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e33); }
      }
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 40) {
          s6 = peg$c4;
          peg$currPos++;
        } else {
          s6 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e5); }
        }
        if (s6 !== peg$FAILED) {
          s7 = peg$parse_();
          s8 = peg$parseinteger();
          if (s8 !== peg$FAILED) {
            s9 = peg$parse_();
            if (input.charCodeAt(peg$currPos) === 41) {
              s10 = peg$c5;
              peg$currPos++;
            } else {
              s10 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$e6); }
            }
            if (s10 !== peg$FAILED) {
              peg$savedPos = s5;
              s5 = peg$f339(s8);
            } else {
              peg$currPos = s5;
              s5 = peg$FAILED;
            }
          } else {
            peg$currPos = s5;
            s5 = peg$FAILED;
          }
        } else {
          peg$currPos = s5;
          s5 = peg$FAILED;
        }
        if (s5 === peg$FAILED) {
          s5 = null;
        }
        s6 = peg$parse_();
        if (input.substr(peg$currPos, 2) === peg$c33) {
          s7 = peg$c33;
          peg$currPos += 2;
        } else {
          s7 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e34); }
        }
        if (s7 !== peg$FAILED) {
          s8 = peg$parse_();
          s9 = input.substr(peg$currPos, 5);
          if (s9.toLowerCase() === peg$c34) {
            peg$currPos += 5;
          } else {
            s9 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e35); }
          }
          if (s9 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f340(s5);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parsedatetime_type_interval_day() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11, s12, s13, s14, s15, s16;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c31) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e32); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = input.substr(peg$currPos, 3);
      if (s3.toLowerCase() === peg$c35) {
        peg$currPos += 3;
      } else {
        s3 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e36); }
      }
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 40) {
          s6 = peg$c4;
          peg$currPos++;
        } else {
          s6 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e5); }
        }
        if (s6 !== peg$FAILED) {
          s7 = peg$parse_();
          s8 = peg$parseinteger();
          if (s8 !== peg$FAILED) {
            s9 = peg$parse_();
            if (input.charCodeAt(peg$currPos) === 41) {
              s10 = peg$c5;
              peg$currPos++;
            } else {
              s10 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$e6); }
            }
            if (s10 !== peg$FAILED) {
              peg$savedPos = s5;
              s5 = peg$f341(s8);
            } else {
              peg$currPos = s5;
              s5 = peg$FAILED;
            }
          } else {
            peg$currPos = s5;
            s5 = peg$FAILED;
          }
        } else {
          peg$currPos = s5;
          s5 = peg$FAILED;
        }
        if (s5 === peg$FAILED) {
          s5 = null;
        }
        s6 = peg$parse_();
        if (input.substr(peg$currPos, 2) === peg$c33) {
          s7 = peg$c33;
          peg$currPos += 2;
        } else {
          s7 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e34); }
        }
        if (s7 !== peg$FAILED) {
          s8 = peg$parse_();
          s9 = input.substr(peg$currPos, 6);
          if (s9.toLowerCase() === peg$c36) {
            peg$currPos += 6;
          } else {
            s9 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e37); }
          }
          if (s9 !== peg$FAILED) {
            s10 = peg$parse_();
            s11 = peg$currPos;
            if (input.charCodeAt(peg$currPos) === 40) {
              s12 = peg$c4;
              peg$currPos++;
            } else {
              s12 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$e5); }
            }
            if (s12 !== peg$FAILED) {
              s13 = peg$parse_();
              s14 = peg$parseinteger();
              if (s14 !== peg$FAILED) {
                s15 = peg$parse_();
                if (input.charCodeAt(peg$currPos) === 41) {
                  s16 = peg$c5;
                  peg$currPos++;
                } else {
                  s16 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$e6); }
                }
                if (s16 !== peg$FAILED) {
                  peg$savedPos = s11;
                  s11 = peg$f342(s5, s14);
                } else {
                  peg$currPos = s11;
                  s11 = peg$FAILED;
                }
              } else {
                peg$currPos = s11;
                s11 = peg$FAILED;
              }
            } else {
              peg$currPos = s11;
              s11 = peg$FAILED;
            }
            if (s11 === peg$FAILED) {
              s11 = null;
            }
            peg$savedPos = s0;
            s0 = peg$f343(s5, s11);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseoracle_supplied_type() {
    var s0;

    s0 = peg$parseany_type();
    if (s0 === peg$FAILED) {
      s0 = peg$parseXML_type();
      if (s0 === peg$FAILED) {
        s0 = peg$parsespacial_type();
      }
    }

    return s0;
  }

  function peg$parsespacial_type() {
    var s0, s1;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 12);
    if (s1.toLowerCase() === peg$c37) {
      peg$currPos += 12;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e38); }
    }
    if (s1 === peg$FAILED) {
      s1 = input.substr(peg$currPos, 17);
      if (s1.toLowerCase() === peg$c38) {
        peg$currPos += 17;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e39); }
      }
      if (s1 === peg$FAILED) {
        if (input.substr(peg$currPos, 13) === peg$c39) {
          s1 = peg$c39;
          peg$currPos += 13;
        } else {
          s1 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e40); }
        }
      }
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f344(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parseXML_type() {
    var s0, s1;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c40) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e41); }
    }
    if (s1 === peg$FAILED) {
      s1 = input.substr(peg$currPos, 7);
      if (s1.toLowerCase() === peg$c41) {
        peg$currPos += 7;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e42); }
      }
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f345(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parseany_type() {
    var s0, s1;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 14);
    if (s1.toLowerCase() === peg$c42) {
      peg$currPos += 14;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e43); }
    }
    if (s1 === peg$FAILED) {
      s1 = input.substr(peg$currPos, 11);
      if (s1.toLowerCase() === peg$c43) {
        peg$currPos += 11;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e44); }
      }
      if (s1 === peg$FAILED) {
        s1 = input.substr(peg$currPos, 11);
        if (s1.toLowerCase() === peg$c44) {
          peg$currPos += 11;
        } else {
          s1 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e45); }
        }
      }
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f346(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parseansi_supported_data_type() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11;

    s0 = peg$currPos;
    s1 = peg$parseKW_CHARACTER();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseKW_VARYING();
      if (s3 === peg$FAILED) {
        s3 = null;
      }
      s4 = peg$parse_();
      s5 = peg$parseLPAR();
      if (s5 !== peg$FAILED) {
        s6 = peg$parse_();
        s7 = peg$parseinteger();
        if (s7 !== peg$FAILED) {
          s8 = peg$parse_();
          s9 = peg$parseRPAR();
          if (s9 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f347(s1, s3, s7);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseKW_CHAR();
      if (s1 === peg$FAILED) {
        s1 = peg$parseKW_NCHAR();
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        s3 = peg$parseKW_VARYING();
        if (s3 !== peg$FAILED) {
          s4 = peg$parse_();
          s5 = peg$parseLPAR();
          if (s5 !== peg$FAILED) {
            s6 = peg$parse_();
            s7 = peg$parseinteger();
            if (s7 !== peg$FAILED) {
              s8 = peg$parse_();
              s9 = peg$parseRPAR();
              if (s9 !== peg$FAILED) {
                peg$savedPos = s0;
                s0 = peg$f348(s1, s3, s7);
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$parseKW_VARCHAR();
        if (s1 !== peg$FAILED) {
          s2 = peg$parse_();
          s3 = peg$parseLPAR();
          if (s3 !== peg$FAILED) {
            s4 = peg$parse_();
            s5 = peg$parseinteger();
            if (s5 !== peg$FAILED) {
              s6 = peg$parse_();
              s7 = peg$parseRPAR();
              if (s7 !== peg$FAILED) {
                peg$savedPos = s0;
                s0 = peg$f349(s1, s5);
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$parseKW_NATIONAL();
          if (s1 !== peg$FAILED) {
            s2 = peg$parse_();
            s3 = peg$parseKW_CHAR();
            if (s3 === peg$FAILED) {
              s3 = peg$parseKW_CHARACTER();
            }
            if (s3 !== peg$FAILED) {
              s4 = peg$parse_();
              s5 = peg$parseKW_VARYING();
              if (s5 === peg$FAILED) {
                s5 = null;
              }
              s6 = peg$parse_();
              s7 = peg$parseLPAR();
              if (s7 !== peg$FAILED) {
                s8 = peg$parse_();
                s9 = peg$parseinteger();
                if (s9 !== peg$FAILED) {
                  s10 = peg$parse_();
                  s11 = peg$parseRPAR();
                  if (s11 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s0 = peg$f350(s1, s3, s5, s9);
                  } else {
                    peg$currPos = s0;
                    s0 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$parseKW_INT();
            if (s1 === peg$FAILED) {
              s1 = peg$parseKW_INTEGER();
              if (s1 === peg$FAILED) {
                s1 = peg$parseKW_SMALLINT();
                if (s1 === peg$FAILED) {
                  s1 = peg$parseKW_REAL();
                }
              }
            }
            if (s1 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$f351(s1);
            }
            s0 = s1;
            if (s0 === peg$FAILED) {
              s0 = peg$currPos;
              s1 = peg$parseKW_FLOAT();
              if (s1 !== peg$FAILED) {
                s2 = peg$parse_();
                s3 = peg$currPos;
                s4 = peg$parseLPAR();
                if (s4 !== peg$FAILED) {
                  s5 = peg$parse_();
                  s6 = peg$parseinteger();
                  if (s6 !== peg$FAILED) {
                    s7 = peg$parse_();
                    s8 = peg$parseRPAR();
                    if (s8 !== peg$FAILED) {
                      peg$savedPos = s3;
                      s3 = peg$f352(s1, s6);
                    } else {
                      peg$currPos = s3;
                      s3 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s3;
                    s3 = peg$FAILED;
                  }
                } else {
                  peg$currPos = s3;
                  s3 = peg$FAILED;
                }
                if (s3 === peg$FAILED) {
                  s3 = null;
                }
                peg$savedPos = s0;
                s0 = peg$f353(s1, s3);
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
              if (s0 === peg$FAILED) {
                s0 = peg$currPos;
                s1 = peg$parseKW_NUMERIC();
                if (s1 === peg$FAILED) {
                  s1 = peg$parseKW_DECIMAL();
                  if (s1 === peg$FAILED) {
                    s1 = peg$parseKW_DEC();
                  }
                }
                if (s1 !== peg$FAILED) {
                  s2 = peg$currPos;
                  s3 = peg$parseLPAR();
                  if (s3 !== peg$FAILED) {
                    s4 = peg$parse_();
                    s5 = peg$parseinteger();
                    if (s5 !== peg$FAILED) {
                      s6 = peg$parse_();
                      s7 = peg$currPos;
                      s8 = peg$parseCOMMA();
                      if (s8 !== peg$FAILED) {
                        s9 = peg$parse_();
                        s10 = peg$parseinteger();
                        if (s10 !== peg$FAILED) {
                          peg$savedPos = s7;
                          s7 = peg$f354(s1, s5, s10);
                        } else {
                          peg$currPos = s7;
                          s7 = peg$FAILED;
                        }
                      } else {
                        peg$currPos = s7;
                        s7 = peg$FAILED;
                      }
                      if (s7 === peg$FAILED) {
                        s7 = null;
                      }
                      s8 = peg$parse_();
                      s9 = peg$parseRPAR();
                      if (s9 !== peg$FAILED) {
                        peg$savedPos = s2;
                        s2 = peg$f355(s1, s5, s7);
                      } else {
                        peg$currPos = s2;
                        s2 = peg$FAILED;
                      }
                    } else {
                      peg$currPos = s2;
                      s2 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s2;
                    s2 = peg$FAILED;
                  }
                  if (s2 === peg$FAILED) {
                    s2 = null;
                  }
                  peg$savedPos = s0;
                  s0 = peg$f356(s1, s2);
                } else {
                  peg$currPos = s0;
                  s0 = peg$FAILED;
                }
                if (s0 === peg$FAILED) {
                  s0 = peg$currPos;
                  s1 = peg$currPos;
                  s2 = peg$parseKW_DOUBLE();
                  if (s2 !== peg$FAILED) {
                    s3 = peg$parse_();
                    s4 = peg$parseKW_PRECISION();
                    if (s4 !== peg$FAILED) {
                      s2 = [s2, s3, s4];
                      s1 = s2;
                    } else {
                      peg$currPos = s1;
                      s1 = peg$FAILED;
                    }
                  } else {
                    peg$currPos = s1;
                    s1 = peg$FAILED;
                  }
                  if (s1 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$f357(s1);
                  }
                  s0 = s1;
                }
              }
            }
          }
        }
      }
    }

    return s0;
  }

  function peg$parselogging_clause() {
    var s0;

    s0 = peg$parseKW_LOGGING();
    if (s0 === peg$FAILED) {
      s0 = peg$parseKW_NOLOGGING();
      if (s0 === peg$FAILED) {
        s0 = peg$parseKW_FILESYSTEM_LIKE_LOGGING();
      }
    }

    return s0;
  }

  function peg$parseobject_table() {
    var s0;

    s0 = '';

    return s0;
  }

  function peg$parseXMLType_table() {
    var s0;

    s0 = '';

    return s0;
  }

  function peg$parsesubquery() {
    var s0;

    s0 = '';

    return s0;
  }

  function peg$parsecondition() {
    var s0;

    s0 = '';

    return s0;
  }

  function peg$parsecomma_separated_identifiers() {
    var s0, s1, s2, s3, s4, s5, s6, s7;

    s0 = peg$currPos;
    s1 = peg$parseidentifier_name();
    if (s1 !== peg$FAILED) {
      s2 = [];
      s3 = peg$currPos;
      s4 = peg$parse_();
      s5 = peg$parseCOMMA();
      if (s5 !== peg$FAILED) {
        s6 = peg$parse_();
        s7 = peg$parseidentifier_name();
        if (s7 !== peg$FAILED) {
          peg$savedPos = s3;
          s3 = peg$f358(s1, s7);
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
      while (s3 !== peg$FAILED) {
        s2.push(s3);
        s3 = peg$currPos;
        s4 = peg$parse_();
        s5 = peg$parseCOMMA();
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parseidentifier_name();
          if (s7 !== peg$FAILED) {
            peg$savedPos = s3;
            s3 = peg$f358(s1, s7);
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      }
      peg$savedPos = s0;
      s0 = peg$f359(s1, s2);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseinteger() {
    var s0, s1, s2;

    s0 = peg$currPos;
    s1 = [];
    s2 = input.charAt(peg$currPos);
    if (peg$r1.test(s2)) {
      peg$currPos++;
    } else {
      s2 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e46); }
    }
    if (s2 !== peg$FAILED) {
      while (s2 !== peg$FAILED) {
        s1.push(s2);
        s2 = input.charAt(peg$currPos);
        if (peg$r1.test(s2)) {
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e46); }
        }
      }
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f360(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parsesingle_quoted_str() {
    var s0, s1, s2;

    s0 = peg$currPos;
    s1 = peg$parseSQUO();
    if (s1 !== peg$FAILED) {
      s2 = peg$parseany();
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f361(s2);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseany() {
    var s0, s1, s2;

    s0 = peg$currPos;
    s1 = [];
    s2 = input.charAt(peg$currPos);
    if (peg$r2.test(s2)) {
      peg$currPos++;
    } else {
      s2 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e47); }
    }
    if (s2 !== peg$FAILED) {
      while (s2 !== peg$FAILED) {
        s1.push(s2);
        s2 = input.charAt(peg$currPos);
        if (peg$r2.test(s2)) {
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e47); }
        }
      }
    } else {
      s1 = peg$FAILED;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f362(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parseidentifier_name() {
    var s0, s1;

    s0 = peg$currPos;
    s1 = peg$parseident_name();
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f363(s1);
    }
    s0 = s1;

    return s0;
  }

  function peg$parseident_name() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = peg$parseident_start();
    if (s1 !== peg$FAILED) {
      s2 = [];
      s3 = peg$parseident_part();
      while (s3 !== peg$FAILED) {
        s2.push(s3);
        s3 = peg$parseident_part();
      }
      peg$savedPos = s0;
      s0 = peg$f364(s1, s2);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseident_start() {
    var s0;

    s0 = input.charAt(peg$currPos);
    if (peg$r3.test(s0)) {
      peg$currPos++;
    } else {
      s0 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e48); }
    }

    return s0;
  }

  function peg$parseident_part() {
    var s0;

    s0 = input.charAt(peg$currPos);
    if (peg$r4.test(s0)) {
      peg$currPos++;
    } else {
      s0 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e49); }
    }

    return s0;
  }

  function peg$parse_() {
    var s0, s1;

    s0 = [];
    s1 = input.charAt(peg$currPos);
    if (peg$r5.test(s1)) {
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e50); }
    }
    while (s1 !== peg$FAILED) {
      s0.push(s1);
      s1 = input.charAt(peg$currPos);
      if (peg$r5.test(s1)) {
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e50); }
      }
    }

    return s0;
  }

  function peg$parseEQ() {
    var s0;

    if (input.charCodeAt(peg$currPos) === 61) {
      s0 = peg$c45;
      peg$currPos++;
    } else {
      s0 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e51); }
    }

    return s0;
  }

  function peg$parseDOT() {
    var s0;

    if (input.charCodeAt(peg$currPos) === 46) {
      s0 = peg$c46;
      peg$currPos++;
    } else {
      s0 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e52); }
    }

    return s0;
  }

  function peg$parseLPAR() {
    var s0;

    if (input.charCodeAt(peg$currPos) === 40) {
      s0 = peg$c4;
      peg$currPos++;
    } else {
      s0 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e5); }
    }

    return s0;
  }

  function peg$parseRPAR() {
    var s0;

    if (input.charCodeAt(peg$currPos) === 41) {
      s0 = peg$c5;
      peg$currPos++;
    } else {
      s0 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e6); }
    }

    return s0;
  }

  function peg$parseCOMMA() {
    var s0;

    if (input.charCodeAt(peg$currPos) === 44) {
      s0 = peg$c15;
      peg$currPos++;
    } else {
      s0 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e16); }
    }

    return s0;
  }

  function peg$parseSEMI_COLON() {
    var s0;

    if (input.charCodeAt(peg$currPos) === 59) {
      s0 = peg$c47;
      peg$currPos++;
    } else {
      s0 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e53); }
    }

    return s0;
  }

  function peg$parseSQUO() {
    var s0;

    if (input.charCodeAt(peg$currPos) === 39) {
      s0 = peg$c48;
      peg$currPos++;
    } else {
      s0 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e54); }
    }

    return s0;
  }

  function peg$parseCOLON() {
    var s0;

    if (input.charCodeAt(peg$currPos) === 58) {
      s0 = peg$c49;
      peg$currPos++;
    } else {
      s0 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e55); }
    }

    return s0;
  }

  function peg$parseKW_CREATE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c50) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e56); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f365();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_TABLE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c51) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e57); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f366();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_GLOBAL() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c52) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e58); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f367();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_PRIVATE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c53) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e59); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f368();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_TEMPORARY() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 9);
    if (s1.toLowerCase() === peg$c54) {
      peg$currPos += 9;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e60); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f369();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_SHARED() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c55) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e61); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f370();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_DUPLICATED() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 10);
    if (s1.toLowerCase() === peg$c56) {
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e62); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f371();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_IMMUTABLE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 9);
    if (s1.toLowerCase() === peg$c57) {
      peg$currPos += 9;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e63); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f372();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_BLOCKCHAIN() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 10);
    if (s1.toLowerCase() === peg$c58) {
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e64); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f373();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_SHARING() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c59) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e65); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f374();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_METADATA() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c60) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e66); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f375();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_DATA() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c61) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e67); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f376();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_EXTENDED() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c62) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e68); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f377();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_NONE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c63) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e69); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f378();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_MEMOPTIMIZE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 11);
    if (s1.toLowerCase() === peg$c64) {
      peg$currPos += 11;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e70); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f379();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_FOR() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 3);
    if (s1.toLowerCase() === peg$c65) {
      peg$currPos += 3;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e71); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f380();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_READ() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c66) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e72); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f381();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_WRITE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c67) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e73); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f382();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_PARENT() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c68) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e74); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f383();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_NO() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 2);
    if (s1.toLowerCase() === peg$c69) {
      peg$currPos += 2;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e75); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f384();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_ON() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 2);
    if (s1.toLowerCase() === peg$c70) {
      peg$currPos += 2;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e76); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f385();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_NOT() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 3);
    if (s1.toLowerCase() === peg$c71) {
      peg$currPos += 3;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e77); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f386();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_INTO() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c72) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e78); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f387();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_DROP() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c73) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e79); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f388();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_DELETE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c74) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e80); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f389();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_UNTIL() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c75) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e81); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f390();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_DAYS() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c76) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e82); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f391();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_IDLE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c77) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e83); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f392();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_LOCKED() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c78) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e84); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f393();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_AFTER() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c79) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e85); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f394();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_INSERT() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c80) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e86); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f395();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_HASHING() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c81) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e87); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f396();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_USING() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c82) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e88); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f397();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_VERSION() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c83) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e89); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f398();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_DEFAULT() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c84) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e90); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f399();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_COLLATION() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 9);
    if (s1.toLowerCase() === peg$c85) {
      peg$currPos += 9;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e91); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f400();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_COLLATE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c86) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e92); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f401();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_COMMIT() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c87) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e93); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f402();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_PRESERVE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c88) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e94); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f403();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_DEFINITION() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 10);
    if (s1.toLowerCase() === peg$c89) {
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e95); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f404();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_ROWS() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c90) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e96); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f405();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_SORT() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c91) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e97); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f406();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_VISIBLE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c92) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e98); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f407();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_INVISIBLE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 9);
    if (s1.toLowerCase() === peg$c93) {
      peg$currPos += 9;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e99); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f408();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_NULL() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c94) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e100); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f409();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_GENERATED() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 9);
    if (s1.toLowerCase() === peg$c95) {
      peg$currPos += 9;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e101); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f410();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_ALWAYS() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c96) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e102); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f411();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_BY() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 2);
    if (s1.toLowerCase() === peg$c97) {
      peg$currPos += 2;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e103); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f412();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_AS() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 2);
    if (s1.toLowerCase() === peg$c98) {
      peg$currPos += 2;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e104); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f413();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_IS() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 2);
    if (s1.toLowerCase() === peg$c99) {
      peg$currPos += 2;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e105); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f414();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_OF() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 2);
    if (s1.toLowerCase() === peg$c100) {
      peg$currPos += 2;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e106); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f415();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_TO() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 2);
    if (s1.toLowerCase() === peg$c33) {
      peg$currPos += 2;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e107); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f416();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_IDENTITY() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c101) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e108); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f417();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_START() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c102) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e109); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f418();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_WITH() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c27) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e28); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f419();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_SALT() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c103) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e110); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f420();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_LIMIT() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c104) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e111); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f421();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_VALUE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c105) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e112); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f422();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_INCREMENT() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 9);
    if (s1.toLowerCase() === peg$c106) {
      peg$currPos += 9;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e113); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f423();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_MAXVALUE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c107) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e114); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f424();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_NOMAXVALUE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 10);
    if (s1.toLowerCase() === peg$c108) {
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e115); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f425();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_MINVALUE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c109) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e116); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f426();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_NOMINVALUE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 10);
    if (s1.toLowerCase() === peg$c110) {
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e117); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f427();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_CYCLE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c111) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e118); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f428();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_NOCYCLE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c112) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e119); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f429();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_CACHE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c113) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e120); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f430();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_NOCACHE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c114) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e121); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f431();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_ORDER() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c115) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e122); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f432();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_NOORDER() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c116) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e123); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f433();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_ENCRYPT() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c117) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e124); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f434();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_IDENTIFIED() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 10);
    if (s1.toLowerCase() === peg$c118) {
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e125); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f435();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_CONSTRAINT() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 10);
    if (s1.toLowerCase() === peg$c119) {
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e126); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f436();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_UNIQUE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c120) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e127); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f437();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_PRIMARY() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c121) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e128); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f438();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_KEY() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 3);
    if (s1.toLowerCase() === peg$c122) {
      peg$currPos += 3;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e129); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f439();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_CHECK() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c123) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e130); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f440();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_REFERENCES() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 10);
    if (s1.toLowerCase() === peg$c124) {
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e131); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f441();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_CASCADE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c125) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e132); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f442();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_SET() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 3);
    if (s1.toLowerCase() === peg$c126) {
      peg$currPos += 3;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e133); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f443();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_REF() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 3);
    if (s1.toLowerCase() === peg$c127) {
      peg$currPos += 3;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e134); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f444();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_RELY() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c128) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e135); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f445();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_NORELY() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c129) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e136); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f446();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_DEFERRABLE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 10);
    if (s1.toLowerCase() === peg$c130) {
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e137); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f447();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_DEFERRED() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c131) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e138); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f448();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_INITIALLY() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 9);
    if (s1.toLowerCase() === peg$c132) {
      peg$currPos += 9;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e139); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f449();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_IMMEDIATE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 9);
    if (s1.toLowerCase() === peg$c133) {
      peg$currPos += 9;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e140); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f450();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_ENABLE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c134) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e141); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f451();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_DISABLE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c135) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e142); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f452();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_VALIDATE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c136) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e143); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f453();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_NOVALIDATE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 10);
    if (s1.toLowerCase() === peg$c137) {
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e144); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f454();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_EXCEPTIONS() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 10);
    if (s1.toLowerCase() === peg$c138) {
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e145); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f455();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_SCOPE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c139) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e146); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f456();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_FOREIGN() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c140) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e147); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f457();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_SEGMENT() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c141) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e148); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f458();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_CREATION() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c142) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e149); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f459();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_TABLESPACE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 10);
    if (s1.toLowerCase() === peg$c143) {
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e150); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f460();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_LOGGING() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c144) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e151); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f461();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_NOLOGGING() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 9);
    if (s1.toLowerCase() === peg$c145) {
      peg$currPos += 9;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e152); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f462();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_FILESYSTEM_LIKE_LOGGING() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 23);
    if (s1.toLowerCase() === peg$c146) {
      peg$currPos += 23;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e153); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f463();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_PCTFREE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c147) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e154); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f464();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_PCTUSED() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c148) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e155); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f465();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_INITRANS() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c149) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e156); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f466();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_STORAGE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c150) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e157); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f467();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_INITIAL() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c151) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e158); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f468();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_NEXT() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c152) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e159); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f469();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_MINEXTENTS() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 10);
    if (s1.toLowerCase() === peg$c153) {
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e160); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f470();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_MAXEXTENTS() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 10);
    if (s1.toLowerCase() === peg$c154) {
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e161); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f471();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_UNLIMITED() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 9);
    if (s1.toLowerCase() === peg$c155) {
      peg$currPos += 9;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e162); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f472();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_MAXSIZE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c156) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e163); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f473();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_KEEP() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c157) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e164); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f474();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_RECYCLE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c158) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e165); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f475();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_OPTIMAL() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c159) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e166); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f476();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_PCTINCREASE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 11);
    if (s1.toLowerCase() === peg$c160) {
      peg$currPos += 11;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e167); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f477();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_FREELISTS() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 9);
    if (s1.toLowerCase() === peg$c161) {
      peg$currPos += 9;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e168); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f478();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_FREELIST() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c162) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e169); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f479();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_GROUPS() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c163) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e170); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f480();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_BUFFER_POOL() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 11);
    if (s1.toLowerCase() === peg$c164) {
      peg$currPos += 11;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e171); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f481();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_FLASH_CACHE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 11);
    if (s1.toLowerCase() === peg$c165) {
      peg$currPos += 11;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e172); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f482();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_CELL_FLASH_CACHE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 16);
    if (s1.toLowerCase() === peg$c166) {
      peg$currPos += 16;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e173); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f483();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_COMPRESS() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c167) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e174); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f484();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_ROW() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 3);
    if (s1.toLowerCase() === peg$c168) {
      peg$currPos += 3;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e175); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f485();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_STORE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c169) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e176); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f486();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_BASIC() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c170) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e177); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f487();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_ADVANCED() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c171) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e178); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f488();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_COLUMN() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c172) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e179); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f489();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_QUERY() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c173) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e180); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f490();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_ARCHIVE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c174) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e181); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f491();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_LOW() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 3);
    if (s1.toLowerCase() === peg$c175) {
      peg$currPos += 3;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e182); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f492();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_HIGH() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c176) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e183); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f493();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_ROW_LEVEL_LOCKING() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 17);
    if (s1.toLowerCase() === peg$c177) {
      peg$currPos += 17;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e184); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f494();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_NOCOMPRESS() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 10);
    if (s1.toLowerCase() === peg$c178) {
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e185); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f495();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_LEVEL() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c179) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e186); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f496();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_LOCKING() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c180) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e187); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f497();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_INMEMORY() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c181) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e188); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f498();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_MEMCOMPRESS() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 11);
    if (s1.toLowerCase() === peg$c182) {
      peg$currPos += 11;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e189); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f499();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_DML() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 3);
    if (s1.toLowerCase() === peg$c183) {
      peg$currPos += 3;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e190); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f500();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_CAPACITY() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c184) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e191); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f501();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_AUTO() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c185) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e192); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f502();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_PRIORITY() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c186) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e193); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f503();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_MEDIUM() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c187) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e194); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f504();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_CRITICAL() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c188) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e195); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f505();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_DISTRIBUTE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 10);
    if (s1.toLowerCase() === peg$c189) {
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e196); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f506();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_RANGE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c190) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e197); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f507();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_PARTITION() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 9);
    if (s1.toLowerCase() === peg$c191) {
      peg$currPos += 9;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e198); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f508();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_SUBPARTITION() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 12);
    if (s1.toLowerCase() === peg$c192) {
      peg$currPos += 12;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e199); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f509();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_SERVICE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c193) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e200); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f510();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_ALL() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 3);
    if (s1.toLowerCase() === peg$c194) {
      peg$currPos += 3;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e201); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f511();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_DUPLICATE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 9);
    if (s1.toLowerCase() === peg$c195) {
      peg$currPos += 9;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e202); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f512();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_SPATIAL() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c196) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e203); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f513();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_ILM() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 3);
    if (s1.toLowerCase() === peg$c197) {
      peg$currPos += 3;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e204); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f514();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_ADD() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 3);
    if (s1.toLowerCase() === peg$c198) {
      peg$currPos += 3;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e205); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f515();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_POLICY() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c199) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e206); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f516();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_DISABLE_ALL() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 11);
    if (s1.toLowerCase() === peg$c200) {
      peg$currPos += 11;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e207); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f517();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_DELETE_ALL() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 10);
    if (s1.toLowerCase() === peg$c201) {
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e208); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f518();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_ENABLE_ALL() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 10);
    if (s1.toLowerCase() === peg$c202) {
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e209); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f519();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_GROUP() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c203) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e210); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f520();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_ACCESS() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c204) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e211); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f521();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_MODIFICATION() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 12);
    if (s1.toLowerCase() === peg$c205) {
      peg$currPos += 12;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e212); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f522();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_DAY() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 3);
    if (s1.toLowerCase() === peg$c35) {
      peg$currPos += 3;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e36); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f523();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_MONTH() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c34) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e35); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f524();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_MONTHS() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c206) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e213); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f525();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_YEAR() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c32) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e33); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f526();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_YEARS() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c207) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e214); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f527();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_TIER() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c208) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e215); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f528();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_ONLY() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c209) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e216); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f529();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_MODIFY() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c210) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e217); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f530();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_CLUSTER() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c211) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e218); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f531();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_INDEX() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c212) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e219); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f532();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_EXTERNAL() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c213) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e220); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f533();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_REJECT() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c214) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e221); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f534();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_ATTRIBUTES() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 10);
    if (s1.toLowerCase() === peg$c215) {
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e222); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f535();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_TYPE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c216) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e223); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f536();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_DIRECTORY() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 9);
    if (s1.toLowerCase() === peg$c217) {
      peg$currPos += 9;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e224); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f537();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_LOCATION() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c218) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e225); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f538();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_CLOB() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c20) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e21); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f539();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_HEAP() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c219) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e226); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f540();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_PARAMETERS() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 10);
    if (s1.toLowerCase() === peg$c220) {
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e227); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f541();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_ORGANIZATION() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 12);
    if (s1.toLowerCase() === peg$c221) {
      peg$currPos += 12;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e228); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f542();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_MAPPING() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c222) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e229); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f543();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_NOMAPPING() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 9);
    if (s1.toLowerCase() === peg$c223) {
      peg$currPos += 9;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e230); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f544();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_PCTTHRESHOLD() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 12);
    if (s1.toLowerCase() === peg$c224) {
      peg$currPos += 12;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e231); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f545();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_INCLUDING() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 9);
    if (s1.toLowerCase() === peg$c225) {
      peg$currPos += 9;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e232); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f546();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_OVERFLOW() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c226) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e233); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f547();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_PERIOD() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c227) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e234); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f548();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_SUPPLEMENTAL() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 12);
    if (s1.toLowerCase() === peg$c228) {
      peg$currPos += 12;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e235); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f549();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_LOG() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 3);
    if (s1.toLowerCase() === peg$c229) {
      peg$currPos += 3;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e236); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f550();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_COLUMNS() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c230) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e237); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f551();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_SUBSTITUTABLE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 13);
    if (s1.toLowerCase() === peg$c231) {
      peg$currPos += 13;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e238); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f552();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_ELEMENT() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c232) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e239); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f553();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_LEVELS() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c233) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e240); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f554();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_AT() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 2);
    if (s1.toLowerCase() === peg$c234) {
      peg$currPos += 2;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e241); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f555();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_NESTED() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c235) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e242); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f556();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_RETURN() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c236) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e243); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f557();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_LOCATOR() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c237) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e244); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f558();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_LOCAL() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c28) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e29); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f559();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_RETENTION() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 9);
    if (s1.toLowerCase() === peg$c238) {
      peg$currPos += 9;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e245); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f560();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_CHUNK() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c239) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e246); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f561();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_PCTVERSION() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 10);
    if (s1.toLowerCase() === peg$c240) {
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e247); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f562();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_FREEPOOLS() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 9);
    if (s1.toLowerCase() === peg$c241) {
      peg$currPos += 9;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e248); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f563();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_VARRAY() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c242) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e249); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f564();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_SECUREFILE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 10);
    if (s1.toLowerCase() === peg$c243) {
      peg$currPos += 10;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e250); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f565();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_BASICFILE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 9);
    if (s1.toLowerCase() === peg$c244) {
      peg$currPos += 9;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e251); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f566();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_LOB() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 3);
    if (s1.toLowerCase() === peg$c245) {
      peg$currPos += 3;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e252); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f567();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_IN() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 2);
    if (s1.toLowerCase() === peg$c246) {
      peg$currPos += 2;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e253); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f568();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_DECRYPT() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c247) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e254); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f569();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_READS() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c248) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e255); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f570();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_DEDUPLICATE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 11);
    if (s1.toLowerCase() === peg$c249) {
      peg$currPos += 11;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e256); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f571();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_KEEP_DUPLICATES() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 15);
    if (s1.toLowerCase() === peg$c250) {
      peg$currPos += 15;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e257); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f572();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_MAX() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 3);
    if (s1.toLowerCase() === peg$c251) {
      peg$currPos += 3;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e258); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f573();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_MIN() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 3);
    if (s1.toLowerCase() === peg$c252) {
      peg$currPos += 3;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e259); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f574();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_OFF() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 3);
    if (s1.toLowerCase() === peg$c253) {
      peg$currPos += 3;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e260); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f575();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_INDEXING() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c254) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e261); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f576();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_VARYING() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c255) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e262); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f577();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_VARCHAR() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c256) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e263); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f578();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_CHARACTER() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 9);
    if (s1.toLowerCase() === peg$c257) {
      peg$currPos += 9;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e264); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f579();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_CHAR() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c7) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e8); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f580();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_NCHAR() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c8) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e9); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f581();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_NATIONAL() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c258) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e265); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f582();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_INT() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 3);
    if (s1.toLowerCase() === peg$c259) {
      peg$currPos += 3;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e266); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f583();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_INTEGER() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c260) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e267); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f584();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_SMALLINT() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c261) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e268); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f585();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_FLOAT() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c13) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e14); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f586();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_REAL() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c262) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e269); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f587();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_NUMERIC() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c263) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e270); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f588();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_DECIMAL() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 7);
    if (s1.toLowerCase() === peg$c264) {
      peg$currPos += 7;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e271); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f589();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_DEC() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 3);
    if (s1.toLowerCase() === peg$c265) {
      peg$currPos += 3;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e272); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f590();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_DOUBLE() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 6);
    if (s1.toLowerCase() === peg$c266) {
      peg$currPos += 6;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e273); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f591();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_PRECISION() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 9);
    if (s1.toLowerCase() === peg$c267) {
      peg$currPos += 9;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e274); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f592();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_ROWID() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 5);
    if (s1.toLowerCase() === peg$c23) {
      peg$currPos += 5;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e24); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f593();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_VARCHAR2() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 8);
    if (s1.toLowerCase() === peg$c10) {
      peg$currPos += 8;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e11); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f594();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }

  function peg$parseKW_JSON() {
    var s0, s1, s2, s3;

    s0 = peg$currPos;
    s1 = input.substr(peg$currPos, 4);
    if (s1.toLowerCase() === peg$c268) {
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e275); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      peg$silentFails++;
      s3 = peg$parseident_start();
      peg$silentFails--;
      if (s3 === peg$FAILED) {
        s2 = undefined;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f595();
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    return s0;
  }


    const reservedKeywords = {
        ACCESS: true,
        ADD: true,
        ALL: true,
        ALTER: true,
        AND: true,
        ANY: true,
        AS: true,
        ASC: true,
        AUDIT: true,
        BETWEEN: true,
        BY: true,
        CHAR: true,
        CHECK: true,
        CLUSTER: true,
        COLUMN: true,
        COLUMN_VALUE: true,
        COMMENT: true,
        COMPRESSL: true,
        CONNECT: true,
        CREATE: true,
        CURRENT: true,
        DATE: true,
        DECIMAL: true,
        DEFAULT: true,
        DELETE: true,
        DESC: true,
        DISTINCT: true,
        DROP: true,
        ELSE: true,
        EXCLUSIVE: true,
        EXISTS: true,
        FILE: true,
        FLOAT: true,
        FOR: true,
        FROM: true,
        GRANT: true,
        GROUP: true,
        HAVING: true,
        IDENTIFIED: true,
        IMMEDIATE: true,
        IN: true,
        INCREMENT: true,
        INDEX: true,
        INITIAL: true,
        INSERT: true,
        INTEGER: true,
        INTERSECT: true,
        INTO: true,
        IS: true,
        LEVEL: true,
        LIKE: true,
        LOCK: true,
        LONG: true,
        MAXEXTENTS: true,
        MINUS: true,
        MLSLABEL: true,
        MODE: true,
        MODIFY: true,
        NESTED_TABLE_ID: true,
        NOAUDIT: true,
        NOCOMPRESS: true,
        NOT: true,
        NOWAIT: true,
        NULL: true,
        NUMBER: true,
        OF: true,
        OFFLINE: true,
        ON: true,
        ONLINE: true,
        OPTION: true,
        OR: true,
        ORDER: true,
        PCTFREE: true,
        PRIOR: true,
        PUBLIC: true,
        RAW: true,
        RENAME: true,
        RESOURCE: true,
        REVOKE: true,
        ROW: true,
        ROWID: true,
        ROWNUM: true,
        ROWS: true,
        SELECT: true,
        SESSION: true,
        SET: true,
        SHARE: true,
        SIZEL: true,
        SMALLINT: true,
        START: true,
        SUCCESSFUL: true,
        SYNONYM: true,
        SYSDATE: true,
        TABLE: true,
        THEN: true,
        TO: true,
        TRIGGER: true,
        UID: true,
        UNION: true,
        UNIQUE: true,
        UPDATE: true,
        USER: true,
        VALIDATE: true,
        VALUES: true,
        VARCHAR: true,
        VARCHAR2: true,
        VIEW: true,
        WHENEVER: true,
        WHERE: true,
        WITH: true,
    };

    const validEncryptionAlgos = {
        AES128: true, 
        AES192: true, 
        AES256: true, 
        ARIA256: true, 
        GOST256: true, 
        SEED128: true,
        '3DES168': true, 
    };

    const validIntegrityAlgos = {
        NOMAC: true,
        'SHA-1': true, 
    };

    const validAccessDrivers = {
        ORACLE_LOADER: true, 
        ORACLE_DATAPUMP: true,
        ORACLE_HDFS: true, 
        ORACLE_HIVE: true,
    };

  peg$result = peg$startRuleFunction();

  if (options.peg$library) {
    return /** @type {any} */ ({
      peg$result,
      peg$currPos,
      peg$FAILED,
      peg$maxFailExpected,
      peg$maxFailPos
    });
  }
  if (peg$result !== peg$FAILED && peg$currPos === input.length) {
    return peg$result;
  } else {
    if (peg$result !== peg$FAILED && peg$currPos < input.length) {
      peg$fail(peg$endExpectation());
    }

    throw peg$buildStructuredError(
      peg$maxFailExpected,
      peg$maxFailPos < input.length ? input.charAt(peg$maxFailPos) : null,
      peg$maxFailPos < input.length
        ? peg$computeLocation(peg$maxFailPos, peg$maxFailPos + 1)
        : peg$computeLocation(peg$maxFailPos, peg$maxFailPos)
    );
  }
}

module.exports = {
  StartRules: ["start"],
  SyntaxError: peg$SyntaxError,
  parse: peg$parse
};
